<?php

namespace FoodSearchPages;

class adminpages {

    public function __construct() {
        // Adding columns
        add_action('admin_menu', [$this, 'register_menu_item'], 12);
        add_action('wp_ajax_nopriv_add_menu_item', array($this, 'add_menu_item'));
        add_action('wp_ajax_add_menu_item', array($this, 'add_menu_item'));
        add_action('wp_ajax_nopriv_add_choice_group', array($this, 'add_choice_group'));
        add_action('wp_ajax_add_choice_group', array($this, 'add_choice_group'));
        add_action('wp_ajax_call_ajaxMenuItemListByMenuID', [$this, 'ajaxMenuItemListByMenuID']);
        add_action('wp_ajax_call_ajaxChoiceGroupsByID', [$this, 'ajaxChoiceGroupsByID']);
        add_action('wp_ajax_nopriv_menudetailhtmlbyid', array($this, 'menudetailhtmlbyid'));
        add_action('wp_ajax_menudetailhtmlbyid', array($this, 'menudetailhtmlbyid'));
        add_action('wp_ajax_nopriv_menusaddForm', array($this, 'menusaddForm'));
        add_action('wp_ajax_menusaddForm', array($this, 'menusaddForm'));
        add_action('wp_ajax_nopriv_menusItemaddForm', array($this, 'menusItemaddForm'));
        add_action('wp_ajax_menusItemaddForm', array($this, 'menusItemaddForm'));
        add_action('wp_ajax_nopriv_menuItemUpdate', array($this, 'menuItemUpdate'));
        add_action('wp_ajax_menuItemUpdate', array($this, 'menuItemUpdate'));
        add_action('wp_ajax_nopriv_menuItemdetailhtmlbyid', array($this, 'menuItemDetailhtmlbyid'));
        add_action('wp_ajax_menuItemdetailhtmlbyid', array($this, 'menuItemDetailhtmlbyid'));
        add_action('wp_ajax_nopriv_choiceGroupaddForm', array($this, 'choiceGroupaddForm'));
        add_action('wp_ajax_choiceGroupaddForm', array($this, 'choiceGroupaddForm'));
        add_action('wp_ajax_nopriv_choiceGroupdetailhtmlbyid', array($this, 'choiceGroupdetailhtmlbyid'));
        add_action('wp_ajax_choiceGroupdetailhtmlbyid', array($this, 'choiceGroupdetailhtmlbyid'));
        add_action('wp_ajax_nopriv_update-menu-item-order', array($this, 'updateMenuItemOrder'));
        add_action('wp_ajax_update-menu-item-order', array($this, 'updateMenuItemOrder'));
        
        add_action('admin_head', function() {
            ?>
            <style>
                #toplevel_page_foodsearch-plugin-settings li.wp-first-item {display: none;}
                #wpadminbar #wp-admin-bar-fds-foodsearch-plugin .ab-icon:before {top: 2px;}
            </style>
            <?php
        }, 99);
        
        add_action('rest_api_init', [$this, 'register_api'], 5);
    }
    
    public function register_api() {

        register_rest_route('wp/v1', 'menu-item-list-bymid', array(
            'methods' => 'POST',
            'callback' => [$this, 'ajaxMenuItemListByMenuID'],
           'permission_callback' =>  'admin_permissions_check',
        ));
        register_rest_route('wp/v1', 'food-menu-itemedit-byid', array(
            'methods' => 'POST',
            'callback' => [$this, 'menudetailhtmlbyid'],
           'permission_callback' =>  'admin_permissions_check',
        ));
        register_rest_route('wp/v1', 'food-choice-groups-bymid', array(
            'methods' => 'POST',
            'callback' => [$this, 'ajaxChoiceGroupsByID'],
           'permission_callback' =>  'admin_permissions_check',
        ));
        register_rest_route('wp/v1', 'food-menuitm-detail-bymid', array(
            'methods' => 'POST',
            'callback' => [$this, 'menuItemDetailhtmlbyid'],
           'permission_callback' =>  'admin_permissions_check',
        ));
        register_rest_route('wp/v1', 'food-choicegroup-detail-bymid', array(
            'methods' => 'POST',
            'callback' => [$this, 'choiceGroupdetailhtmlbyid'],
           'permission_callback' =>  'admin_permissions_check',
        ));
        register_rest_route('wp/v1', 'food-choicegroup-add-form', array(
            'methods' => 'POST',
            'callback' => [$this, 'choiceGroupaddForm'],
           'permission_callback' =>  'admin_permissions_check',
        ));
        register_rest_route('wp/v1', 'food-menus-add-form', array(
            'methods' => 'POST',
            'callback' => [$this, 'menusaddForm'],
           'permission_callback' =>  'admin_permissions_check',
        ));
        register_rest_route('wp/v1', 'food-menuitm-add-form', array(
            'methods' => 'POST',
            'callback' => [$this, 'menusItemaddForm'],
           'permission_callback' =>  'admin_permissions_check',
        ));
    }
    public function updateMenuItemOrder() {
        echo "<pre>" . print_r($_REQUEST, true) . "</pre><br>";
        exit();
    }

    public function screen_options_choices() {
        $args = array(
            'label' => esc_html__('number of items per page:', 'wp-foodsearch'),
            'default' => 30,
            'option' => 'choices_per_page'
        );
        add_screen_option('per_page', $args);
    }

    public function register_menu_item() {
        add_submenu_page('foodsearch-plugin-settings', esc_html__('Food menus', 'wp-foodsearch'), esc_html__('Food menus', 'wp-foodsearch'), 'manage_options', 'menus', [$this, 'menu_page']);
        add_submenu_page('foodsearch-plugin-settings', esc_html__('Food items', 'wp-foodsearch'), esc_html__('Food items', 'wp-foodsearch'), 'manage_options', 'menu-item', [$this, 'menu_items_list']);
        add_submenu_page('foodsearch-plugin-settings', esc_html__('Food item categories', 'wp-foodsearch'), esc_html__('Food item categories', 'wp-foodsearch'), 'manage_options', 'edit-tags.php?taxonomy=food_item_cat&post_type=restaurants');
        $hook = add_submenu_page('foodsearch-plugin-settings', esc_html__('Choice groups', 'wp-foodsearch'), esc_html__('Choice groups', 'wp-foodsearch'), 'manage_options', 'menu-choice-group', [$this, 'menu_choicegroup']);
        add_action("load-$hook", [$this, 'screen_options_choices'], 31);
        
        add_submenu_page('foodsearch-plugin-settings', esc_html__('Orders', 'wp-foodsearch'), esc_html__('Orders', 'wp-foodsearch'), 'manage_options', 'fds_orders', [$this, 'orders_page']);

        add_action('parent_file', function (string $parent_file): string {
            global $current_screen;

            if ($current_screen->taxonomy === 'food_item_cat') {
                return 'foodsearch-plugin-settings';
            }

            return $parent_file;
        });
    }

    public function menu_page() {
        global $foodsearch_form_fields;
        require plugin_dir_path(__FILE__) . 'pages/menu-list.php';
    }

    public function menu_items_list() {
        global $foodsearch_form_fields;
        require plugin_dir_path(__FILE__) . 'pages/menu-item-list.php';
    }

    public function menu_choicegroup() {
        global $foodsearch_form_fields;
        require plugin_dir_path(__FILE__) . 'pages/menu-item-choice-group.php';
    }

    public function orders_page() {
        global $foodsearch_form_fields;
        require plugin_dir_path(__FILE__) . 'pages/orders-list.php';
    }

    public function menusaddForm() {

        global $foodsearch_form_fields;
        require plugin_dir_path(__FILE__) . 'forms/add-menus.php';
    }

    public function menudetailhtmlbyid() {
        global $table_prefix, $wpdb, $foodsearch_form_fields;
        $table_name = $table_prefix . 'menus';
        $id = $_REQUEST['id'];
        $sql = "SELECT * FROM $table_name where id =" . $id;
        $result = $wpdb->get_row($sql);
        $content = '';
        if (!empty($result)) {
            $args = array(
                'type' => 'hidden',
                'id' => 'id',
                'name' => 'id',
                'classes' => '',
                'label' => '',
                'value' => $result->id,
                'return' => true,
            );
            $content .= $foodsearch_form_fields->input_field($args);
            $content .= '<div class="filed-group fds-form-field">';
            $values = SELF::restaurantListincId($result->restaurant_id);
            $args = array(
                'type' => 'single',
                'id' => 'restaurant_id',
                'name' => 'restaurant_id',
                'classes' => 'select_menu post-filed restaurant-dropdown',
                'label' => esc_html__('select restaurant', 'wp-foodsearch'),
                'placeholder' => '',
                'required' => 'true',
                'value' => $values,
                'selected' => $result->restaurant_id,
                'return' => true,
            );
            $content .= $foodsearch_form_fields->select_field($args);

            $content .= ' </div><div class="filed-group fds-form-field">';

            $args = array(
                'type' => 'text',
                'id' => 'title',
                'name' => 'title',
                'classes' => 'post-filed fds-input-style',
                'label' => esc_html__('title', 'wp-foodsearch'),
                'placeholder' => esc_html__('title', 'wp-foodsearch'),
                'required' => 'true',
                'value' => $result->name,
                'return' => true
            );
            $content .= $foodsearch_form_fields->input_field($args);
            $content .= ' </div><div class="filed-group fds-form-field">';

            $values = array(
                'monday' => esc_html__('monday', 'wp-foodsearch'),
                'tuesday' => esc_html__('tuesday', 'wp-foodsearch'),
                'wednesday' => esc_html__('wednesday', 'wp-foodsearch'),
                'thursday' => esc_html__('thursday', 'wp-foodsearch'),
                'friday' => esc_html__('friday', 'wp-foodsearch'),
                'saturday' => esc_html__('saturday', 'wp-foodsearch'),
                'sunday' => esc_html__('sunday', 'wp-foodsearch'),
            );
            $args = array(
                'id' => 'menu_opening_days',
                'name' => 'menu_opening_days[]',
                'classes' => 'post-filed select_dropdown',
                'label' => esc_html__('menu opening days', 'wp-foodsearch'),
                'placeholder' => esc_html__('select menu opening days', 'wp-foodsearch'),
                'required' => 'true',
                'value' => $values,
                'selected' => !empty($result->menu_opening_days) ? json_decode($result->menu_opening_days, true) : '',
                'type' => 'multiple',
                'return' => true
            );
            $content .= $foodsearch_form_fields->select_field($args);
            $content .= '</div><div class="filed-group fds-form-field">';

            $values = array();
            for ($i = 0; $i < 24; $i++) {
                for ($x = 0; $x <= 3; $x++) {
                    $values[$i . ':' . (($x * 15) == 0 ? '00' : ($x * 15))] = $i . ':' . (($x * 15) == 0 ? '00' : ($x * 15));
                }
            }
            $args = array(
                'id' => 'menu_start_time',
                'name' => 'menu_start_time',
                'classes' => 'post-filed select_dropdown',
                'label' => esc_html__('menu start time', 'wp-foodsearch'),
                'placeholder' => esc_html__('select menu starting time', 'wp-foodsearch'),
                'required' => 'true',
                'value' => $values,
                'selected' => $result->menu_start_time,
                'return' => true
            );
            $content .= $foodsearch_form_fields->select_field($args);
            $content .= ' </div><div class="filed-group fds-form-field">';
            $args = array(
                'id' => 'menu_end_time',
                'name' => 'menu_end_time',
                'classes' => 'post-filed select_dropdown',
                'label' => esc_html__('menu closing time', 'wp-foodsearch'),
                'placeholder' => esc_html__('select menu closing time', 'wp-foodsearch'),
                'required' => 'true',
                'value' => $values,
                'selected' => $result->menu_end_time,
                'return' => true
            );
            $content .= $foodsearch_form_fields->select_field($args);
            $content .= ' </div><div class="filed-group fds-form-field">';

            $args = array(
                'id' => 'details',
                'name' => 'details',
                'classes' => 'post-filed fds-textarea-style',
                'label' => esc_html__('menu details', 'wp-foodsearch'),
                'placeholder' => esc_html__('menu details', 'wp-foodsearch'),
                'required' => 'true',
                'value' => $result->details,
                'return' => true
            );
            $content .= $foodsearch_form_fields->textarea_field($args);
            $content .= ' </div><div class="filed-group fds-form-field">';
            $values = array(
                '1' => esc_html__('pending', 'wp-foodsearch'),
                '2' => esc_html__('approve', 'wp-foodsearch'),
                '4' => esc_html__('reject', 'wp-foodsearch'),
            );
            $args = array(
                'type' => 'single',
                'id' => 'status',
                'name' => 'status',
                'classes' => 'select_menu post-filed select_dropdown',
                'label' => esc_html__('select status', 'wp-foodsearch'),
                'value' => $values,
                'selected' => $result->status,
                'required' => 'true',
                'return' => true
            );
            $content .= $foodsearch_form_fields->select_field($args);

            $content .= ' </div><div class="filed-group">';
            ob_start();
            wp_nonce_field('updating_menu', 'menu_save_nonce');
            $content .= ob_get_clean();
            
            $content .= '<div class="fds-btn fds-medium-btn">';
            $args = array(
                'type' => 'button',
                'id' => 'menuUpdateBtn',
                'name' => 'save_menu',
                'classes' => 'submit_btn fds-has-bg',
                'value' => esc_html__('update', 'wp-foodsearch'),
                'return' => true
            );
            $content .= $foodsearch_form_fields->button($args);
            $content .= '  </div>';
            $content .= '  </div>';
        }
        $responsedata = array('status' => 'success', 'html' => $content);
        wp_send_json($responsedata);
        wp_die();
    }

    public function menusItemaddForm() {

        global $foodsearch_form_fields;
        require plugin_dir_path(__FILE__) . 'forms/add-menu-items.php';
    }

    public function menuItemDetailhtmlbyid() {

        global $foodsearch_form_fields;
        require plugin_dir_path(__FILE__) . 'forms/update-menu-items.php';
    }

    public function choiceGroupaddForm() {

        global $foodsearch_form_fields;
        require plugin_dir_path(__FILE__) . 'forms/add-choice-group.php';
    }

    public function choiceGroupdetailhtmlbyid() {

        global $foodsearch_form_fields;
        require plugin_dir_path(__FILE__) . 'forms/update-choice-group.php';
    }

    public function menuListIncId($id) {
        global $table_prefix, $wpdb;
        $table_name = $table_prefix . 'menus';
        $sql = "SELECT * FROM $table_name where id =" . $id;
        $result = $wpdb->get_row($sql);
        $sql = "SELECT * FROM $table_name where id NOT IN (" . $id . ") ORDER BY RAND() limit 99";
        $results = $wpdb->get_results($sql);
        $p = array();

        if (!empty($result)) {
            $p[$result->id] = $result->name;
        }
        if (!empty($results)) {
            foreach ($results as $post) {
                $p[$post->id] = $post->name;
            }
        }
        return $p;
    }

    public function menuItemListIncId($id) {
        global $table_prefix, $wpdb;
        $table_name = $table_prefix . 'menu_items';
        $sql = "SELECT * FROM $table_name where id =" . $id;
        $result = $wpdb->get_row($sql);
        $sql = "SELECT * FROM $table_name where id NOT IN (" . $id . ") ORDER BY RAND() limit 99";
        $results = $wpdb->get_results($sql);
        $p = array();

        if (!empty($result)) {
            $p[$result->id] = $result->name;
        }
        if (!empty($results)) {
            foreach ($results as $post) {
                $p[$post->id] = $post->name;
            }
        }
        return $p;
    }

    public function menuChoiceGroupIncId($id) {
        global $table_prefix, $wpdb;
        $table_name = $table_prefix . 'menu_choice_group';

        $result = $results = '';
        if ($id != '') {
            $sql = "SELECT * FROM $table_name where id IN(" . $id . ")";
            $result = $wpdb->get_results($sql);
            $where = '';
            if (!empty($id)) {
                $where = "where id NOT IN (" . $id . ")";
            }
            $sql = "SELECT * FROM $table_name $where ORDER BY RAND() limit 99";
            $results = $wpdb->get_results($sql);
        }
        $p = array();

        if (!empty($result)) {
            foreach ($result as $post) {
                $p[$post->id] = $post->name;
            }
        }
        if (!empty($results)) {
            foreach ($results as $post) {
                $p[$post->id] = $post->name;
            }
        }
        return $p;
    }

    public function menuCategoryIncId($id) {
        $args = array(
            'taxonomy' => 'food_item_cat',
            'hide_empty' => false,
            'include' => $id
        );
        $myterms = get_terms($args);
        $args = array(
            'taxonomy' => 'food_item_cat',
            'hide_empty' => false,
            'number' => 99
        );
        $terms = get_terms($args);
        $p = array();
        if (!empty($myterms)) {
            foreach ($myterms as $post) {
                $p[$post->term_id] = $post->name;
            }
        }
        if (!empty($terms)) {
            foreach ($terms as $post) {
                if (!in_array($post->name, $p)) {
                    $p[$post->term_id] = $post->name;
                }
            }
        }
        return $p;
    }

    public function restaurantListincId($id) {
        $args = array(
            'post_type' => 'restaurants',
            'post__in' => [$id]
        );
        $p = array();
        $pt = get_posts($args);
        foreach ($pt as $post) {
            $p[$post->ID] = $post->post_title;
        }
        $args = array(
            'post_type' => 'restaurants',
            'posts_per_page' => 99
        );
        $posts = get_posts($args);
        foreach ($posts as $post) {
            $p[$post->ID] = $post->post_title;
        }
        return $p;
    }

    public function get_field($field_name, $tbl_name, $where) {
        global $table_prefix, $wpdb;
        $result = $wpdb->get_var("SELECT $field_name FROM $table_prefix$tbl_name where $where");
        return $result;
    }

    public function ajaxChoiceGroupsByID($id) {
        $where = '';
        $in = 0;
        if (isset($_POST['id'])) {
            $where = ' where id =' . $_POST['id'];
        }
        global $table_prefix, $wpdb;
        $table_name = $table_prefix . 'menu_items';
        $results = $wpdb->get_row("SELECT choice_groups_id FROM $table_name$where");

        if ($results->choice_groups_id) {
            $in = $results->choice_groups_id;
        }
        $where = ' where id in (' . $in . ')';
        $table_name = $table_prefix . 'menu_choice_group';
        $results = $wpdb->get_results("SELECT * FROM $table_name$where");

        $content = '<td colspan="8">';
        $content .= '<table>';
        $content .= '<tr>';
        $content .= '<th>' . esc_html__("name", "wp-foodsearch") . '</th>';
        $content .= '<th>' . esc_html__("minimum", "wp-foodsearch") . '</th>';
        $content .= '<th>' . esc_html__("maximum", "wp-foodsearch") . '</th>';
        $content .= '<th>' . esc_html__("choice items", "wp-foodsearch") . '</th>';
        $content .= '</tr>';
        foreach ($results as $row) {
            $content .= '<tr>';
            $content .= '<td>' . $row->name . '</td>';
            $content .= '<td>' . $row->min . '</td>';
            $content .= '<td>' . $row->max . '</td>';
            $content .= '<td>';
            $results2 = json_decode($row->menuItem_id);

            foreach ($results2 as $item) {
                $content .= "(Item = " . $this->get_field("name", "menu_items", " id = " . $item->item_id);
                $content .= ") (Price = " . $item->item_price;
                $content .= ")<br />";
            }
            $content .= '</td>';
            $content .= '</tr>';
        }
        $content .= '</table>';
        $content .= ' </td>';

        $responsedata = array('status' => 'success', 'html' => $content);
        wp_send_json($responsedata);
        wp_die();
    }

    public function ajaxMenuItemListByMenuID() {
        
        $where = '';
        if (isset($_POST['id'])) {
            $where = ' where menu_id =' . $_POST['id'];
        }
        global $table_prefix, $wpdb;
        $table_name = $table_prefix . 'menu_items';
        $results = $wpdb->get_results("SELECT * FROM $table_name$where");

        $content = '<td colspan="8">';
        $content .= '<form method="post" id="menuItemsForm"><table =><tbody id="sortable">';
        $content .= '<tr>';
        $content .= '<th>' . esc_html__("name", "wp-foodsearch") . '</th>';
        $content .= '<th>' . esc_html__("price", "wp-foodsearch") . '</th>';
        $content .= '<th>' . esc_html__("discount price", "wp-foodsearch") . '</th>';
        $content .= '<th>' . esc_html__("category", "wp-foodsearch") . '</th>';
        $content .= '<th>' . esc_html__("variations", "wp-foodsearch") . '</th>';
        $content .= '<th>' . esc_html__("action", "wp-foodsearch") . '</th>';
        $content .= '</tr>';

        foreach ($results as $row) {
            $content .= '<tr>';
            $content .= '<td><input type="hidden" name="menu_items[]" value="' . $row->id . '"> ' . $row->name . '</td>';
            $content .= '<td>' . $row->price . '</td>';
            $content .= '<td>' . $row->discount_price . '</td>';
            $content .= '<td>';
            if (!empty($row->category_id)) {
                $cats = explode(",", $row->category_id);
                foreach ($cats as $cat_id) {
                    $term = get_term_by('id', $cat_id, 'food_item_cat');
                    if (isset($term->name)) {
                        $content .= $term->name . "<br/>";
                    }
                }
            }
            $content .= '</td>';
            $content .= '<td>';
            $results2 = json_decode($row->variations);

            foreach ($results2 as $item) {
                $content .= "(Name = " . $item->variation_name . ")";
                $content .= " (Price = " . $item->variation_price . ")";
                $content .= "<br />";
            }
            $content .= '</td>';
            $content .= '<td><a class="fds-link choice-groups" id = "' . $row->id . '" href="#" data-id="' . $row->id . '">' . esc_html__('choice group', 'wp-foodsearch') . '</a></td>';

            $content .= ' </tr>';
            $content .= '<tr style = "display:none" class="choice-groups-area' . $row->id . '">';
            $content .= ' </tr>';
        }

        $content .= '</tbody></table></form> ';
        $content .= '</td>';

        $responsedata = array('status' => 'success', 'html' => $content);
        wp_send_json($responsedata);
        wp_die();
    }

    public function menuCategoriesList() {
        global $table_prefix, $wpdb;
        $paged = $paged = isset($_GET['paged']) ? $_GET['paged'] : 1;
        $rows_per_page = 30;
        $offset = ($paged * $rows_per_page) - $rows_per_page;
        $table_name = $table_prefix . 'menu_category';
        $resultCount = $wpdb->get_results("SELECT count(id) as totalItems FROM $table_name");
        $results = $wpdb->get_results("SELECT * FROM $table_name order by id desc limit $rows_per_page offset $offset");

        $pagination_args = array(
            'base' => add_query_arg('paged', '='),
            'total' => ceil($resultCount[0]->totalItems / $rows_per_page),
            'total_result' => $resultCount[0]->totalItems,
            'current' => $paged,
            'rows_per_page' => $rows_per_page,
            'show_all' => false,
            'type' => 'plain',
        );
        $content = 'Please add categories first !';
        if (!empty($results)) { // Checking if $results have some values or not
            $i = $offset + 1;
            $content = '';
            foreach ($results as $row) {
                $content .= '<tr>';
                $image = '';
                if ($row->attachment_id != '') {
                    $imageURL = wp_get_attachment_url($row->attachment_id);
                    $image = '<img src="' . $imageURL . '" class="menu-attachment-image">';
                }
                $content .= '<td>' . ($i + (($paged - 1) * $rows_per_page)) . '</td>';
                $content .= '<td>' . $image . '</td>';
                $content .= '<td>' . $row->name . '</td>';
                $content .= '<td>' . $row->slug . '</td>';
                $content .= '<td>' . ((isset($row->parent_id) && $row->parent_id != '') ? implode(', ', SELF::cat_parent_name($row->parent_id)) : '') . '</td>';
                $content .= '<td>' . $row->details . '</td>';
                $content .= '<td><a href="#" class="fds-link" data-id="' . $row->id . '">' . esc_html__('edit', 'wp-foodsearch') . '</a></td>';
                $content .= ' </tr>';
                $i++;
            }
            $pagination = SELF::pagenation($pagination_args);
        }
        return array('content' => $content, 'pagenation' => $pagination);
    }

    public function menuList() {
        global $table_prefix, $wpdb;
        $paged = $paged = isset($_GET['paged']) ? $_GET['paged'] : 1;
        $rows_per_page = 30;
        $offset = ($paged * $rows_per_page) - $rows_per_page;
        $table_name = $table_prefix . 'menus';
        $resultCount = $wpdb->get_results("SELECT count(id) as totalItems FROM $table_name");
        $results = $wpdb->get_results("SELECT * FROM $table_name limit $rows_per_page offset $offset");
        $content = esc_html__('please add menu first !', 'wp-foodsearch');
        $pagination = '';
        if (!empty($results)) { // Checking if $results have some values or not
            $i = $offset + 1;
            $pagination_args = array(
                'base' => add_query_arg('paged', '='),
                'total' => ceil($resultCount[0]->totalItems / $rows_per_page),
                'total_result' => $resultCount[0]->totalItems,
                'current' => $paged,
                'rows_per_page' => $rows_per_page,
                'show_all' => false,
                'type' => 'plain',
            );
            $content = '';
            foreach ($results as $row) {
                $content .= '<tr>';
                $content .= '<td>' . ($i + (($paged - 1) * $rows_per_page)) . '</td>';
                $content .= '<td>' . $row->name . '</td>';
                $content .= '<td>' . $row->slug . '</td>';
                $content .= '<td>' . strtoupper(implode(', ', json_decode($row->menu_opening_days, true))) . '</td>';
                $content .= '<td>' . $row->menu_start_time . '</td>';
                $content .= '<td>' . $row->menu_end_time . '</td>';
                $content .= '<td>' . $row->restaurant_id . '</td>';
                $content .= '<td>' . $row->details . '</td>';
                $content .= '<td><a href="#" class="fds-link" data-id="' . $row->id . '">' . esc_html__('edit', 'wp-foodsearch') . '</a></td>';
                $content .= ' </tr>';
                $i++;
            }
            $pagination = SELF::pagenation($pagination_args);
        }

        return array('content' => $content, 'pagenation' => $pagination);
    }

    public function menus_dropdown() {
        global $table_prefix, $wpdb;
        $table_name = $table_prefix . 'menus';
        $results = $wpdb->get_results("SELECT * FROM $table_name");
        $content = 'Please add Menu first !';
        if (!empty($results)) {  // Checking if $results have some values or not
            $content .= '<option value="">' . esc_html__("select menu", "wp-foodsearch") . '</option>';

            foreach ($results as $row) {
                $content .= '<option value="' . $row->id . '">' . $row->name . '</option>';
            }
        }
        return $content;
    }

    public function menuItemList() {
        global $table_prefix, $wpdb;
        $paged = $paged = isset($_GET['paged']) ? $_GET['paged'] : 1;
        $rows_per_page = 30;
        $offset = ($paged * $rows_per_page) - $rows_per_page;
        $table_name = $table_prefix . 'menu_items';
        $tablemenu = $table_prefix . 'menus';
        $resultCount = $wpdb->get_results("SELECT count(id) as totalItems FROM $table_name");
        $results = $wpdb->get_results("SELECT mi.*,m.name as menuname FROM $table_name as mi left join $tablemenu as m on m.id=mi.menu_id  limit $rows_per_page offset $offset"); // Query to fetch data from database table and storing in $results
        $content = 'Please add Menu Item first !';
        if (!empty($results)) { // Checking if $results have some values or not
            $i = $offset + 1;
            $pagination_args = array(
                'base' => add_query_arg('paged', '='),
                'total' => ceil($resultCount[0]->totalItems / $rows_per_page),
                'total_result' => $resultCount[0]->totalItems,
                'current' => $paged,
                'rows_per_page' => $rows_per_page,
                'show_all' => false,
                'type' => 'plain',
            );
            $content = array();
            foreach ($results as $key => $row) {
                $content[$key]['attachment_url'] = '';


                $content[$key]['id'] = $row->id;
                $content[$key]['name'] = $row->name;
                $content[$key]['price'] = $row->price;
                $content[$key]['discount_price'] = $row->discount_price;
                $content[$key]['offer_status'] = $row->offer_status;
                $content[$key]['details'] = $row->details;
                if ($row->attachment_id != '') {
                    $content[$key]['attachment_url'] = wp_get_attachment_url($row->attachment_id);
                }
            }
            $pagination = SELF::pagenation($pagination_args);
        }

        return array('content' => $content, 'pagenation' => $pagination);
    }

    public function menu_list($cat = 'extra') {
        global $table_prefix, $wpdb;
        $menuTable = $table_prefix . 'menu_items';
        $categoryTable = $table_prefix . 'menu_category';
        $sql = "SELECT * FROM $menuTable as mt left JOIN $categoryTable as ct on mt.category=ct.id where ct.name='" . $cat . "'";
        $results = $wpdb->get_results($sql); // Query to fetch data from database table and storing in $results
        $content = '';
        if (!empty($results)) { // Checking if $results have some values or not
            $content = '<select class="select_menu post-filed select-dropdown" data-placeholder="' . esc_html__('select menu item', 'wp-foodsearch') . '" name="extra_product">';
            $content .= '<option value="">' . esc_html__('select menu item', 'wp-foodsearch') . '</option>';
            foreach ($results as $row) {
                $content .= '<option value="' . $row->id . '">' . $row->name . '</option>';
            }
            $content .= '</select>';
        }
        return $content;
    }

    public function ChoiceGroupList() {
        global $table_prefix, $wpdb;
        $paged = $paged = isset($_GET['paged']) ? $_GET['paged'] : 1;
        $rows_per_page = 10;
        $offset = ($paged * $rows_per_page) - $rows_per_page;
        $table_name = $table_prefix . 'menu_choice_group';
        $resultCount = $wpdb->get_results("SELECT count(id) as totalItems FROM $table_name");
        $results = $wpdb->get_results("SELECT * FROM $table_name  order by id desc limit $rows_per_page offset $offset"); // Query to fetch data from database
        // table and storing in $results
        $i = $offset + 1;
        $pagination_args = array(
            'base' => add_query_arg('paged', '='),
            'total' => ceil($resultCount[0]->totalItems / $rows_per_page),
            'total_result' => $resultCount[0]->totalItems,
            'current' => $paged,
            'rows_per_page' => $rows_per_page,
            'show_all' => false,
            'type' => 'plain',
        );
        $content = '';
        if (!empty($results)) { // Checking if $results have some values or not
            foreach ($results as $row) {
                $content .= "<tr>";
                $content .= "<td scope='row'>" . $row->id . "</td>";
                $content .= "<td>" . $row->name . "</td>";
                $content .= "<td>" . $row->min . "</td>";
                $content .= "<td>" . $row->max . "</td>";
                $content .= "<td></td>";
                $content .= "</tr>";
            }
        } else {
            $content .= '<tr><th scope="row" colspan="4">' . esc_html__('no data found', 'wp-foodsearch') . '</th></tr>';
        }
        $pagination = SELF::pagenation($pagination_args);
        return array('content' => $content, 'pagenation' => $pagination);
    }

    private function cat_parent_name($id) {
        global $table_prefix, $wpdb;
        $content = array();
        $table_name = $table_prefix . 'menu_category';
        $results = $wpdb->get_results("SELECT name FROM $table_name where id in ($id)"); // Query to fetch data from
        if (!empty($results)) { // Checking if $results have some values or not
            foreach ($results as $item) {
                $content[] = $item->name;
            }
        }
        
        return $content;
    }

    public function pagenation($args) {
        return '<div class="pagination">' . paginate_links(array(
                    'base' => str_replace(999999999, '%#%', esc_url(get_pagenum_link(999999999))),
                    'total' => $args['total_result'] / $args['rows_per_page'],
                    'current' => $args['current'],
                    'format' => '?paged=%#%',
                    'show_all' => false,
                    'type' => 'plain',
                    'end_size' => 6,
                    'mid_size' => 1,
                    'prev_next' => true,
                    'prev_text' => sprintf('<i></i> %1$s', esc_html__('newer posts', 'wp-foodsearch')),
                    'next_text' => sprintf('%1$s <i></i>', esc_html__('older posts', 'wp-foodsearch')),
                    'add_args' => false,
                    'add_fragment' => '',
                    'type' => 'list'
                )) . '</div>';
    }

    public function foodsearch_menuItemNameByID($id) {
        global $wpdb, $table_prefix;
        $table_name = $table_prefix . 'menu_items';
        $results = $wpdb->get_results("SELECT name FROM $table_name where id=" . $id);
        return $results[0]->name;
    }
   

}

new adminpages();
