<?php

namespace FoodSearch\Dashboard_Settings;
use FoodSearch\Dashboard_Settings\Common_Functions as Common_Functions;

class Customer_Builder {

    protected static $_instance = null;

    public static function instance() {
        if (is_null(self::$_instance)) {
            self::$_instance = new self();
        }
        return self::$_instance;
    }

    public function __construct() {
        add_filter('foodsearch_bk_dashboard_customer_builder_setins', array($this, 'builder_container'));
    }
    
    public function builder_container() {
         $common_functions = new Common_Functions;
        
        ob_start();
        $common_functions->dashboard_builder('customer');
        $html = ob_get_clean();
        
        return $html;
    }
    
    public function dashboard_menu_elements_list() {
        $elements = array(
            'account_settings' => array(
                'label' => esc_html__('account settings', 'wp-foodsearch'),
                'custom_fields' => true,
                'fields' => array(
                    'first_name' => array(
                        'sort' => 0,
                        'label' => esc_html__('first name', 'wp-foodsearch')
                    ),
                    'last_name' => array(
                        'sort' => 0,
                        'label' => esc_html__('last name', 'wp-foodsearch')
                    ),
                    'email_address' => array(
                        'sort' => 0,
                        'label' => esc_html__('email address', 'wp-foodsearch')
                    ),
                    'contact_number' => array(
                        'sort' => 0,
                        'label' => esc_html__('contact number', 'wp-foodsearch')
                    ),
                ),
            ),
            'profile_image' => array(
                'label' => esc_html__('profile picture', 'wp-foodsearch'),
            ),
            'loc_address' => array(
                'label' => esc_html__('address', 'wp-foodsearch'),
            ),
            'change_password' => array(
                'label' => esc_html__('change password', 'wp-foodsearch'),
            ),
            'favourite_restaurants' => array(
                'label' => esc_html__('favourite restaurants', 'wp-foodsearch'),
            ),
            'reviews' => array(
                'label' => esc_html__('my reviews', 'wp-foodsearch'),
            ),
            'orders' => array(
                'label' => esc_html__('my orders', 'wp-foodsearch'),
            ),
            'acc_switcher' => array(
                'label' => esc_html__('account switcher', 'wp-foodsearch'),
            ),
            'custom_box' => array(
                'label' => esc_html__('custom content', 'wp-foodsearch'),
                'removeable' => '0'
            ),
        );
        
        return apply_filters('foodsearch_customer_menu_elems_list', $elements);
    }

}

new Customer_Builder;
