document.querySelector('body').classList.add('wp-foodsearch');
document.querySelector('body').classList.add('foodsearch-default');

jQuery(function($){
    
    foodsearch_menudropdown();
    foodsearch_choiceGroupdropdown();
    foodsearch_restaurantdropdown();
    foodsearch_selectdropdownFiled();
    foodsearch_initailizeSelect2();
    foodsearch_itemcategoriesinitailize();

    // on upload button click
    jQuery('body').on( 'click', '.fds-upload', function(e){
        "use strict";
        e.preventDefault();

        var button = jQuery(this),
            custom_uploader = wp.media({
                title: 'Insert image',
                library : {
                    type : 'image'
                },
                button: {
                    text: 'Use this image' // button label text
                },
                multiple: false
            }).on('select', function() { // it also has "open" and "close" events
                var attachment = custom_uploader.state().get('selection').first().toJSON();
                console.log(attachment);
                button.css({'background-image':'url('+attachment.url+')','background-size':'cover','background-repeat':'no-repeat'});
                button.next().show();
                button.html(' ');
                button.parents('div.image-upload').find('input').val(attachment.id);
            }).open();

    });
    // on remove button click
    jQuery('body').on('click', 'a.fds-remove', function(e){
        "use strict";
        e.preventDefault();
        var button = jQuery(this);
        button.prev().css('background-image','none'); // emptying the hidden field
        button.hide().prev().html('<i class="fds-icon fds-camera"></i>');
    });
    foodsearch_choicegroupOption();

});

var foodsearch_common_getJSON = function (url, callback) {
    "use strict";
    var xhr = new XMLHttpRequest();
    xhr.open('GET', url, true);
    xhr.responseType = 'json';
    xhr.onload = function () {
        var status = xhr.status;
        if (status === 200) {
            callback(null, xhr.response);
        } else {
            callback(status, xhr.response);
        }
    };
    xhr.send();
};

function foodsearch_color_pickr_call() {
    "use strict";
    if (jQuery('.fds-pickr-selectr').length > 0) {
        jQuery('.fds-pickr-selectr').each(function() {
            var this_elm = jQuery(this);
            var this_elm_parent = this_elm.parents('.fds-pickr-containr');
            var def_color_code = this_elm.attr('data-colr');
            var bycolor_pickr = new Pickr({
                el: '.fds-pickr-selectr',
                container: 'body',
                theme: 'monolith',
                swatches: null,
                defaultRepresentation: 'HEXA',
                appClass: 'fds-color-picker',
                default: def_color_code,
                comparison: false,
                components: {
                    preview: false,
                    opacity: true,
                    hue: true,
                    interaction: {
                        hex: false,
                        rgba: false,
                        hsva: false,
                        input: true,
                        clear: true,
                        save: false
                    }
                }
            }).on('changestop', (source, instance) => {
                var selectd_color = bycolor_pickr.getColor().toHEXA().toString();
                this_elm_parent.find('input[type=hidden]').val(selectd_color).trigger('change');
            }).on('clear', () => {
                this_elm_parent.find('input[type=hidden]').val('').trigger('change');
            });
        });
    }
}

jQuery(document).ready(function () {
    
    if (jQuery('.fds-bkcolor-field').length > 0) {
        jQuery('.fds-bkcolor-field').wpColorPicker();
    }
    
    foodsearch_color_pickr_call();
    
    if (jQuery('.fds-select-dropdown').length > 0) {
        jQuery('.fds-select-dropdown').select2({
            allowClear: true,
            width: '100%'
        });       
    }
    
    jQuery('#fds-setting-search-item').select2({
        width: '100%',
        ajax: {
            url: fds_admin_script_vars.site_url + 'wp/v1/search-plugin-options',
            dataType: 'json',
            data: function (params) {
                var query = {
                    search: params.term
                }
                return query;
            },
            beforeSend: function (xhr) {
                if(fds_admin_script_vars.adminCheck!='true'){
                    xhr.setRequestHeader('X-WP-Nonce', fds_admin_script_vars.wpnonce);
                }                
            }
        }
    });
    jQuery(document).on('click','#update-location-table',function(){        
        jQuery.ajax({
            type: "POST",
            dataType:'json',
            url:fds_admin_script_vars.ajax_curl,                
            data:{
                action:'update_location_db'
            },            
            success: function(data){
                window.location.reload();
            }
        });
    });
    
    
    jQuery('.fds-user-select2').select2({
        width: '100%',
        ajax: {
            url: fds_admin_script_vars.site_url + 'wp/v1/fds-search-users',
            dataType: 'json',
            data: function (params) {
                var query = {
                    search: params.term
                }
                return query;
            },
           beforeSend: function (xhr) {
                if(fds_admin_script_vars.adminCheck!='true'){
                    xhr.setRequestHeader('X-WP-Nonce', fds_admin_script_vars.wpnonce);
                }                
            }
        }
    });
    
    window.onbeforeunload = function() {
        if (jQuery('.fds-settings-msg').length > 0) {
            if (jQuery('.fds-settings-msg').hasClass('alert-warning')) {
                return false;
            }
        }
    };
});

jQuery(document).on('change', '.fds-settings-switch', function() {
    "use strict";
    var this_btn = jQuery(this);
    if (this_btn.is(':checked')) {
        if (this_btn.hasClass('fds-intig-val')) {
            var on_val = '1';
        } else {
            var on_val = 'on';
        }
        this_btn.parents('.fds-switch').find('input[type=hidden]').val(on_val).trigger('change');
    } else {
        this_btn.parents('.fds-switch').find('input[type=hidden]').val('').trigger('change');
    }
});

jQuery('.side-itm-menu > a > i').on('click', function(ev) {
    "use strict";
    ev.preventDefault();
    var this_btn = jQuery(this);
    this_btn.parents('.side-itm-menu').find('.submenu-con').slideToggle();
});

jQuery('.fds-save-changes,.fds-reset-section,.fds-reset-all').on('click', function(ev) {
    "use strict";
    ev.preventDefault();
    var this_btn = jQuery(this);
    var doing_reset_sec = false, doing_reset_all = false;
    var action_input = jQuery('input[name="fds_plugin_settings_action"]');
    if (this_btn.hasClass('fds-reset-section')) {
        doing_reset_sec = true;
        action_input.val('reset_section');
    } else if (this_btn.hasClass('fds-reset-all')) {
        action_input.val('reset_all');
        doing_reset_all = true;
    } else {
        action_input.val('save_section');
    }
    
    if (doing_reset_sec === true) {
        jQuery.fds_confirm_popup({
            message: fds_admin_script_vars.reset_sec_setings,
            buttons: {
                Yes: {
                    class: 'fds-accept-btn',
                    action: function () {
                        this_btn.parents('form').trigger('submit');
                        jQuery.fds_confirm_popup.hide();
                    },
                },
                No: {
                    class: 'fds-decline-btn',
                    action: function () {
                        jQuery.fds_confirm_popup.hide();
                    }
                }
            }
        });
    } else if (doing_reset_all === true) {
        jQuery.fds_confirm_popup({
            message: fds_admin_script_vars.reset_all_setings,
            buttons: {
                Yes: {
                    class: 'fds-accept-btn',
                    action: function () {
                        this_btn.parents('form').trigger('submit');
                        jQuery.fds_confirm_popup.hide();
                    },
                },
                No: {
                    class: 'fds-decline-btn',
                    action: function () {
                        jQuery.fds_confirm_popup.hide();
                    }
                }
            }
        });
    } else {
        this_btn.parents('form').trigger('submit');
    }
});

jQuery('.fds-pluginsetin-form').on('submit', function(ev) {
    "use strict";
    ev.preventDefault();
    var this_form = jQuery(this),
    msg_con = this_form.find('.fds-settings-msg'),
    from_element = this_form[0];
    
    var form_data = new FormData(from_element);

    this_form.append('<div class="fds-loader-holder"><div class="fds-loader"></div></div>');

    msg_con.html('').hide();
    var request = jQuery.ajax({
        url: fds_admin_script_vars.ajax_url,
        method: "POST",
        processData: false,
        contentType: false,
        data: form_data, 
        dataType: "json"
    });
    request.done(function (response) {

        if (response.error == '0') {
            msg_con.attr('class', 'fds-settings-msg alert-success');
            msg_con.html(response.msg);
            msg_con.slideDown();
            setTimeout(function() {
                msg_con.slideUp();
            }, 3000);
        } else if (response.error == '2') {
            msg_con.attr('class', 'fds-settings-msg alert-warning');
            msg_con.html(response.msg);
            msg_con.slideDown();
            //
            setTimeout(function() {
                window.location.reload();
            }, 3000);
        } else {
            msg_con.attr('class', 'fds-settings-msg alert-danger');
            msg_con.html(response.msg);
            msg_con.slideDown();
            setTimeout(function() {
                msg_con.slideUp();
            }, 3000);
        }
        
    });
    request.always(function () {
        this_form.find('.fds-loader-holder').remove();
    });
    
    return false;
});

jQuery(document).on('change', '.fds-pluginsetin-form input,.fds-pluginsetin-form select,.fds-pluginsetin-form textarea', function() {
    "use strict";
    var _this = jQuery(this);
    var this_form = _this.parents('form'),
    msg_con = this_form.find('.fds-settings-msg'),
    from_element = this_form[0];

    if (typeof _this.attr('name') !== 'undefined' && _this.attr('name') != '' && _this.attr('name') != 'undefined') {
        
        if (!msg_con.hasClass('fds-save-changes')) {
            msg_con.attr('class', 'fds-settings-msg fds-save-changes alert-warning');
            msg_con.html(fds_admin_script_vars.seting_change_msg);
            msg_con.slideDown();
        }
        
        // For condition base fields check
        var form_data = new FormData(from_element);
        form_data.delete('fds_plugin_settings_action');
        form_data.append('plugin_settings_cond_check', '1');

        var request = jQuery.ajax({
            url: fds_admin_script_vars.ajax_url,
            method: "POST",
            processData: false,
            contentType: false,
            data: form_data,
            dataType: "json", 
        });
        request.done(function (response) {
            var conditions = response.conditions;

            for (var key in conditions) {
                if (conditions.hasOwnProperty(key)) {
                    var condition_itm = conditions[key];
                    var condition_class = condition_itm.class;
                    var condition_html = condition_itm.html;
                    if (condition_html == 'off') {
                        jQuery(condition_class).hide();
                    } else {
                        jQuery(condition_class).removeAttr('style');
                    }
                }
            }
        });
        request.always(function () {
            
        });
        
        return false;
    }
});

jQuery(document).on('change', '#fds-setting-search-item', function() {
    "use strict";
    var _this = jQuery(this);
    var this_val  = _this.val();
    var this_val_itms = this_val.split('|');
    var page_url = _this.parents('.fds-setings-serch-con').data('page');
    
    if (this_val_itms.length == 3) {
        var field_id = this_val_itms[2];
        field_id = 'fds-field-' + field_id.replace(/_/gi, '-');
        page_url += '?page=foodsearch-plugin-settings&tab=' + this_val_itms[0] + '&section=' + this_val_itms[1] + '#' + field_id;
        window.location.href = page_url;
    } else if (this_val_itms.length == 2) {
        var field_id = this_val_itms[1];
        field_id = 'fds-field-' + field_id.replace(/_/gi, '-');
        page_url += '?page=foodsearch-plugin-settings&tab=' + this_val_itms[0] + '#' + field_id;
        window.location.href = page_url;
    }
});

const foodsearch_submit_msg_alert = (function() {
    "use strict";
    return function foodsearch_submit_msg_alert(id, msg, alert_class = 'alert-info') {
        if (jQuery('body').find('.fds-msg-wrap').length == 0) {
            jQuery('body').append('<div class="fds-msg-wrap"></div>');
        }
        jQuery('body').find('.fds-msg-wrap').html('<div class="fds-alert-msg ' + alert_class + '" id="' + id + '">' + msg + '</div>');
        setTimeout(function(){ jQuery('#' + id).addClass('fds-alert-hide'); }, 4000);
        setTimeout(function(){ jQuery('#' + id).remove(); }, 6000);
    }
})();

jQuery.fds_confirm_popup = function (params) {
    "use strict";
    if (jQuery('#fds-confirm-msg-popup').length) {
        return false;
    }

    var buttonHTML = '';
    jQuery.each(params.buttons, function (name, obj) {

        buttonHTML += '<a class="fds-confirm-button fds-link ' + obj['class'] + '">' + name + '</a>';

        if (!obj.action) {
            obj.action = function () {};
        }
    });

    var markup = [
        '<div id="fds-confirm-msg-popup" class="fds-modal-popup fds-popup-visible fds-confirmsg-modal">',
        '<div class="fds-modal-container">',
        '<div class="fds-modal-inner-area">',
        '<div class="fds-modal-content-area">',
        '<div class="fds-confirmsg-con">',
        '<p class="confrm-msg-txt">', params.message, '</p>',
        '<div class="confirm-popup-btns">',
        buttonHTML,
        '</div></div></div></div></div>'
    ].join('');

    jQuery(markup).appendTo('body');
    jQuery('body').addClass('foodsearch-popup-active');

    var buttons = jQuery('#fds-confirm-msg-popup .fds-confirm-button'),
    i = 0;

    jQuery.each(params.buttons, function (name, obj) {
        buttons.eq(i++).on('click', function () {

            obj.action();
            return false;
        });
    });
}

jQuery.fds_confirm_popup.hide = function () {
    "use strict";
    foodsearch_modal_popup_close();
    jQuery('#fds-confirm-msg-popup').remove();
}

function foodsearch_modal_popup_open(target) {
    "use strict";
    jQuery('#' + target).removeClass('fds-popup-hide').addClass('fds-popup-visible').css({'visibility':'visible','opacity':1});
    jQuery('body').addClass('foodsearch-popup-active');
}

function foodsearch_modal_popup_close() {
    "use strict";
    if (!jQuery('body').hasClass('foodsearch-hardcore-popup')) {
        jQuery('.fds-modal-popup').removeClass('fds-popup-visible').addClass('fds-popup-hide').css({'visibility':'hidden','opacity':0});
        jQuery('body').removeClass('foodsearch-popup-active');
    }
}

jQuery(document).on('mousedown', '.fds-modal-popup', function (e) {
    "use strict";
    //
    var is_close = true;
    var this_dom = e.target;
    var thisdom_obj = jQuery(this_dom);

    if (thisdom_obj.hasClass('fds-modal-inner-area') || thisdom_obj.parents('.fds-modal-inner-area').length > 0) {
        is_close = false;
    }
    if (is_close === true) {
        foodsearch_modal_popup_close();
    }
});

jQuery(document).on("click", ".fds-upload-file", function () {
    "use strict";
    var _this = jQuery(this);
    var id = _this.attr("name");
    var custom_uploader = wp.media({
        title: 'Select File',
        button: {
            text: 'Add File'
        },
        multiple: false
    })
    .on('select', function () {
        var attachment = custom_uploader.state().get('selection').first().toJSON();
        if (_this.parents('.fds-imgfield-con').length > 0) {
            _this.parents('.fds-imgfield-con').find('img').attr('src', attachment.url);
            _this.parents('.fds-imgfield-con').find('.fds-remvupload-file').removeAttr('style');
        }
        if (_this.hasClass('fds-attach-id')) {
            jQuery('#' + id).val(attachment.id).trigger('change');
        } else {
            jQuery('#' + id).val(attachment.url).trigger('change');
        }
    }).open();
});

jQuery(document).on("click", ".fds-remvupload-file", function () {
    "use strict";
    var _this = jQuery(this);
    if (_this.parents('.fds-imgfield-con').length > 0) {
        _this.parents('.fds-imgfield-con').find('img').attr('src', '');
        _this.parents('.fds-imgfield-con').find('input[type="text"]').val('').attr('value', '').trigger('change');
        _this.hide();
    }
});

jQuery('span.slider').on('click',function(){
    "use strict";
    if(jQuery(this).parents('label.switch').find('input').val()!=1) {
        jQuery(this).parents('label.switch').find('input').val(1);
    }
    else{
        jQuery(this).parents('label.switch').find('input').val(0)
    }
});


jQuery(document).on('click','div#restaurants_menu_meta_filed table tr td a.menu-items',function () {
    "use strict";
    var id = jQuery(this).attr('id');
    var content = '';

    jQuery.ajax({
        type: "post",
        dataType: "json",
        url:fds_admin_script_vars.site_url + 'wp/v1/menu-item-list-bymid',
        data:  {
            id: id
        },        
        beforeSend: function (xhr) {
            if(fds_admin_script_vars.adminCheck!='true'){
                xhr.setRequestHeader('X-WP-Nonce', fds_admin_script_vars.wpnonce);
            }       
        },
        success: function(data){
            jQuery(".menu-items-area"+id).html(data.html).toggle(500);
            jQuery( "#sortable" ).sortable({
                'items': 'tr',
                'placeholder': "ui-state-highlight",
                'axis': 'y',
                'update' : function(e, ui) {
                    var order               =   jQuery('#sortable').sortable('serialize');
                    console.log(order);
                     var queryString = { "action": "update-menu-item-order", "order" : order};
                    //send the data through ajax
                    jQuery.ajax({
                        type: 'POST',
                        url: ajaxurl,
                        data: queryString,
                        cache: false,
                        dataType: "html",
                        success: function(data){

                        },
                        error: function(html){

                        }
                    });

                }});
            jQuery( "#sortable" ).disableSelection();
        }
    });

});

jQuery(document).on('click','div#restaurants_menu_meta_filed table tr td table tr td a.choice-groups',function () {
    "use strict";
    var id = jQuery(this).attr('id');
    jQuery.ajax({
        type: "post",
        dataType: "json",
        url:fds_admin_script_vars.site_url + 'wp/v1/food-choice-groups-bymid',
        data:  {
            id: id
        },
        beforeSend: function (xhr) { 
            if(fds_admin_script_vars.adminCheck!='true'){
                 xhr.setRequestHeader('X-WP-Nonce', fds_admin_script_vars.wpnonce);
            }       
        },
        success: function(data){
            content = data;
            jQuery(".choice-groups-area"+id).html(data.html).toggle(500);
        }
    });

});


jQuery('button#myBtn').on('click',function(){
    "use strict";
    foodsearch_showSidebarPopup('add',jQuery(this).attr('data-type'));
});
jQuery('span#closeSaveBtn').on('click',function(){
    "use strict";
    jQuery(".menu-form form.addform").animate({
        right: -600
    }, "slow",'linear',function(){
        jQuery('.menu-form').toggleClass('open').hide();
    });
    jQuery('.result-status').html('');
    jQuery('.filed-group-con').html('');
    //

});
jQuery('span#closeUpdateBtn').on('click',function(){
    "use strict";
    jQuery(".menu-form form.updateform").animate({
        right: -600
    }, "slow",'linear',function(){
        jQuery('.menu-form').toggleClass('open').hide();
    });

    jQuery('.result-status').html('');
    jQuery('.update-filed-group-con').html('');
    //

});

jQuery(document).on('click','a.edit-menu',function (e) {
    "use strict";
    e.preventDefault();
    jQuery('.result-status').hide();
    foodsearch_showSidebarPopup('update');
    var id = jQuery(this).attr('data-id');
    jQuery('.update-text-block').html('Edit: '+jQuery(this).attr('data-title')).show();
    jQuery.ajax({
        type: "post",
        dataType: "json",
        url:fds_admin_script_vars.site_url + 'wp/v1/food-menu-itemedit-byid',
        data:  {
            id: id
        },
        beforeSend: function (xhr) {            
            if(fds_admin_script_vars.adminCheck!='true'){
                xhr.setRequestHeader('X-WP-Nonce', fds_admin_script_vars.wpnonce);
           }       
        },
        success: function(data){
            jQuery('span.spin').hide();
            jQuery('.update-filed-group-con').html(data.html);
            foodsearch_restaurantdropdown();
            foodsearch_selectdropdownFiled();
            jQuery('.update-filed-group-con').show();
            jQuery('.result-status').show();

        }
    });
});
jQuery(document).on('click','a.edit-menu-item',function (e) {
    "use strict";
    e.preventDefault();
    jQuery('.result-status').hide();
    foodsearch_showSidebarPopup('update');
    var id = jQuery(this).attr('data-id');
    jQuery('.update-text-block').html('Edit: '+jQuery(this).attr('data-title')).show();

    jQuery.ajax({
        type: "post",
        dataType: "json",
        url:fds_admin_script_vars.site_url + 'wp/v1/food-menuitm-detail-bymid',
        data:  {
            id: id
        },
        success: function(data){
            jQuery('span.spin').hide();
            jQuery('.update-filed-group-con').html(data.html);
            foodsearch_itemcategoriesinitailize();
            foodsearch_selectdropdownFiled();
            foodsearch_choiceGroupdropdown();
            foodsearch_extendVariationFileds();
            foodsearch_menudropdown();
            jQuery('.update-filed-group-con').show();

        }
    });
});
jQuery(document).on('click','a.edit-choice-group',function (e) {
    "use strict";
e.preventDefault();
    jQuery('.result-status').hide();
    foodsearch_showSidebarPopup('update');
    var id = jQuery(this).attr('data-id');
    jQuery('.update-text-block').html('Edit: '+jQuery(this).attr('data-title')).show();

    jQuery.ajax({
        type: "post",
        dataType: "json",
        url:fds_admin_script_vars.site_url + 'wp/v1/food-choicegroup-detail-bymid',
        data:  {
            id: id
        },
        
        beforeSend: function (xhr) {
            if(fds_admin_script_vars.adminCheck!='true'){
                 xhr.setRequestHeader('X-WP-Nonce', fds_admin_script_vars.wpnonce);
            }       
        },
        success: function(data){
            jQuery('span.spin').hide();
            jQuery('.update-filed-group-con').html(data.html);
            foodsearch_choicegroupOption();
            foodsearch_initailizeSelect2();
            foodsearch_selectdropdownFiled();
            foodsearch_restaurantdropdown();
            jQuery('.update-filed-group-con').show();

        }
    });
});

jQuery(document).on('click', 'button#menuSaveBtn',function () {
    "use strict";
    jQuery(this).prop('disabled');
    var from = jQuery(this).parents('form');
    var formData = from.serialize();
    jQuery.ajax({
        type: "post",
        dataType: "json",
        url:fds_admin_script_vars.site_url + 'wp/v1/create-menu',
        data: formData,        
        beforeSend: function (xhr) {
            if(fds_admin_script_vars.adminCheck!='true'){
                 xhr.setRequestHeader('X-WP-Nonce', fds_admin_script_vars.wpnonce);
            }       
        },
        success: function(data){
            var msg_rand = Math.floor(Math.random() * 1000000) + 1;
            if(data.status=='success'){
                from[0].reset();
                foodsearch_submit_msg_alert('alert-msg-' + msg_rand, data.msg, 'fds-alert-success');
                jQuery('#fds-emptymenu-btnsec').hide();
                jQuery('#fds-havemenu-btnsec').removeAttr('style');
                foodsearch_modal_popup_close();
                window.location.reload();
            } else {
                foodsearch_submit_msg_alert('alert-msg-' + msg_rand, data.msg, 'fds-alert-info');
            }
        }
    });
});

jQuery(document).on('click','button#menuItemSaveBtn',function () {
    "use strict";
    jQuery(this).prop('disabled');
    var from = jQuery(this).parents('form');
    var formData = from.serialize();
    jQuery.ajax({
        type: "post",
        dataType: "json",
        url:fds_admin_script_vars.site_url + 'wp/v1/create-menu-item',
        data: formData,
        beforeSend: function (xhr) {
            if(fds_admin_script_vars.adminCheck!='true'){
                 xhr.setRequestHeader('X-WP-Nonce', fds_admin_script_vars.wpnonce);
            }       
        },
        success: function(data){
            var msg_rand = Math.floor(Math.random() * 1000000) + 1;
            if(data.status=='success'){
                from[0].reset();
                foodsearch_submit_msg_alert('alert-msg-' + msg_rand, data.msg, 'fds-alert-success');
            } else {
                foodsearch_submit_msg_alert('alert-msg-' + msg_rand, data.msg, 'fds-alert-info');
            }
        }
    });
});

jQuery(document).on('click','button#choseGroupSaveBtn',function () {
    "use strict";
    var from = jQuery(this).parents('form');
    var formData = from.serialize();
    jQuery('.result-status').hide();
    jQuery.ajax({
        type: "post",
        dataType: "json",
        url:fds_admin_script_vars.site_url + 'wp/v1/create-choice-group',
        data: formData,
        beforeSend: function (xhr) {
            if(fds_admin_script_vars.adminCheck!='true'){
                 xhr.setRequestHeader('X-WP-Nonce', fds_admin_script_vars.wpnonce);
            }       
        },
        success: function(data){
            var msg_rand = Math.floor(Math.random() * 1000000) + 1;
            if(data.status=='success'){
                from[0].reset();
                foodsearch_submit_msg_alert('alert-msg-' + msg_rand, data.msg, 'fds-alert-success');
            } else {
                foodsearch_submit_msg_alert('alert-msg-' + msg_rand, data.msg, 'fds-alert-info');
            }
            
        }
    });
});

jQuery(document).on('click','button#menuUpdateBtn',function () {
    "use strict";
    jQuery('button#menuUpdateBtn').prop('disabled', true);
    var from = jQuery(this).parents('form');
    var formData = from.serialize();
    jQuery('.result-status').hide();
    jQuery.ajax({
        type: "post",
        dataType: "json",
        url:fds_admin_script_vars.site_url + 'wp/v1/update-menu',
        data: formData,
        beforeSend: function (xhr) {
            if(fds_admin_script_vars.adminCheck!='true'){
                 xhr.setRequestHeader('X-WP-Nonce', fds_admin_script_vars.wpnonce);
            }       
        },
        success: function(data){
            var msg_rand = Math.floor(Math.random() * 1000000) + 1;
            jQuery('button#menuUpdateBtn').prop('disabled', false);
            foodsearch_submit_msg_alert('alert-msg-' + msg_rand, data.msg, 'fds-alert-success');
        }
    });
});

jQuery(document).on('click','button#menuItemUpdateBtn',function () {
    "use strict";
    jQuery('button#menuItemUpdateBtn').prop('disabled', true);
    var from = jQuery(this).parents('form');
    var formData = from.serialize();
    jQuery('.result-status').hide();

    jQuery.ajax({
        type: "post",
        dataType: "json",
        url:fds_admin_script_vars.site_url + 'wp/v1/update-menu-item',
        data: formData,
        beforeSend: function (xhr) {
            if(fds_admin_script_vars.adminCheck!='true'){
                 xhr.setRequestHeader('X-WP-Nonce', fds_admin_script_vars.wpnonce);
            }       
        },
        success: function(data){

            jQuery('button#menuItemUpdateBtn').prop('disabled', false);
            var msg_rand = Math.floor(Math.random() * 1000000) + 1;
            foodsearch_submit_msg_alert('alert-msg-' + msg_rand, data.msg, 'fds-alert-success');
        }
    });
});

jQuery(document).on('click','button#choiceGroupUpdateBtn',function () {
    "use strict";
    jQuery('button#choiceGroupUpdateBtn').prop('disabled', true);
    var from = jQuery(this).parents('form');
    var formData = from.serialize();
    jQuery('.result-status').hide();
    jQuery.ajax({
        type: "post",
        dataType: "json",
        url:fds_admin_script_vars.site_url + 'wp/v1/update-choice-group',
        data: formData,
        beforeSend: function (xhr) {
            if(fds_admin_script_vars.adminCheck!='true'){
                 xhr.setRequestHeader('X-WP-Nonce', fds_admin_script_vars.wpnonce);
            }       
        },
        success: function(data){
            jQuery('button#choiceGroupUpdateBtn').prop('disabled', false);
            var msg_rand = Math.floor(Math.random() * 1000000) + 1;
            foodsearch_submit_msg_alert('alert-msg-' + msg_rand, data.msg, 'fds-alert-success');
        }
    });
});

function foodsearch_choicegroupOption() {
    "use strict";
    var maxField = 100; //Input fields increment limitation
    var wrapper = jQuery('.field_wrapper'); //Input field wrapper
    var fieldHTML = jQuery("#fooditemFiled")
        .eq(0)
        .clone()
        .find("input").val("").end().html();  //Input field wrapper
    var fieldHTMLContent = '<div class="item_box">'+fieldHTML+'</div>'; //New input field html
    var x = 1; //Initial field counter is 1

    //Once add button is clicked
    jQuery(document).on('click','.add_button', function () {
        if (x < maxField) {
            x++; //Increment field counter
            jQuery(wrapper).append(fieldHTMLContent); //Add field html
        }
        var n = jQuery(wrapper).find('div.item_box').length;
        foodsearch_updateDropdown(n);
    });

    //Once remove button is clicked
    jQuery(document).on('click', '.remove_button', function (e) {
        e.preventDefault();
        
        jQuery(this).parents('div.item_box').remove(); //Remove field html
        x--; //Decrement field counter
        var n = jQuery(wrapper).find('div.item_box').length;
        foodsearch_updateDropdown(n);
    });
}

const foodsearch_showSidebarPopup = (function() {
    "use strict";

    return function foodsearch_showSidebarPopup(status = '',type=''){

        var boxwidth = -17;
        if(jQuery('.menu-form').hasClass('open')){
            boxwidth =-600;
        }
        jQuery('.menu-form').toggleClass('open').show();
        if(status=='update'){
            jQuery('.addform').hide();
            jQuery('.updateform').show();
            jQuery(".menu-form form.updateform").animate({
                right: boxwidth
            },'slow','linear',function(){
            });
        } else {
            jQuery('.addform').show();
            jQuery('.updateform').hide();
            jQuery(".menu-form form.addform").animate({
                right: boxwidth
            },'slow','linear',function(){

            });
        }
        if(type=='choicegroup'){
            jQuery.ajax({
                type: "post",
                dataType: "json",
                url:fds_admin_script_vars.site_url + 'wp/v1/food-choicegroup-add-form',
                data:  {
                    addin:'choiceGroupaddForm',
                },
                beforeSend: function (xhr) {
                    if(fds_admin_script_vars.adminCheck!='true'){
                         xhr.setRequestHeader('X-WP-Nonce', fds_admin_script_vars.wpnonce);
                    }       
                },
                success: function(data){
                    jQuery('span.spin').hide();
                    jQuery('.filed-group-con').html(data.html);
                    foodsearch_choicegroupOption();
                    foodsearch_initailizeSelect2();
                    foodsearch_restaurantdropdown();
                    foodsearch_selectdropdownFiled();
                    jQuery('.filed-group-con').show();

                }
            });
        }
        else if(type=='menus'){
            jQuery.ajax({
                type: "post",
                dataType: "json",
                url:fds_admin_script_vars.site_url + 'wp/v1/food-menus-add-form',
                data:  {
                    addin:'menusaddForm',
                },
                beforeSend: function (xhr) {
                    if(fds_admin_script_vars.adminCheck!='true'){
                         xhr.setRequestHeader('X-WP-Nonce', fds_admin_script_vars.wpnonce);
                    }       
                },
                success: function(data){
                    jQuery('span.spin').hide();
                    jQuery('.filed-group-con').html(data.html);
                    foodsearch_restaurantdropdown();
                    foodsearch_selectdropdownFiled();
                    jQuery('.filed-group-con').show();

                }
            });
        }
        else if(type=='menuitems'){
            jQuery.ajax({
                type: "post",
                dataType: "json",
                url:fds_admin_script_vars.site_url + 'wp/v1/food-menuitm-add-form',
                data:  {
                    addin:'menusItemaddForm',
                },
                beforeSend: function (xhr) {
                    if(fds_admin_script_vars.adminCheck!='true'){
                         xhr.setRequestHeader('X-WP-Nonce', fds_admin_script_vars.wpnonce);
                    }       
                },
                success: function(data){
                    jQuery('span.spin').hide();
                    jQuery('.filed-group-con').html(data.html);
                    foodsearch_itemcategoriesinitailize();
                    foodsearch_selectdropdownFiled();
                    foodsearch_choiceGroupdropdown();
                   foodsearch_extendVariationFileds();
                    foodsearch_menudropdown();
                    jQuery('.filed-group-con').show();

                }
            });
        }

    }
})();
function foodsearch_itemcategoriesinitailize(){
    "use strict";
    jQuery('.food-item-category-dropdown').select2({
        width: '100%',
        ajax: {
            url: fds_admin_script_vars.site_url + 'wp/v1/itemcategories',            
           beforeSend: function (xhr) {
                if(fds_admin_script_vars.adminCheck!='true'){
                    xhr.setRequestHeader('X-WP-Nonce', fds_admin_script_vars.wpnonce);
                }                
            },
            dataType: 'json'
            
        }
    });
}
function foodsearch_updateDropdown(n){
    "use strict";
    foodsearch_initailizeSelect2();
    var maxContent, minContent = '';
    for(var i =0;i<=n;i++){
        minContent +='<option value="'+i+'">'+i+'</option>';
    }
    jQuery('.min_dropdown').html(minContent);

    for(var i =1;i<=n;i++){
        maxContent +='<option value="'+i+'">'+i+'</option>';
    }
    jQuery('.max_dropdown').html(maxContent);
}

const foodsearch_initailizeSelect2 = (function() {
    "use strict";
    return function foodsearch_initailizeSelect2(restaurant_id = 0) {

        jQuery('.food-item-dropdown').select2({
            width: '100%',
            ajax: {
                url: fds_admin_script_vars.site_url + 'wp/v1/fooditems',
                dataType: 'json',
                beforeSend: function (xhr) {
                    
            if(fds_admin_script_vars.adminCheck!='true'){
                xhr.setRequestHeader('X-WP-Nonce', fds_admin_script_vars.wpnonce);
           }       
                },
                data: function (params) {
                    var query = {
                        restaurant: restaurant_id,
                        q: params.term
                    }
                    return query;
                },
            }
        });
    }
})();
jQuery('#choiceGroup-addform,#choiceGroup-updateform').on('change', '#restaurant_id', function() {
    "use strict";
    var _this = jQuery(this);
    if (_this.parents('form').find('.food-item-dropdown').length > 0) {
        var restaurant_id = _this.val();
        foodsearch_initailizeSelect2(restaurant_id);
    }
});
function foodsearch_selectdropdownFiled() {
    "use strict";
    jQuery('.select_dropdown').select2({
        width: '100%',
    });
}
function foodsearch_restaurantdropdown(){
    "use strict";
    jQuery('.restaurant-dropdown').select2({
        width: '100%',
        ajax: {
            url: fds_admin_script_vars.site_url + 'wp/v1/restaurantDropdown',
           beforeSend: function (xhr) {
                if(fds_admin_script_vars.adminCheck!='true'){
                    xhr.setRequestHeader('X-WP-Nonce', fds_admin_script_vars.wpnonce);
                }                
            },
            dataType: 'json'
        }
    });
}

const foodsearch_choiceGroupdropdown = (function() {
    "use strict";
    return function foodsearch_choiceGroupdropdown(restaurant_id = 0) {

        jQuery('.food-item-choicegroup-dropdown').select2({
            width: '100%',
            ajax: {
                url: fds_admin_script_vars.site_url + 'wp/v1/choicegroupList',
                dataType: 'json',
                beforeSend: function (xhr) {
                    if(fds_admin_script_vars.adminCheck!='true'){
                         xhr.setRequestHeader('X-WP-Nonce', fds_admin_script_vars.wpnonce);
                    }       
                },
                data: function (params) {
                    var query = {
                        restaurant: restaurant_id,
                        q: params.term
                    }
                    return query;
                },
            }
        });
    }
})();
function foodsearch_extendVariationFileds(){
    "use strict";
       //Once add button is clicked
    var x = 1; //Initial field counter is 1
    var wrapperV = jQuery('.variation_wrapper_outer'); //Input field wrapper
    jQuery(document).on('click','.add_variation_button', function () {
        x++; //Increment field counter
        jQuery('.price_wrap').hide();
        jQuery('.variation_wrapper_outer').show();
        jQuery(".item_box")
            .eq(0)
            .clone()
            .find("input").val("").end() // ***
            .show()
            .insertAfter(".item_box:last");
        var n = jQuery(wrapperV).find('div.item_box').length;
    });

    //Once remove button is clicked
    jQuery(document).on('click', 'a.remove_variation_button', function (e) {
        e.preventDefault();
        jQuery(this).parents('div.item_box').remove(); //Remove field html
        x--; //Decrement field counter
        var n = jQuery(wrapperV).find('div.item_box').length;
        if (n == 1) {
            jQuery('.price_wrap').show();
            jQuery('.variation_wrapper_outer').hide();
        }
    });
}
function foodsearch_menudropdown(){
    "use strict";
    jQuery('.food-menu-dropdown').select2({
        width: '100%',
        ajax: {
            url: fds_admin_script_vars.site_url + 'wp/v1/menuList',
           beforeSend: function (xhr) {
                if(fds_admin_script_vars.adminCheck!='true'){
                    xhr.setRequestHeader('X-WP-Nonce', fds_admin_script_vars.wpnonce);
                }                
            },
            dataType: 'json'
            // Additional AJAX parameters go here; see the end of this chapter for the full code of this example
        }
    });
}

jQuery(document).on('click', '.fds-to-list-itms', function() {
    "use strict";
    var _this = jQuery(this);
    var this_id = _this.attr('data-id');
    
    var child_itms_con = jQuery('.items-con-' + this_id);
    if (child_itms_con.hasClass('active-list-itms')) {
        child_itms_con.slideUp();
        child_itms_con.removeClass('active-list-itms');
    } else {
        child_itms_con.slideDown();
        child_itms_con.addClass('active-list-itms');
    }
});

jQuery(document).on('click', '.add-mtext-itm', function(ev) {
    "use strict";
    ev.preventDefault();
    var _this = jQuery(this);
    var this_parent = _this.parents('.text-input-itm');
    this_parent.after('<div class="text-input-itm">' + this_parent.html() + (this_parent.find('.remove-mtext-itm').length > 0 ? '' : '<a href="#" class="remove-mtext-itm fds-link"><i class="dashicons-before dashicons-no"></i></a>') + '</div>');
});

jQuery(document).on('click', '.remove-mtext-itm', function(ev) {
    "use strict";
    ev.preventDefault();
    var _this = jQuery(this);
    var this_parent = _this.parents('.text-input-itm');
    this_parent.remove();
});

jQuery(document).on('click', '.fds-settins-menu-template', function (ev) {
    "use strict";
    ev.preventDefault();
    
    var _this = jQuery(this),
    temp_id = _this.attr('data-tid');
    
    jQuery('#menu-template-settin-popup').find('.fds-dynm-modal-content').html('<div class="fds-loader-holder"><div class="fds-loader"></div></div>');

    jQuery.ajax({
        type: "post",
        dataType: "json",
        url: fds_admin_script_vars.site_url + 'wp/v1/menu-template-setting-popup-html',
        data: {
            temp_id: temp_id,
        },
        beforeSend: function (xhr) {
            if(fds_admin_script_vars.adminCheck!='true'){
                 xhr.setRequestHeader('X-WP-Nonce', fds_admin_script_vars.wpnonce);
            }       
        },
        success: function(data){
            jQuery('#menu-template-settin-popup').find('.fds-dynm-modal-content').html(data.html);
        }
    });
    foodsearch_modal_popup_open('menu-template-settin-popup');
});

jQuery(document).on('submit', '#menu-tmplate-settin-form', function (ev) {
    "use strict";
    ev.preventDefault();
    
    var _this = jQuery(this),
    form_data = _this.serialize(),
    this_btn = _this.find('button[type="submit"]'),
    btn_html = this_btn.html();
    
    this_btn.html('<div class="fds-inline-loader"><div class="fds-loader"></div></div>');

    jQuery.ajax({
        type: "post",
        dataType: "json",
        url: fds_admin_script_vars.site_url + 'wp/v1/menu-template-settings-save',
        data: form_data,
        beforeSend: function (xhr) {
            if(fds_admin_script_vars.adminCheck!='true'){
                 xhr.setRequestHeader('X-WP-Nonce', fds_admin_script_vars.wpnonce);
            }       
        },
        success: function(data){
            var msg_rand = Math.floor(Math.random() * 1000000) + 1;
            if (data.error == '0'){
                foodsearch_submit_msg_alert('alert-msg-' + msg_rand, data.msg, 'fds-alert-success');
                
                var temp_id = data.id;
                var temp_con = jQuery('#template-' + temp_id);
                if (data.img != '') {
                    temp_con.find('.fds-template-icon-con').addClass('fds-has-img').css({'max-height': '212px'});
                    temp_con.find('.fds-template-icon-con img').attr('src', data.img).removeAttr('style');
                    temp_con.find('.fds-template-icon-con i').hide();
                } else {
                    temp_con.find('.fds-template-icon-con').removeClass('fds-has-img');
                    temp_con.find('.fds-template-icon-con i').removeAttr('style');
                    temp_con.find('.fds-template-icon-con img').attr('src', '').hide();
                }
                temp_con.find('.fds-template-name').html(data.title);
                
                foodsearch_modal_popup_close('menu-template-settin-popup');
            } else {
                foodsearch_submit_msg_alert('alert-msg-' + msg_rand, data.msg, 'fds-alert-info');
                this_btn.html(btn_html);
            }
        },
        error: function() {
            this_btn.html(btn_html);
        }
    });
    return false;
});