var foodsearch__map;
var foodsearch_map_markers = [];

jQuery(document).ready(function() {

    function foodsearch_get_map_cords_addres(lat, lng) {
        "use strict"; 
       
        var this_parent = jQuery('.fds-user-locations');
        this_parent.append('<div class="fds-loader-holder"><div class="fds-loader"></div></div>');
        var geoloc_request = jQuery.ajax({
            type: "POST",
            dataType: "json",
            url: google_map_vars.site_url + 'wp/v1/get-map-cords-addres',
            data: {
                lat: lat,
                lng: lng,
            },            
            beforeSend: function (xhr) {
                if(google_map_vars.adminCheck!='true'){
                    xhr.setRequestHeader('X-WP-Nonce', google_map_vars.wpnonce);
               }  
            }
        });
        geoloc_request.done(function (response) {
            if (response.address != '') {
                this_parent.find('.fds-loc-address-field').val(response.address);
                jQuery('.fds-map-adr-field').val(response.address);   
            }
        });
        geoloc_request.always(function () {
            this_parent.find('.fds-loader-holder').remove();
        });
    }
    function foodsearch__map_render() {
        "use strict";
        if (jQuery('.fds-location-map-outer').length > 0) {
            var map_parent_con = jQuery('.fds-location-map-outer');
            var rand_id = map_parent_con.attr('data-id');
            
            var def_lat = parseFloat(google_map_vars.lat);
            var def_lng = parseFloat(google_map_vars.lng);
            
            var map_lat_lng = {lat: def_lat, lng: def_lng};
            foodsearch__map = new google.maps.Map(document.getElementById('fds-map-' + rand_id), {
                zoom: parseInt(google_map_vars.zoom),
                center: map_lat_lng,
                streetViewControl: false,
                scrollwheel: false,
                mapTypeControl: false,
            });
            
            var marker = new google.maps.Marker({
                position: map_lat_lng,
                map: foodsearch__map,
                draggable: true,
            });
            
            foodsearch_map_markers.push(marker);

            google.maps.event.addListener(marker, 'dragend', function () {
                document.querySelector('.fds-map-lat-field').value = this.getPosition().lat();
                document.querySelector('.fds-map-lng-field').value = this.getPosition().lng();
                foodsearch_get_map_cords_addres(this.getPosition().lat, this.getPosition().lng);
            });
            google.maps.event.addListener(foodsearch__map, 'zoom_changed', function () {
                var zoom_lvl = foodsearch__map.getZoom();
                document.querySelector('.fds-map-zoom-field').value = zoom_lvl;
            });
            
            var autocomplete_input = document.querySelector('.fds-loc-address-field');
            var autcomplete_options = {};
            var autocomplete = new google.maps.places.Autocomplete(autocomplete_input, autcomplete_options);
            
            google.maps.event.addListener(autocomplete, 'place_changed', function () {
                var geocode_did_work = false;
                var geti_ayuto_adres = autocomplete.getPlace().formatted_address;
                var geocoder = new google.maps.Geocoder();
                geocoder.geocode({address: geti_ayuto_adres}, function (results, status) {
                    if (status == google.maps.GeocoderStatus.OK) {
                        geocode_did_work = true;
                        //console.log(results[0]);
                        var new_latitude = results[0].geometry.location.lat();
                        var new_longitude = results[0].geometry.location.lng();
                        
                        document.querySelector('.fds-map-lat-field').value = new_latitude;
                        document.querySelector('.fds-map-lng-field').value = new_longitude;
                        
                        // clear previous markers
                        for (var i = 0; i < foodsearch_map_markers.length; i++) {
                            foodsearch_map_markers[i].setMap(null);
                        }
                        
                        var marker = new google.maps.Marker({
                            map: foodsearch__map,
                            position: results[0].geometry.location,
                            draggable: true,
                        });
                        
                        foodsearch_map_markers.push(marker);
                        
                        google.maps.event.addListener(marker, 'dragend', function () {
                            document.querySelector('.fds-map-lat-field').value = this.getPosition().lat();
                            document.querySelector('.fds-map-lng-field').value = this.getPosition().lng();
                            foodsearch_get_map_cords_addres(this.getPosition().lat, this.getPosition().lng);
                        });
                    }
                });
                // if (geocode_did_work === false) {
                //     var mapbox_access_token = google_map_vars.mapbox_access_token;
                //     if (mapbox_access_token != '') {
                //         var map_addrapi_uri = 'https://api.mapbox.com/geocoding/v5/mapbox.places/' + encodeURI(geti_ayuto_adres) + '.json?access_token=' + mapbox_access_token;
                //         foodsearch_common_getJSON(map_addrapi_uri, function (loc_status, new_loc_response) {
                //             if (typeof new_loc_response === 'object') {
                               
                //                 var new_cords = new_loc_response.features[0].geometry.coordinates;
                //                 if (new_cords !== 'undefined') {
                //                     var new_latitude = new_cords[1];
                //                     var new_longitude = new_cords[0];
                                    
                //                     var new_position = {lat: new_latitude, lng: new_longitude};

                //                     document.querySelector('.fds-map-lat-field').value = new_latitude;
                //                     document.querySelector('.fds-map-lng-field').value = new_longitude;
                                    
                //                     foodsearch__map.setCenter(new_position);

                //                     // clear previous markers
                //                     for (var i = 0; i < foodsearch_map_markers.length; i++) {
                //                         foodsearch_map_markers[i].setMap(null);
                //                     }

                //                     var marker = new google.maps.Marker({
                //                         map: foodsearch__map,
                //                         position: new_position,
                //                         draggable: true,
                //                     });
                //                     foodsearch_map_markers.push(marker);

                //                     google.maps.event.addListener(marker, 'dragend', function () {
                //                         document.querySelector('.fds-map-lat-field').value = this.getPosition().lat();
                //                         document.querySelector('.fds-map-lng-field').value = this.getPosition().lng();
                //                         foodsearch_get_map_cords_addres(this.getPosition().lat, this.getPosition().lng);
                //                     });
                //                 }
                //             }
                //         });
                //     }
                // }
            });
        }
    }
    
    foodsearch__map_render();
});
jQuery(document).on('click','.update-popup-location',function(e){
    "use strict";
    e.preventDefault();
    var _this = jQuery(this);
    var this_prent = _this.parents('.fds-location-popup-open');
    this_prent.append('<div class="fds-loader-holder"><div class="fds-loader"></div></div>');
    jQuery.ajax({
        type: "post",
        dataType: "json",
        url:google_map_vars.site_url + 'wp/v1/update-user-delivery-location',
        data:  {
            lat:this_prent.find('.fds-map-lat-field').val(),
            lng:this_prent.find('.fds-map-lng-field').val(),
            address:this_prent.find('.fds-map-adr-field').val(),
            order_type:_this.attr('data-value'),
        },            
        beforeSend: function (xhr) {
           if(google_map_vars.adminCheck!='true'){
        xhr.setRequestHeader('X-WP-Nonce', google_map_vars.wpnonce);
}  
        },
        success: function(data){
            jQuery.ajax({
                type: "get",
                dataType: 'json',
                url: google_map_vars.site_url + 'wp/v1/call-restaurants',
                data: jQuery('#frm_restaurant_listing').serialize(),
                success: function(res){
                    foodsearch_modal_popup_close();
                    jQuery('#restaurant_area').html(res.html);   
                    this_prent.find('.fds-loader-holder').remove();
                  foodsearch_update_loc( jQuery('#offset').val() );
                }
            });

        }
    });
})
jQuery(document).on('click', '.fds-get-current-location', function(ev) {
   
    "use strict";
    ev.preventDefault();
    if (navigator.geolocation) {
        const options = {
            enableHighAccuracy: true,
            timeout: 5000,
            maximumAge: 1
        };
        function foodsearch_geolocation_access_err(error) {
            console.warn('ERROR(' + error.code + '): ' + error.message);
            foodsearch_check_location_latlng();
        }
        navigator.geolocation.getCurrentPosition(foodsearch_set_user_current_locate, foodsearch_geolocation_access_err, options);
    } else {
        console.log("Geolocation is not supported.");
        foodsearch_check_location_latlng();
    }
});

function foodsearch_check_location_latlng() {
    "use strict";
    var def_zoom = google_map_vars.map_zoom;
    var request = jQuery.ajax({
        url: "https://ipinfo.io/json",
        dataType: "json"
    });
    request.done(function (result) {
        if (result != null && typeof result.loc !== undefined && result.loc != '') {
            var address = result.city + ' ' + result.country;
            document.querySelector('.fds-loc-address-field').value = address;
            var latlng_str = result.loc;
            var latlng = latlng_str.split(',');
            var lat = latlng[0];
            var lng = latlng[1];
            foodsearch_set_map_latlng_marker(lat, lng, def_zoom);
        } else {
            foodsearch_geoloc_ipinfo_fallback();
        }
    });
    request.fail(function () {
        foodsearch_geoloc_ipinfo_fallback();
    });
}

function foodsearch_set_user_current_locate(position) {
    "use strict";
    
    var lat = position.coords.latitude;
    var lng = position.coords.longitude;
    
    //if (typeof foodsearch_geoloc_curr_request == 'undefined') {
        
        var def_zoom = google_map_vars.map_zoom;

        var this_parent = jQuery('.fds-addupd-location');
        var addres_field = this_parent.find('.fds-loc-address-field');
        this_parent.find('.fds-get-current-location').append('<div class="fds-inline-loader"><div class="fds-loader"></div></div>');

        foodsearch_geoloc_curr_request = jQuery.ajax({
            type: "POST",
            dataType: "json",
            url: google_map_vars.site_url + 'wp/v1/get-map-cords-addres',
            data: {
                lat: lat,
                lng: lng,
            },            
            beforeSend: function (xhr) {
                if(google_map_vars.adminCheck!='true'){
                    xhr.setRequestHeader('X-WP-Nonce', google_map_vars.wpnonce);
               }  
            }
        });
        foodsearch_geoloc_curr_request.done(function (response) {
            addres_field.val(response.address).attr('value', response.address);
            jQuery('.fds-map-adr-field').val(response.address);
        });
        foodsearch_geoloc_curr_request.always(function () {
            this_parent.find('.fds-get-current-location').find('.fds-inline-loader').remove();
        });
    // }
    // else{
    //     console.log('hi in curnt loc '+foodsearch_geoloc_curr_request);
    // }
}
jQuery(document).on('click','.update-popup-res-location',function(){
    "use strict";
    var _this = jQuery(this);
    var this_prent = _this.parents('.fds-location-map-outer');
    this_prent.append('<div class="fds-loader-holder"><div class="fds-loader"></div></div>');
    jQuery.ajax({
        type: "post",
        dataType: "json",
        url:google_map_vars.site_url + 'wp/v1/update-user-delivery-location',
        data:  {
            lat:this_prent.find('.fds-map-lat-field').val(),
            lng:this_prent.find('.fds-map-lng-field').val(),
            address:this_prent.find('.fds-map-adr-field').val(),
            order_type:_this.attr('data-value'),
            resID:this_prent.find('.fds-rest-id-field').val(),
        },            
        beforeSend: function (xhr) {
           if(google_map_vars.adminCheck!='true'){
        xhr.setRequestHeader('X-WP-Nonce', google_map_vars.wpnonce);
}  
        },
        success: function(data){            
            jQuery('.fds-location-block-wrap').show();
            jQuery('#fds-address-block').html(data.data.address);
            jQuery('#fds-order-type-block').html(data.data.order_type);
            var msg_rand = Math.floor(Math.random() * 1000000) + 1;
            jQuery.ajax({
                type: "get",
                dataType: 'json',
                url: google_map_vars.site_url + 'wp/v1/restaurants-delivery-check',                
                success: function(res){                   
                    this_prent.find('.fds-loader-holder').remove();  
                    if(res==true){
                        foodsearch_modal_popup_close();                    
                       foodsearch_submit_msg_alert('alert-msg-' + msg_rand, 'Address Updated', 'fds-alert-success');
                    }
                    else{
                        foodsearch_submit_msg_alert('alert-msg-' + msg_rand, 'This resturent is not deliverd to you addredd', 'fds-alert-danger');
                    }
                }
            });

        }
    });
})

jQuery(document).on('click', '.fds-addres-change', function() {
    //  alert('hi');
      foodsearch_modal_popup_open('fds-location-mpopup');
      var marker_lat = jQuery('.fds-location-popup-filed').find('input.fds-map-lat-field').val();
      var marker_lng = jQuery('.fds-location-popup-filed').find('input.fds-map-lng-field').val();
      var adrs = jQuery('.fds-location-popup-filed').find('input.fds-map-adr-field').val();
      var map_zoom = 10;
      foodsearch_set_map_latlng_marker(marker_lat, marker_lng, map_zoom);
      jQuery('.fds-loc-address-field').val(adrs);
      
  });
  jQuery(document).on('click', '.fds-addres-change-resturant', function() {
      //  alert('hi');
        foodsearch_modal_popup_open('fds-location-mpopup');
        var marker_lat = jQuery('.fds-location-popup-filed').find('input.fds-map-lat-field').val();
        var marker_lng = jQuery('.fds-location-popup-filed').find('input.fds-map-lng-field').val();
        var adrs = jQuery('.fds-location-popup-filed').find('input.fds-map-adr-field').val();
        var map_zoom = 10;
        jQuery('.update-popup-location').addClass('update-popup-res-location').removeClass('update-popup-location');
        foodsearch_set_map_latlng_marker(marker_lat, marker_lng, map_zoom);
        jQuery('.fds-loc-address-field').val(adrs);
        
    });
  
    var foodsearch_geoloc_curr_request; 
function foodsearch_set_map_latlng_marker(lat, lng, zoom) {
    "use strict";
   
    var loc_maps = google_map_vars.loc_maps;
    var loc_map_type = google_map_vars.maps_type;
    var mapbox_api_key = google_map_vars.mapbox_api;
    var mapbox_style = google_map_vars.mapbox_style;
    
    lat = parseFloat(lat);
    lng = parseFloat(lng);
    zoom = zoom > 0 ? parseInt(zoom) : zoom;
    console.log('loc_maps: '+str);
    if (loc_maps == 'on') {
               
       
            var pos = {
                lat: parseFloat(lat),
                lng: parseFloat(lng)
            };
           
            console.log(pos);
            foodsearch__map.setCenter(lat,lng,zoom);
            foodsearch__map.setZoom(24);
            document.querySelector('.fds-map-lat-field').value = lat;
            document.querySelector('.fds-map-lng-field').value = lng;

            // clear previous markers
            for (var i = 0; i < foodsearch_map_markers.length; i++) {
                foodsearch_map_markers[i].setMap(null);
            }

            var marker = new google.maps.Marker({
                map: foodsearch__map,
                position: pos,
                draggable: true,
            });
            marker.setPosition(pos);
            map.setCenter(pos);
            
            currentloc(marker);
           //  var str = JSON.stringify(marker);
          
            foodsearch_map_markers.push(marker);
            foodsearch_map_markers.getCenter()
            google.maps.event.addListener(marker, 'dragend', function () {
                document.querySelector('.fds-map-lat-field').value = this.getPosition().lat();
                document.querySelector('.fds-map-lng-field').value = this.getPosition().lng();
                foodsearch_get_map_cords_addres(this.getPosition().lat, this.getPosition().lng);
            });
        }
   // }
}
function currentloc(marker){       
    latlng = marker.getPosition();
    url = 'https://maps.googleapis.com/maps/api/geocode/json?latlng='+ latlng.lat() + ',' + latlng.lng() + '&sensor=false';
    console.log(url);
    $.get(url, function(data) {
       // if (data.status == 'OK') {
            map.setCenter(data.results[0].geometry.location);                
          //  if (confirm('Do you also want to change location text to ' + data.results[0].formatted_address) === true) {
               // $('#searchmap').val(data.results[0].formatted_address);
                
                jQuery('.fds-loc-address-field').val(data.results[0].formatted_address);
                document.querySelector('.fds-map-lat-field').value = data.results[0].geometry.location.lat;
                document.querySelector('.fds-map-lng-field').value = data.results[0].geometry.location.lng;
                // $('#lat').val(data.results[0].geometry.location.lat);
                // $('#lng').val(data.results[0].geometry.location.lng);
           // }
        //}
    });   
}