var foodsearch__map, infoWindow,foodsearch_geoloc_curr_request; 
var foodsearch_map_markers = [];


jQuery(document).ready(function() {    
    foodsearch__map_render();
});
"use strict"; 
function foodsearch__map_render(lat = '',lng = '') {
    
    if (jQuery('.fds-location-map-outer').length > 0) {
        var map_parent_con = jQuery('.fds-location-map-outer');
        var rand_id = map_parent_con.attr('data-id');
        var zoom = parseInt(google_map_vars.zoom);
        if(lat!='' && lng !=''){
            var def_lat = parseFloat(lat);
            var def_lng = parseFloat(lng);
        }
        else{
            var def_lat = parseFloat(google_map_vars.lat);
            var def_lng = parseFloat(google_map_vars.lng);
        }
        
        var map_lat_lng = {lat: def_lat, lng: def_lng};
        foodsearch__map = new google.maps.Map(document.getElementById('fds-map-' + rand_id), {
            center: {lat: def_lat, lng: def_lng},
            zoom: zoom,
            disableDefaultUI: true,
          });
          infoWindow = new google.maps.InfoWindow;
        
      var marker = new google.maps.Marker({
          map: foodsearch__map,
          draggable: true,
        });
        if(lat!='' && lng !=''){
            var pos = {
                lat: lat,
                lng: lng
              };
            marker.setPosition(pos);
            foodsearch__map.setCenter(pos);
            google.maps.event.addListener(marker, 'dragend', function () {
                foodsearch__map.setCenter(this.getPosition()); // Set map center to marker position
            });
        }
         else{         
          // Try HTML5 geolocation.
          var geocode_did_work = false;
          if (navigator.geolocation) {
            navigator.geolocation.getCurrentPosition(function(position) {
                geocode_did_work = true;
              var pos = {
                lat: position.coords.latitude,
                lng: position.coords.longitude
              };
              marker.setPosition(pos);
              foodsearch__map.setZoom(zoom);    
              foodsearch__map.setCenter(pos);
  
            }, function() {
              handleLocationError(true, infoWindow, foodsearch__map.getCenter());
  
            });
            google.maps.event.addListener(marker, 'dragend', function () {
                foodsearch__map.setZoom(zoom);    
                foodsearch__map.setCenter(this.getPosition()); // Set map center to marker position
            });
  
          } 
          else {
            // Browser doesn't support Geolocation
            handleLocationError(false, infoWindow, foodsearch__map.getCenter());
          }
        }
        var autocomplete_input = document.getElementById('fdsLocAddressField');
        var autcomplete_options = { componentRestrictions: { country: google_map_vars.countries }};
        var autocomplete = new google.maps.places.Autocomplete(autocomplete_input, autcomplete_options);
        
          //var searchBox = new google.maps.places.SearchBox(document.getElementById('fdsLocAddressField'));
            google.maps.event.addListener(autocomplete,'places_changed',function(){
              var places = searchBox.getPlaces();
            
              var bounds = new google.maps.LatLngBounds();
              var i,place;
              for(i=0; place=places[i]; i++){
                bounds.extend(place.geometry.location);
                marker.setPosition(place.geometry.location);
              }
              foodsearch__map.fitBounds(bounds);
              foodsearch__map.setZoom(zoom);    
              document.querySelector('.fds-map-lat-field').value = marker.getPosition().lat();
              document.querySelector('.fds-map-lng-field').value = marker.getPosition().lng();
              foodsearch_get_map_cords_addres(marker.getPosition().lat, marker.getPosition().lng);          
            });
  
  
        google.maps.event.addListener(marker, 'dragend', function () {
            document.querySelector('.fds-map-lat-field').value = this.getPosition().lat();
            document.querySelector('.fds-map-lng-field').value = this.getPosition().lng();
            foodsearch_get_map_cords_addres(this.getPosition().lat, this.getPosition().lng);
        });                      
    }
}
function foodsearch_get_map_cords_addres(lat, lng) {
    "use strict"; 
   
    var this_parent = jQuery('.fds-user-locations');
    this_parent.append('<div class="fds-loader-holder"><div class="fds-loader"></div></div>');
    var geoloc_request = jQuery.ajax({
        type: "POST",
        dataType: "json",
        url: google_map_vars.site_url + 'wp/v1/get-map-cords-addres',
        data: {
            lat: lat,
            lng: lng,
        },            
        beforeSend: function (xhr) {
            if(google_map_vars.adminCheck!='true'){
                xhr.setRequestHeader('X-WP-Nonce', google_map_vars.wpnonce);
           }  
        }
    });
    geoloc_request.done(function (response) {
        if (response.address != '') {
            this_parent.find('.fds-loc-address-field').val(response.address);
            jQuery('.fds-map-adr-field').val(response.address);   
        }
    });
    geoloc_request.always(function () {
        this_parent.find('.fds-loader-holder').remove();
    });
}
jQuery(document).on('click', '.fds-get-current-location', function(ev) {
   
    "use strict";
    ev.preventDefault();
    if (navigator.geolocation) {
        const options = {
            enableHighAccuracy: true,
            timeout: 5000,
            maximumAge: 1
        };
        function foodsearch_geolocation_access_err(error) {
            console.warn('ERROR(' + error.code + '): ' + error.message);
            foodsearch_check_location_latlng();
        }
        navigator.geolocation.getCurrentPosition(foodsearch_set_user_current_locate, foodsearch_geolocation_access_err, options);
    } else {
        console.log("Geolocation is not supported.");
        foodsearch_check_location_latlng();
    }
});
function foodsearch_set_user_current_locate(position) {
    "use strict";
    
    var lat = position.coords.latitude;
    var lng = position.coords.longitude;
        
        var def_zoom = google_map_vars.map_zoom;

        var this_parent = jQuery('.fds-addupd-location');
        var addres_field = this_parent.find('.fds-loc-address-field');
        this_parent.find('.fds-get-current-location').append('<div class="fds-inline-loader"><div class="fds-loader"></div></div>');

        foodsearch_geoloc_curr_request = jQuery.ajax({
            type: "POST",
            dataType: "json",
            url: google_map_vars.site_url + 'wp/v1/get-map-cords-addres',
            data: {
                lat: lat,
                lng: lng,
            },            
            beforeSend: function (xhr) {
                if(google_map_vars.adminCheck!='true'){
                    xhr.setRequestHeader('X-WP-Nonce', google_map_vars.wpnonce);
               }  
            }
        });
        foodsearch_geoloc_curr_request.done(function (response) {
            addres_field.val(response.address).attr('value', response.address);
            jQuery('.fds-map-adr-field').val(response.address);
            foodsearch__map_render(lat,lng);
        });
        foodsearch_geoloc_curr_request.always(function () {
            this_parent.find('.fds-get-current-location').find('.fds-inline-loader').remove();
        });
   
}
function foodsearch_check_location_latlng() {
    "use strict";
    var def_zoom = google_map_vars.map_zoom;
    var request = jQuery.ajax({
        url: "https://ipinfo.io/json",
        dataType: "json"
    });
    request.done(function (result) {
        if (result != null && typeof result.loc !== undefined && result.loc != '') {
            var address = result.city + ' ' + result.country;
            document.querySelector('.fds-loc-address-field').value = address;
            var latlng_str = result.loc;
            var latlng = latlng_str.split(',');
            var lat = latlng[0];
            var lng = latlng[1];
            foodsearch_set_map_latlng_marker(lat, lng, def_zoom);
        } else {
            foodsearch_geoloc_ipinfo_fallback();
        }
    });
    request.fail(function () {
        foodsearch_geoloc_ipinfo_fallback();
    });
}
jQuery(document).on('click','.update-popup-location',function(e){
    "use strict";
    e.preventDefault();
    var _this = jQuery(this);
    var this_prent = _this.parents('.fds-location-popup-open');
    this_prent.append('<div class="fds-loader-holder"><div class="fds-loader"></div></div>');
    jQuery.ajax({
        type: "post",
        dataType: "json",
        url:google_map_vars.site_url + 'wp/v1/update-user-delivery-location',
        data:  {
            lat:this_prent.find('.fds-map-lat-field').val(),
            lng:this_prent.find('.fds-map-lng-field').val(),
            address:this_prent.find('.fds-map-adr-field').val(),
            order_type:_this.attr('data-value'),
        },            
        beforeSend: function (xhr) {
           if(google_map_vars.adminCheck!='true'){
        xhr.setRequestHeader('X-WP-Nonce', google_map_vars.wpnonce);
}  
        },
        success: function(data){
            jQuery('.fds-location-block-wrap').show();
            jQuery('#fds-address-block').html(data.data.address);
            jQuery('#fds-address-block').attr('data-lat',jQuery('.fds-map-lat-field').val());
            jQuery('#fds-address-block').attr('data-lng',jQuery('.fds-map-lng-field').val());
            jQuery('#fds-order-type-block').html(data.data.order_type);
            jQuery.ajax({
                type: "get",
                dataType: 'json',
                url: google_map_vars.site_url + 'wp/v1/call-restaurants',
                data: jQuery('#frm_restaurant_listing').serialize(),
                success: function(res){
                    foodsearch_modal_popup_close();
                    jQuery('#restaurant_area').html(res.html);   
                    this_prent.find('.fds-loader-holder').remove();
                  foodsearch_update_loc( jQuery('#offset').val() );
                }
            });

        }
    });
})
jQuery(document).on('click','.update-popup-res-location',function(){
    "use strict";
    var _this = jQuery(this);
    var this_prent = _this.parents('.fds-location-map-outer');
    this_prent.append('<div class="fds-loader-holder"><div class="fds-loader"></div></div>');
    jQuery.ajax({
        type: "post",
        dataType: "json",
        url:google_map_vars.site_url + 'wp/v1/update-user-delivery-location',
        data:  {
            lat:this_prent.find('.fds-map-lat-field').val(),
            lng:this_prent.find('.fds-map-lng-field').val(),
            address:this_prent.find('.fds-map-adr-field').val(),
            order_type:_this.attr('data-value'),
            resID:this_prent.find('.fds-rest-id-field').val(),
        },            
        beforeSend: function (xhr) {
           if(google_map_vars.adminCheck!='true'){
        xhr.setRequestHeader('X-WP-Nonce', google_map_vars.wpnonce);
}  
        },
        success: function(data){            
            jQuery('.fds-location-block-wrap').show();
            jQuery('#fds-address-block').html(data.data.address);
            jQuery('#fds-order-type-block').html(data.data.order_type);
            var msg_rand = Math.floor(Math.random() * 1000000) + 1;
            jQuery.ajax({
                type: "get",
                dataType: 'json',
                url: google_map_vars.site_url + 'wp/v1/restaurants-delivery-check',                
                success: function(res){                   
                    this_prent.find('.fds-loader-holder').remove();  
                    if(res==true){
                        foodsearch_modal_popup_close();                    
                       foodsearch_submit_msg_alert('alert-msg-' + msg_rand, 'Address Updated', 'fds-alert-success');
                    }
                    else{
                        foodsearch_submit_msg_alert('alert-msg-' + msg_rand, 'This resturent is not deliverd to you addredd', 'fds-alert-danger');
                    }
                }
            });

        }
    });
})
jQuery(document).on('click', '.fds-addres-change-resturant', function() {
    //  alert('hi');
      foodsearch_modal_popup_open('fds-location-mpopup');
      var marker_lat = jQuery(this).attr('data-lat');
      var marker_lng =  jQuery(this).attr('data-lng');
      var adrs = jQuery(this).text();
      if(marker_lat ==''){
        var marker_lat = jQuery('.fds-location-popup-filed').find('input.fds-map-lat-field').val();
        var marker_lng = jQuery('.fds-location-popup-filed').find('input.fds-map-lng-field').val();
        var adrs = jQuery('.fds-location-popup-filed').find('input.fds-map-adr-field').val();
      }
      adrs = adrs.trim();
      var map_zoom = google_map_vars.map_zoom;
      jQuery('.update-popup-location').addClass('update-popup-res-location').removeClass('update-popup-location');
      foodsearch_set_map_latlng_marker(marker_lat, marker_lng, map_zoom);
      jQuery('.fds-loc-address-field').val(adrs);
      
  });
jQuery(document).on('click', '.fds-addres-change', function() {
      foodsearch_modal_popup_open('fds-location-mpopup');
      var marker_lat = jQuery(this).attr('data-lat');
      var marker_lng =  jQuery(this).attr('data-lng');
      var adrs = jQuery(this).text();
      if(marker_lat ==''){
        var marker_lat = jQuery('.fds-location-popup-filed').find('input.fds-map-lat-field').val();
        var marker_lng = jQuery('.fds-location-popup-filed').find('input.fds-map-lng-field').val();
        var adrs = jQuery('.fds-location-popup-filed').find('input.fds-map-adr-field').val();
      }
      adrs = adrs.trim();
      var map_zoom = google_map_vars.map_zoom;
    
      foodsearch_set_map_latlng_marker(marker_lat, marker_lng, map_zoom);
      jQuery('.fds-loc-address-field').val(adrs);
      
  });
function foodsearch_set_map_latlng_marker(lat, lng, zoom) {
    "use strict";
    var def_lat = parseFloat(lat);
    var def_lng = parseFloat(lng);    
    var zoom = zoom > 0 ? parseInt(zoom) : zoom; 
    foodsearch__map_render(def_lat,def_lng);
   
}

jQuery(document).on('click', '.fds-add-loc-triger', function(ev) {
    "use strict";
    ev.preventDefault();
    var _this = jQuery(this);
    var saved_locs_con = _this.parents('.fds-user-locations').find('.fds-saved-locations-list .fds-all-saved-locs');
    //
    saved_locs_con.append('\
    <div class="saved-loc-item savin-new-addres-itm">\
        <span class="address-con"><i class="fds-icon fds-marker-thin"></i> ' + google_map_vars.add_new_loctxt + '</span>\
    </div>');
    
    var form_con = _this.parents('.fds-user-locations').find('.fds-addupd-location');
    
    form_con.find('.fds-locs-hding').removeAttr('style');
    form_con.find('.update-loc-hding').hide();
    form_con.find('.add-location-btn').removeAttr('style');
    form_con.find('.update-location-btn').hide();
    
    //
    if (!form_con.is(':visible')) {
        form_con.removeAttr('style');
        if (form_con.find('.fds-location-map-outer').length > 0) {
            form_con.find('.fds-location-map-outer').addClass('fds-outer-visible');
        }

        // require address field
        form_con.find('input[name="fds_loc_address"]').attr('required', '');
    }
    if (form_con.find('.fds-get-current-location').length > 0) {
        form_con.find('.fds-get-current-location').trigger('click');
    }
    
    if (form_con.find('.fds-loc-id-field').length > 0) {
        form_con.find('.fds-loc-id-field').val('');
    }
    
    var address_field = form_con.find('.fds-loc-address-field');
    
    address_field.val('').attr('value', '');
    form_con.find('.fds-map-lat-field').val('');
    form_con.find('.fds-map-lng-field').val('');
    form_con.find('.fds-address-floor-field').val('');
    form_con.find('.fds-address-notes-field').val('').html('');
    address_field.trigger('focus');
    
    _this.hide();
    
    return false;
});

jQuery(document).on('keypress keyup blur', '.fds-loc-address-field', function () {
    "use strict";
    var _this = jQuery(this);
    if (_this.val() != '') {
        _this.parents('.fds-user-locations').find('.savin-new-addres-itm .address-con').html('<i class="fds-icon fds-marker-thin"></i> ' + _this.val());
    }
});

jQuery(document).on('click', '.fds-edit-user-loc', function(ev) {
    "use strict";
    ev.preventDefault();
    var _this = jQuery(this);
    var loc_id = _this.attr('data-id');
    var n_id = _this.attr('data-nid');
    var this_parent = _this.parents('.fds-user-locations');
    this_parent.find('.fds-add-loc-triger').removeAttr('style');
    this_parent.find('.savin-new-addres-itm').remove();
    var form_con = this_parent.find('.fds-addupd-location');
    var address_field = form_con.find('.fds-loc-address-field');
    this_parent.append('<div class="fds-loader-holder"><div class="fds-loader"></div></div>');
    jQuery('.fds-list-item').removeClass('fds-list-item-active');
    _this.addClass('fds-list-item-active');
    var def_map_zoom = google_map_vars.map_zoom;

    var request = jQuery.ajax({
        type: "POST",
        dataType: "json",
        url: google_map_vars.site_url + 'wp/v1/foodsearch-edit-loc-form',
        data: {
            loc_id: loc_id,
            nid: n_id,
        },            
        beforeSend: function (xhr) {
            if(google_map_vars.adminCheck!='true'){
                xhr.setRequestHeader('X-WP-Nonce', google_map_vars.wpnonce);
           }  
        }
    });
    request.done(function (response) {
        form_con.find('.fds-locs-hding').hide();
        form_con.find('.update-loc-hding').removeAttr('style');
        form_con.find('.add-location-btn').hide();
        form_con.find('.update-location-btn').removeAttr('style').attr('data-id', loc_id);

        address_field.val(response.address).attr('value', response.address);
        jQuery('.fds-loc-address-field').val(response.address);
        jQuery('.fds-map-adr-field').val(response.address);
        form_con.find('.fds-map-lat-field').val(response.lat);
        form_con.find('.fds-map-lng-field').val(response.lng);
        form_con.find('.fds-address-floor-field').val(response.floor_unit);
        form_con.find('.fds-address-notes-field').val(response.notes);
        
        if (form_con.find('.fds-loc-id-field').length > 0) {
            form_con.find('.fds-loc-id-field').val(loc_id);
        }
        
        form_con.find('.fds-addres-labl-other').val(response.label_other);
      
        var adres_labl = response.label != '' && response.label != null ? response.label : 'home';
        form_con.find('input[class=fds-addres-labl-field]').parents('.labl-itm').removeClass('active-labl');        
        form_con.find('input[class=fds-addres-labl-field]').parents('.labl-itm').find('i.fds-icon').removeAttr('style');
        form_con.find('input[class=fds-addres-labl-field][value=' + adres_labl  + ']').parents('.labl-itm').addClass('active-labl');
        form_con.find('input[class=fds-addres-labl-field][value=' + adres_labl  + ']').find('i.fds-icon').css({'background-color': 'rgb(228, 42, 69)','color': 'rgb(255, 255, 255'});
        form_con.find('input[class=fds-addres-labl-field][value=' + adres_labl  + ']').attr('checked', 'checked').trigger('click');

        if (!form_con.is(':visible')) {
            form_con.removeAttr('style');
            if (form_con.find('.fds-location-map-outer').length > 0) {
                form_con.find('.fds-location-map-outer').addClass('fds-outer-visible');
            }

            // require address field
            form_con.find('input[name="fds_loc_address"]').attr('required', '');
        }
        
        var marker_lat = response.lat;
        var marker_lng = response.lng;
        foodsearch_set_map_latlng_marker(marker_lat, marker_lng, def_map_zoom);
        
        //address_field.trigger('focus');
    });
    request.always(function () {
        this_parent.find('.fds-loader-holder').remove();
    });
    
    return false;
});

jQuery(document).on('click', '.fds-remove-user-loc', function(ev) {
    "use strict";
    ev.preventDefault();
    var _this = jQuery(this);
    var loc_id = _this.attr('data-id');
    var n_id = _this.attr('data-nid');
    var this_parent = _this.parents('.fds-user-locations');
    
    jQuery.fds_confirm_popup({
        message: google_map_vars.delete_msg,
        buttons: {
            Yes: {
                class: 'fds-accept-btn',
                action: function () {
                    
                    this_parent.append('<div class="fds-loader-holder"><div class="fds-loader"></div></div>');
                    var request = jQuery.ajax({
                        type: "POST",
                        dataType: "json",
                        url: google_map_vars.site_url + 'wp/v1/foodsearch-remove-user-location',
                        data: {
                            loc_id: loc_id,
                            n_id: n_id
                        },            
                        beforeSend: function (xhr) {
                            if(google_map_vars.adminCheck!='true'){
                                xhr.setRequestHeader('X-WP-Nonce', google_map_vars.wpnonce);
                           }  
                        }
                    });
                    request.done(function (response) {

                        var msg_rand = Math.floor(Math.random() * 1000000) + 1;
                        if (response.error == '0') {
                            foodsearch_submit_msg_alert('alert-msg-' + msg_rand, response.msg, 'fds-alert-success');
                            jQuery('#loc-adress-itm-' + loc_id).remove();
                        } else if (response.error == '2') {
                            foodsearch_submit_msg_alert('alert-msg-' + msg_rand, response.msg, 'alert-warning');
                        } else {
                            foodsearch_submit_msg_alert('alert-msg-' + msg_rand, response.msg, 'fds-alert-danger');
                        }
                    });
                    request.always(function () {
                        this_parent.find('.fds-loader-holder').remove();
                    });
                    jQuery.fds_confirm_popup.hide();
                },
            },
            No: {
                class: 'fds-decline-btn',
                action: function () {
                    jQuery.fds_confirm_popup.hide();
                }
            }
        }
    });
});
jQuery(document).on('change', '.fds-addres-labl-field', function() {
    "use strict";
    var _this = jQuery(this);
    var this_prent = _this.parents('.addres-labels-con');
    this_prent.find('.labl-itm').removeClass('active-labl');
    this_prent.find('.labl-itm').find('i').removeAttr('style');
    _this.parents('.labl-itm').addClass('active-labl').find('i').css({'background-color':'#e42a45','color': '#ffffff'});
    if (_this.val() == 'other') {
        this_prent.find('.other-label-text').removeAttr('style');
    } else {
        this_prent.find('.other-label-text').hide();
    }
});

jQuery(document).on('click', '.update-location-btn', function() {
    "use strict";
    var _this = jQuery(this);
    var loc_id = _this.attr('data-id');
    var this_parent = _this.parents('.fds-addupd-location');
    this_parent.append('<div class="fds-loader-holder"><div class="fds-loader"></div></div>');

    var form_data = this_parent.find('input,textarea').serialize() + '&id=' + loc_id;

    var request = jQuery.ajax({
        type: "POST",
        dataType: "json",
        url: google_map_vars.site_url + 'wp/v1/foodsearch-update-user-location',
        data: form_data,            
        beforeSend: function (xhr) {
            if(google_map_vars.adminCheck!='true'){
                xhr.setRequestHeader('X-WP-Nonce', google_map_vars.wpnonce);
           }  
        }
    });
    request.done(function (response) {

        var msg_rand = Math.floor(Math.random() * 1000000) + 1;
        if (response.error == '0') {
            foodsearch_submit_msg_alert('alert-msg-' + msg_rand, response.msg, 'fds-alert-success');
            this_parent.hide();
            jQuery.ajax({
                type: "post",
                dataType: "json",
                url:google_map_vars.site_url + 'wp/v1/foodsearch-saved-location-list',
                data:  {
                    pid:response.post_id,
                },            
                beforeSend: function (xhr) {
                   if(google_map_vars.adminCheck!='true'){
                xhr.setRequestHeader('X-WP-Nonce', google_map_vars.wpnonce);
}  
                },
                success: function(data){
                    jQuery('.fds-all-saved-locs').html(data.html);

                }
            });
           
        } else if (response.error == '2') {
            foodsearch_submit_msg_alert('alert-msg-' + msg_rand, response.msg, 'alert-warning');
        } else {
            foodsearch_submit_msg_alert('alert-msg-' + msg_rand, response.msg, 'fds-alert-danger');
        }
    });
    request.always(function () {
        this_parent.find('.fds-loader-holder').remove();
    });
});

jQuery(document).on('click', '.add-location-btn', function() {
    "use strict";
    var _this = jQuery(this);
    var upper_appnder_con = _this.parents('.fds-user-locations').find('.fds-saved-locations-list');
    var appendr_locs_con = _this.parents('.fds-user-locations').find('.fds-saved-locations-list .fds-all-saved-locs');
    var this_parent = _this.parents('.fds-addupd-location');
    var address_field = this_parent.find('.fds-loc-address-field');
    this_parent.append('<div class="fds-loader-holder"><div class="fds-loader"></div></div>');

    var form_data = this_parent.find('input,textarea').serialize();

    var request = jQuery.ajax({
        type: "POST",
        dataType: "json",
        url: google_map_vars.site_url + 'wp/v1/foodsearch-add-user-location',
        data: form_data,            
        beforeSend: function (xhr) {
            if(google_map_vars.adminCheck!='true'){
                xhr.setRequestHeader('X-WP-Nonce', google_map_vars.wpnonce);
           }  
        }
    });
    request.done(function (response) {

        var msg_rand = Math.floor(Math.random() * 1000000) + 1;
        if (response.error == '0') {
            foodsearch_submit_msg_alert('alert-msg-' + msg_rand, response.msg, 'fds-alert-success');
            address_field.val('').attr('value', '');
            appendr_locs_con.find('.savin-new-addres-itm').remove();
            //appendr_locs_con.append(response.html);
            appendr_locs_con.removeAttr('style');
            upper_appnder_con.find('.fds-add-loc-triger').removeAttr('style');
            this_parent.hide();
            jQuery.ajax({
                type: "post",
                dataType: "json",
                url:google_map_vars.site_url + 'wp/v1/foodsearch-saved-location-list',
                data:  {
                    pid:response.post_id,
                },            
                beforeSend: function (xhr) {
                   if(google_map_vars.adminCheck!='true'){
                        xhr.setRequestHeader('X-WP-Nonce', google_map_vars.wpnonce);
                    }  
                },
                success: function(data){
                    appendr_locs_con.html(data.html);

                }
            });
        } else if (response.error == '2') {
            foodsearch_submit_msg_alert('alert-msg-' + msg_rand, response.msg, 'fds-alert-info');
        } else {
            foodsearch_submit_msg_alert('alert-msg-' + msg_rand, response.msg, 'fds-alert-danger');
        }
    });
    request.always(function () {
        this_parent.find('.fds-loader-holder').remove();
    });
});

jQuery(document).on('focusout','.fds-loc-address-field',function (e) {
    let text = jQuery(this).val();
    let text2 = jQuery('input.fds-map-adr-field').val();  
    setTimeout(function(text,text2){   
        if(text!==text2){  
     jQuery.ajax({
         type: "post",
         dataType: "json",
         url:google_map_vars.site_url + 'wp/v1/get-location-lat-lng-on-address',
         data:  {
             address:jQuery('.fds-loc-address-field').val(),
         },            
         beforeSend: function (xhr) {
         
         if(google_map_vars.adminCheck!='true'){
                 xhr.setRequestHeader('X-WP-Nonce', google_map_vars.wpnonce);
         }  
         },
         success: function(data){
             var def_zoom = google_map_vars.map_zoom;
             jQuery('.fds-map-adr-field').val(data.address);
             jQuery('.fds-loc-address-field').val(data.address);
         if(data.lat==''){
             foodsearch_check_location_latlng();
         }
         else{
 
             foodsearch_set_map_latlng_marker(data.lat, data.lng, def_zoom);
         }
 
         }
     });
    }
    }, 1000,text,text2);    
})