<?php

namespace FoodSearch\Dashboard\Common;

class Change_Password {
    
    public function __construct() {
        
        add_filter('foodsearch_restaurant_dash_change_password_html', [$this, 'content'], 10, 4);
        add_filter('foodsearch_customer_dash_change_password_html', [$this, 'content'], 10, 4);
    }
    
    public function content($html, $menu_data, $section_key, $element_key) {
        
        $element_data = $menu_data['sections'][$section_key]['elements'][$element_key];
        
        $user_id = get_current_user_id();
        
        ob_start();
        ?>
        <form method="post" class="fds-common-form dashboard-changpass-form fds-update-anything-action">
            <div class="fds-dashform-field fds-form-field fds-field-thirdcalc">
                <div class="label_wrap"><label class="fds-input-label"><?php esc_html_e('current password', 'wp-foodsearch') ?> *</label></div>
                <input type="password" class="fds-input-style" name="fds_current_pass" required placeholder="************">
                <a class="fds-show-userpass fds-link"><i class="fds-icon fds-eye-line"></i></a>
            </div>
            <div class="fds-dashform-field fds-form-field fds-field-thirdcalc">
                <div class="label_wrap"><label class="fds-input-label"><?php esc_html_e('new password', 'wp-foodsearch') ?> *</label></div>
                <input type="password" class="fds-input-style" name="fds_new_pass" required placeholder="************">
                <a class="fds-show-userpass fds-link"><i class="fds-icon fds-eye-line"></i></a>
            </div>
            <div class="fds-dashform-field fds-form-field fds-field-thirdcalc">
                <div class="label_wrap"><label class="fds-input-label"><?php esc_html_e('confirm new password', 'wp-foodsearch') ?> *</label></div>
                <input type="password" class="fds-input-style" name="fds_confnew_pass" required placeholder="************">
                <a class="fds-show-userpass fds-link"><i class="fds-icon fds-eye-line"></i></a>
            </div>
            <div class="fds-dashform-field fds-field-fullcalc">
                <div class="fds-loader-holder" style="display:none;"></div>
                <div class="fds-submitbtn-con">
                    <input type="hidden" name="fds_nonce_id" value="<?php echo ($user_id) ?>">
                    <?php
                    wp_nonce_field('ajax-settings-nonce', 'change-password');
                    ?>
                    <div class="fds-btn fds-medium-btn">
                        <input type="submit" class="fds-has-bg" value="<?php esc_html_e('change password', 'wp-foodsearch') ?>">
                    </div>
                </div>
            </div>
        </form>
        <?php
        $html = ob_get_clean();

        return $html;
    }

}

new Change_Password;
