<?php

namespace FoodSearch\Dashboard\Customer;

use FoodSearch\Common_Functions;
use FoodSearch\User_Reviews;

class Reviews {
    
    public function __construct() {
        
        add_filter('foodsearch_customer_dash_reviews_html', [$this, 'content'], 10, 4);
    }
    
    public function content($html, $menu_data, $section_key, $element_key) {
        
        $common_functions = new Common_Functions;
        $reviews = new User_Reviews;
        
        $user_id = get_current_user_id();
        
        $customer_id = Common_Functions::user_customer_id($user_id);
        
        $com_args = array(
            'user_id' => $user_id,
            'parent' => 0,
            'status' => 'approve',
        );
        $all_comments = get_comments($com_args);
        
        ob_start();
        if (!empty($all_comments)) {
            ?>
            <div class="fds-dashboard-reviews-wrap">
                <div class="fds-dashboard-reviews-list">
                    <ul class="fds-options-wrap">
                        <?php
                        foreach ($all_comments as $r_comment) {
                            $com_post_id = $r_comment->comment_post_ID;
                            $reviews->reviews_list_item($r_comment, $com_post_id);
                        }
                        ?>
                    </ul>
                </div>
            </div>
            <?php
        } else {
            ?>
            <div class="foodsearch-noitm-found">
                <img src="<?php echo foodsearch_plugin_get_url('assets/images/not-found.svg') ?>" alt="">
                <p><?php esc_html_e('no record found.', 'wp-foodsearch') ?></p>
            </div>
            <?php
        }
        $html = ob_get_clean();
        
        return $html;
    }

}

new Reviews;
