<?php

namespace FoodSearch\Dashboard\Restaurant;
use FoodSearch\Common_Functions;

class Nutritions {
    
    public function __construct() {
        
        add_action('wp_enqueue_scripts', [$this, 'style_scripts']);
        
        add_filter('foodsearch_restaurant_dash_nutritions_html', [$this, 'content'], 10, 4);
    }
    
    public function style_scripts() {
        
    }
    
    public function content($html, $menu_data, $section_key, $element_key) {
        
        wp_enqueue_script('menu_builder_script');
        
        $user_id = get_current_user_id();
        
        $common_functions = new Common_Functions;
        $restaurant_id = Common_Functions::user_restaurant_id($user_id);
        
        $nutritions_list = get_post_meta($restaurant_id, 'foodsearch_nutritions_list', true);
        
        ob_start();
        ?>
        <div id="fds-restaurant-nutris-list" class="fds-multi-listcon">
            <?php
            if (!empty($nutritions_list)) {
                foreach ($nutritions_list as $nutri_key => $nutrition_itm) {
                    $nutri_title = $nutrition_itm['title'];
                    $nutri_img = $nutrition_itm['image'];
                    $image_thumb = wp_get_attachment_image_src($nutri_img, 'thumbnail');
                    $img_src = isset($image_thumb[0]) ? $image_thumb[0] : '';
                    ?>
                    <div id="nutri-item-<?php echo ($nutri_key) ?>" class="multi-list-itm">
                        <div class="itm-titl-img">
                            <div class="fds-item-thumb"><img src="<?php echo ($img_src) ?>" alt=""></div>
                            <strong class="fds-item-title"><?php echo ($nutri_title) ?></strong>
                        </div>

                        <div class="fds-menu-ations">
                            <a href="javascript:void(0);" class="fds-body-action fds-updte-nutribtn fds-link" data-id="<?php echo ($nutri_key) ?>" data-nid="<?php echo ($user_id) ?>" data-rid="<?php echo ($restaurant_id) ?>"><i class="fds-icon fds-edit"></i></a>
                            <a href="javascript:void(0);" class="fds-body-action fds-remove-action fds-remove-nutribtn fds-link" data-id="<?php echo ($nutri_key) ?>" data-rid="<?php echo ($restaurant_id) ?>"><i class="fds-icon fds-time-simple"></i></a>
                        </div>
                    </div>
                    <?php
                }
            }
            ?>
        </div>
        <div class="fds-menu-builder-empty have-menus-btncon">
            <div class="fds-btn fds-medium-btn">
                <a href="javascript:void(0);" class="fds-addnutrition-inlist fds-has-bg fds-link" data-id="<?php echo ($restaurant_id) ?>" data-nid="<?php echo ($user_id) ?>"><i class="fds-icon fds-writing"></i> <?php esc_html_e('add new item', 'wp-foodsearch') ?></a>
            </div>
        </div>
        <?php
        $html = ob_get_clean();

        add_action('wp_footer', function() {
            ?>
            <div id="restaurant-nutrition-popup" class="fds-modal-popup fds-popup-hide fds-nutrition-modal">
                <div class="fds-modal-container">
                    <a href="javascript:void(0);" class="fds-popup-closebtn fds-link"><i class="fds-icon fds-time-simple"></i></a>
                    <div class="fds-modal-inner-area">
                        <div class="fds-modal-content-area">
                            <div class="fds-dynm-modal-content">
                                <div class="fds-loader-holder"><div class="fds-loader"></div></div>
                            </div>
                        </div>
                    </div>
                </div>
            </div>
            <?php
        }, 20);
        
        return $html;
    }

}

new Nutritions;
