<?php

namespace FoodSearch\Dashboard;

class Submit_Actions {
    
    public function __construct() {
        if (!empty($_REQUEST['fds_get_type'])) {
            add_action('wp_loaded', array($this, 'process_ajax'), 9);
        }
    }

    public static function verify_nonce($post_key, $nonce_key) {
        if (defined("WP_CACHE")) {
            return true;
        }

        if (!isset($_POST[$post_key]) || !wp_verify_nonce($_POST[$post_key], $nonce_key)) {
            wp_send_json(array('msg' => esc_html__('session token has expired, please reload the page and try again.', 'wp-foodsearch'), 'error' => '2'));
        }
    }
    
    public function process_ajax() {

        add_action('wp_ajax_nopriv_foodsearch_get_user_img', array($this, 'get_user_img'));

        if ( !empty($_REQUEST['fds_get_type']) ) {
            $ajax_action = sanitize_key($_REQUEST['fds_get_type']);

            define("FOODSEARCH_IS_AJAX", true);

            do_action('wp_ajax_nopriv_' . $ajax_action);
            die();
        }
    }
    
    public function get_user_img() {
        
        $user_id = $_REQUEST['id'];
        
        $img_data = get_user_meta($user_id, 'foodsearch_user_img_data', true);
        
        $file_path = $img_data['path'];
        $file_name = $img_data['file_name'];
        
        $check_mime = wp_check_filetype($file_name);
        $file_mimetype = $check_mime['type'];
        
        header('Content-Description: File Transfer');
        header('Content-Type: ' . $file_mimetype);
        header("Content-type: application/force-download");
        header('Content-Disposition: attachment; filename="' . basename($file_path) . '"');
        header('Content-Transfer-Encoding: Binary');
        header('Expires: 0');
        header('Cache-Control: must-revalidate, post-check=0, pre-check=0');
        header('Pragma: public');
        header('Content-Length: ' . filesize($file_path));

        //
        @readfile($file_path);
        exit;
    }

}

new Submit_Actions;
