<?php
/**
 * Created by PhpStorm.
 * User: pc-int3
 * Date: 6/14/2021
 * Time: 6:05 PM
 */

function foodsearch_esc_the_input($input) {
    if ($input != '') {
        $input = wp_kses($input, array());
        $input = str_replace(array('"', "='", '="', 'alert(', '<script'), array('', '', '', '', ''), $input);
    }
    return $input;
}

function foodsearch_inhereted_array_field_validation($input) {
    if (is_array($input)) {
        $new_valid_input = array();
        if (!empty($input)) {
            foreach ($input as $input_key => $input_val) {
                if (is_array($input_val)) {
                    $new_valid_input[$input_key] = $input_val;
                } else {
                    $new_valid_input[$input_key] = foodsearch_esc_the_input($input_val);
                }
            }
        }
        return $new_valid_input;
    }
    return $input;
}

function foodsearch_esc_html($input)
{
    if (is_array($input)) {
        $new_valid_input = array();
        if (!empty($input)) {
            foreach ($input as $input_key => $input_val) {
                if (is_array($input_val)) {
                    $new_valid_input[$input_key] = foodsearch_inhereted_array_field_validation($input_val);
                } else {
                    $new_valid_input[$input_key] = foodsearch_esc_the_input($input_val);
                }
            }
        }
        return $new_valid_input;
    } else {
        if ($input != '') {
            $input = foodsearch_esc_the_input($input);
        }
    }
    return $input;
}
function in_array_r($needle, $haystack, $strict = false) {
    foreach ($haystack as $item) {
        if (($strict ? $item === $needle : $item == $needle) || (is_array($item) && in_array_r($needle, $item, $strict))) {
            return true;
        }
    }
    return false;
}
function foodsearch_esc_the_textarea($input) {
    $allowed_tags = array();

    $allowed_atts = array(
        'align' => array(),
        'class' => array(),
        'type' => array(),
        'id' => array(),
        'style' => array(),
        'src' => array(),
        'alt' => array(),
        'href' => array(),
        'rel' => array(),
        'target' => array(),
        'width' => array(),
        'height' => array(),
        'title' => array(),
        'data' => array(),
    );
    $allowed_tags['form'] = $allowed_atts;
    $allowed_tags['label'] = $allowed_atts;
    $allowed_tags['input'] = $allowed_atts;
    $allowed_tags['textarea'] = $allowed_atts;
    $allowed_tags['iframe'] = $allowed_atts;
    $allowed_tags['style'] = $allowed_atts;
    $allowed_tags['strong'] = $allowed_atts;
    $allowed_tags['small'] = $allowed_atts;
    $allowed_tags['table'] = $allowed_atts;
    $allowed_tags['span'] = $allowed_atts;
    $allowed_tags['abbr'] = $allowed_atts;
    $allowed_tags['code'] = $allowed_atts;
    $allowed_tags['pre'] = $allowed_atts;
    $allowed_tags['div'] = $allowed_atts;
    $allowed_tags['img'] = $allowed_atts;
    $allowed_tags['h1'] = $allowed_atts;
    $allowed_tags['h2'] = $allowed_atts;
    $allowed_tags['h3'] = $allowed_atts;
    $allowed_tags['h4'] = $allowed_atts;
    $allowed_tags['h5'] = $allowed_atts;
    $allowed_tags['h6'] = $allowed_atts;
    $allowed_tags['ol'] = $allowed_atts;
    $allowed_tags['ul'] = $allowed_atts;
    $allowed_tags['li'] = $allowed_atts;
    $allowed_tags['em'] = $allowed_atts;
    $allowed_tags['hr'] = $allowed_atts;
    $allowed_tags['br'] = $allowed_atts;
    $allowed_tags['tr'] = $allowed_atts;
    $allowed_tags['td'] = $allowed_atts;
    $allowed_tags['p'] = $allowed_atts;
    $allowed_tags['a'] = $allowed_atts;
    $allowed_tags['b'] = $allowed_atts;
    $allowed_tags['i'] = $allowed_atts;

    if ($input != '') {
        $input = wp_kses($input, $allowed_tags);
        $input = str_replace(array('alert(', '<script'), array('', ''), $input);
    }
    return $input;
}

function foodsearch_esc_wp_editor($input) {
    if (is_array($input)) {
        $new_valid_input = array();
        if (!empty($input)) {
            foreach ($input as $input_key => $input_val) {
                if (is_array($input_val)) {
                    $new_valid_input[$input_key] = ($input_val);
                } else {
                    $new_valid_input[$input_key] = foodsearch_esc_the_textarea($input_val);
                }
            }
        }
        return $new_valid_input;
    } else {
        $input = foodsearch_esc_the_textarea($input);
    }
    return $input;
}

function foodsearch_template_path() {
    return apply_filters('foodsearch_plugin_template_path', 'wp-foodsearch/');
}

function foodsearch_get_template_part($slug = '', $name = '', $ext_template = '') {
    $template = '';

    if ($ext_template != '') {
        $ext_template = trailingslashit($ext_template);
    }
    if ($name) {
        $template = locate_template(array("{$slug}-{$name}.php", foodsearch_template_path() . "{$ext_template}{$slug}-{$name}.php"));
    }

    if (!$template && $name && file_exists(foodsearch_plugin_get_path() . 'templates/' . "{$ext_template}{$slug}-{$name}.php")) {
        $template = foodsearch_plugin_get_path() . 'templates/' . "{$ext_template}{$slug}-{$name}.php";
    }

    if (!$template) {
        $template = locate_template(array("{$slug}.php", foodsearch_template_path() . "{$ext_template}{$slug}.php"));
    }

    if ($template) {
        load_template($template, false);
    }
}

function foodsearch_public_upload_files_path($dir = '') {
    global $foodsearch_upload_files_extpath, $foodsearch_upload_subdir_extpath;

    $ext_subdir = $foodsearch_upload_subdir_extpath != '' ? '/' . $foodsearch_upload_subdir_extpath : '';
    
    $cus_dir = 'wp-foodsearch' . ($foodsearch_upload_files_extpath != '' ? '/' . $foodsearch_upload_files_extpath : '');
    
    $sub_dir = isset($dir['subdir']) && $dir['subdir'] != '' ? $dir['subdir'] : '';
    $dir_path = array(
        'path' => $dir['basedir'] . '/' . $cus_dir . $sub_dir . $ext_subdir,
        'url' => $dir['baseurl'] . '/' . $cus_dir . $sub_dir . $ext_subdir,
        'subdir' => (isset($dir['subdir']) && $dir['subdir'] != '' ? $dir['subdir'] . $ext_subdir : $cus_dir . $ext_subdir),
    );
    return $dir_path + $dir;
}

add_action('init', 'foodsearch_set_public_folder_access',10);

function foodsearch_set_public_folder_access() {
    
    require_once(ABSPATH . 'wp-admin/includes/file.php');
    WP_Filesystem();
    global $wp_filesystem;

    add_filter('upload_dir', 'foodsearch_public_upload_files_path');
    $wp_upload_dir = wp_upload_dir();
    $files_dir = $wp_upload_dir['path'] . '/';

    remove_filter('upload_dir', 'foodsearch_public_upload_files_path');
}

function foodsearch_menuItemNameByID($id)
{
    global $table_prefix, $wpdb;
    $table_name = $table_prefix . 'menu_items';
    $sql = "SELECT name FROM $table_name where id = {$id}";
    $results = $wpdb->get_results($sql);
    if ($results) {
        return $results[0]->name;
    }
}
function foodsearch_menuItemPriceByID($id) {
    global $wpdb, $table_prefix;
    $table_name = $table_prefix . 'menu_items';
    $results = $wpdb->get_results("SELECT discount_price as dp, price as p FROM $table_name where id=" . $id);
    if ($results) {
        return $results[0]->dp>0?$results[0]->dp:$results[0]->p;
    }
    
}
function foodsearch_variationPriceByPID($id,$type){
    global $wpdb, $table_prefix;
    $table_name = $table_prefix . 'menu_items';
    $results = $wpdb->get_results("SELECT variations FROM $table_name where id=" . $id);
    if ($results) {
        $variations = json_decode($results[0]->variations,true);
        foreach($variations as $variation){
            if($variation['variation_name']==$type){
                return $variation['variation_price'];
            }
        }
       
    }
    else{
        return '0';
    }
}

function foodsearch_choicegroupPriceByPID($id,$cgid){
    global $wpdb, $table_prefix;
    $menuitems = [];
    $table_name = $table_prefix . 'menu_items';
    $sql = "SELECT * FROM $table_name where id = {$id} AND status=2";
    $results = $wpdb->get_results($sql);
    if (!empty($results)) {
        foreach ($results as $res) {
            $menuitems[] = $res;
        }
        foreach ($menuitems as $menuitem) {
        $choice_groups_id = explode(',', $menuitem->choice_groups_id);
            foreach ($choice_groups_id as $key => $choice_group) {
                $table_name = $table_prefix . 'menu_choice_group';
                $sql = "SELECT * FROM $table_name where id = {$choice_group}";
                $results = $wpdb->get_results($sql);
                foreach ($results as $choice) {
                    $items = json_decode($choice->menuItem_id, true);
                    foreach ($items as $key => $item) {
                        if($item['item_id']==$cgid){
                            return $item['item_price'];
                        }
                        
                    }
                }
            }
        }
    }
    else{
        return '0';
    }
}

function foodsearch_getampmtime($time){
    return date('h:i a',strtotime($time));
}

function foodsearch_in_array($needle, $haystack, $strict = false) {
    foreach ($haystack as $item) {
        if (($strict ? $item === $needle : $item == $needle) || (is_array($item) && foodsearch_in_array($needle, $item, $strict))) {
            return true;
        }
    }
    return false;
}

function foodsearch_restaurant_logo_url($user_id, $restaurant_id) {
    $logo_url = get_avatar_url($user_id, array('size' => 200));
    $img_thumb_id = get_post_thumbnail_id($restaurant_id);
    $user_thumb_image = wp_get_attachment_image_src($img_thumb_id, 'full');
    $img_url = isset($user_thumb_image[0]) && esc_url($user_thumb_image[0]) != '' ? $user_thumb_image[0] : '';
    if ($img_url != '') {
        $logo_url = $img_url;
    }
    
    return $logo_url;
}

add_filter('foodsearch_user_image_file_url', 'foodsearch_user_image_file_url', 10, 2);

function foodsearch_user_image_file_url($img_url, $user_id) {
    
    $img_url = add_query_arg(array('fds_get_type' => 'foodsearch_get_user_img', 'id' => $user_id, 'ver' => rand(10000, 99999)), home_url('/'));
    
    return $img_url;
}

function foodsearch_customer_photo_url($user_id) {
    $photo_url = get_avatar_url($user_id, array('size' => 200));
    
    $img_data = get_user_meta($user_id, 'foodsearch_user_img_data', true);

    if (isset($img_data['path']) && file_exists($img_data['path'])) {
        $img_url = $img_data['url'];
        $photo_url = apply_filters('foodsearch_user_image_file_url', $img_url, $user_id);
    }
    
    return $photo_url;
}

function foodsearch_time_elapsed_string($ptime, $before = '', $after = '', $break_time = false) {

    if ($ptime != '') {
        $b_time = human_time_diff($ptime, current_time('timestamp'));
        if ($break_time === true) {
            $b_time = explode(' ', $b_time);
            $b_time = implode('<br>', $b_time);
        }
        return sprintf(esc_html__('%1$s %2$s ago %3$s', 'wp-foodsearch'), $before, $b_time, $after);
    } else {
        return '';
    }
}

function foodsearch__get_post_id($id_slug, $type = 'page') {
    if ($id_slug != '' && absint($id_slug) <= 0) {
        $post_obj = $id_slug != '' ? get_page_by_path($id_slug, 'OBJECT', $type) : '';
        if (is_object($post_obj) && isset($post_obj->ID)) {
            return $post_obj->ID;
        }
    } else if ($id_slug > 0) {
        return $id_slug;
    }
    return 0;
}

function foodsearch_update_orders_counter ($post_id){
    $count = get_post_meta( $post_id, 'foodsearch_total_orders', true );
    if ( ! $count ) $count = 0;
    $count++;
    update_post_meta( $post_id, 'foodsearch_total_orders', $count );
}

add_action('before_delete_post', 'foodsearch_before_delete_post_actions', 15, 2);

function foodsearch_before_delete_post_actions($post_id, $post) {
    if ($post->post_type == 'restaurants') {
        global $table_prefix, $wpdb;
        
        $menus_table = $table_prefix . 'menus';
        $menu_itms_table = $table_prefix . 'menu_items';
        $menuitm_meta_table = $table_prefix . 'menu_itemmeta';
        $choice_grps_table = $table_prefix . 'menu_choice_group';
        
        //
        $atchmnts_query = "SELECT attachment_id FROM $menu_itms_table WHERE restaurant_id={$post_id}";
        $atchmnts_ids = $wpdb->get_col($atchmnts_query);
        if (isset($atchmnts_ids[0])) {
            foreach ($atchmnts_ids as $atchmnt_id) {
                wp_delete_attachment($atchmnt_id, true);
            }
        }
        
        //
        $nutritions_list = get_post_meta($post_id, 'foodsearch_nutritions_list', true);
        if (!empty($nutritions_list)) {
            foreach ($nutritions_list as $nutri_itm) {
                if (isset($nutri_itm['image']) && $nutri_itm['image'] > 0) {
                    $nutri_attch_id = $nutri_itm['image'];
                    wp_delete_attachment($nutri_attch_id, true);
                }
            }
        }
        
        //
        $wpdb->query("DELETE FROM `{$menuitm_meta_table}` WHERE menu_item_id IN (SELECT id FROM `{$menu_itms_table}` WHERE restaurant_id={$post_id})");
        
        $where = array('restaurant_id' => $post_id);
        
        $wpdb->delete($menu_itms_table, $where);
        
        $wpdb->delete($menus_table, $where);
        
        $wpdb->delete($choice_grps_table, $where);
    }
}

// admin toolbar menus
add_action('admin_bar_menu', 'foodsearch_admin_toolbar_items', 100);

function foodsearch_admin_toolbar_items($admin_bar){
    $admin_bar->add_menu( array(
        'id' => 'fds-foodsearch-plugin',
        'title' => '<span class="ab-icon dashicons-before dashicons-admin-generic"></span> <span class="ab-label">' . esc_html__('FoodSearch', 'wp-foodsearch') . '<span>',
        'href' => admin_url('admin.php?page=foodsearch-plugin-settings'),
        'meta' => array(
            'title' => esc_html__('FoodSearch', 'wp-foodsearch'),
        ),
    ));

    $admin_bar->add_menu( array(
        'id' => 'fds-food-menu',
        'parent' => 'fds-foodsearch-plugin',
        'title' => esc_html__('Food Menus', 'wp-foodsearch'),
        'href' => admin_url('admin.php?page=menus'),
        'meta' => array(
            'title' => esc_html__('Food menus', 'wp-foodsearch'),
        ),
    ));
    $admin_bar->add_menu( array(
        'id' => 'fds-food-menu-items',
        'parent' => 'fds-food-menu',
        'title' => esc_html__('Menu Items', 'wp-foodsearch'),
        'href' => admin_url('admin.php?page=menu-item'),
        'meta' => array(
            'title' => esc_html__('Menu Items', 'wp-foodsearch'),
        ),
    ));
    $admin_bar->add_menu( array(
        'id' => 'fds-food-item-cat',
        'parent' => 'fds-food-menu',
        'title' => esc_html__('Food Item Categories', 'wp-foodsearch'),
        'href' => admin_url('edit-tags.php?taxonomy=food_item_cat&post_type=restaurants'),
        'meta' => array(
            'title' => esc_html__('Food Item Categories', 'wp-foodsearch'),
        ),
    ));
    $admin_bar->add_menu( array(
        'id' => 'fds-food-choice-groups',
        'parent' => 'fds-food-menu',
        'title' => esc_html__('Choice Groups', 'wp-foodsearch'),
        'href' => admin_url('admin.php?page=menu-choice-group'),
        'meta' => array(
            'title' => esc_html__('Choice Groups', 'wp-foodsearch'),
        ),
    ));
    
    //
    $admin_bar->add_menu( array(
        'id' => 'fds-orders',
        'parent' => 'fds-foodsearch-plugin',
        'title' => esc_html__('Orders', 'wp-foodsearch'),
        'href' => admin_url('admin.php?page=fds_orders'),
        'meta' => array(
            'title' => esc_html__('Orders', 'wp-foodsearch'),
        ),
    ));
}

add_action('foodsearch_aftersave_restaurant_taxcats', 'foodsearch_update_restaurant_meta_data', 20);
add_action('foodsearch_aftersave_dashboard_restaurant', 'foodsearch_update_restaurant_meta_data', 20, 3);
add_action('post_updated', 'foodsearch_update_restaurant_meta_data', 99, 3);

function foodsearch_update_restaurant_meta_data($post_id, $post_after = '', $post_before = '') {
    if (get_post_type($post_id) == 'restaurants') {
        
        $tax_arr = [];
        
        $restaurant_itemcats = wp_get_post_terms($post_id, 'food_item_cat', ['fields' => 'names']);
        if (!empty($restaurant_itemcats) && is_array($restaurant_itemcats)) {
            $tax_arr = array_merge($tax_arr, $restaurant_itemcats);
        }
        
        $restaurant_cuisines = wp_get_post_terms($post_id, 'food_cuisine', ['fields' => 'names']);
        if (!empty($restaurant_cuisines) && is_array($restaurant_cuisines)) {
            $tax_arr = array_merge($tax_arr, $restaurant_cuisines);
        }
        
        //
        update_post_meta($post_id, 'restaurant_attached_taxonomies', $tax_arr);
    }
}
function get_saved_location_on_id($id,$itemId = ''){
    global $wpdb,$table_prefix;
    $tblname = 'fds_locations';
    $wp_track_table = $table_prefix . "$tblname";
    if(!empty($itemId)){
        $itemquery = ' id='.$itemId;
    }
    else{
        $itemquery = ' post_id='.$id;
    }
    $sql = 'select * from `'. $wp_track_table . '` where'.$itemquery.' order by id desc';
    $results = $wpdb->get_results($sql,ARRAY_A);
    return $results;  

}
function get_customer_id_by_user_id($id){
    $args = array(
        'author'        =>  $id,
        'post_type'        =>  'customers',
        );
    $current_user_posts = get_posts( $args );
    return $current_user_posts;

}