<?php

namespace FoodSearch;

class User_Media {
    
    public function __construct() {
        add_action('rest_api_init', array($this, 'register_api'), 5);
    }
    
    public function register_api() {

        register_rest_route('wp/v1', 'foodsearch-user-media-load', array(
            'methods' => 'POST',
            'callback' => [$this, 'user_media_popup_open'],
           'permission_callback' =>  'admin_permissions_check',
        ));
        register_rest_route('wp/v1', 'foodsearch-user-media-delete', array(
            'methods' => 'POST',
            'callback' => [$this, 'user_media_delete'],
           'permission_callback' =>  'admin_permissions_check',
        ));
        register_rest_route('wp/v1', 'foodsearch-user-newmedia-upload', array(
            'methods' => 'POST',
            'callback' => [$this, 'user_media_upolad'],
           'permission_callback' =>  'admin_permissions_check',
        ));
        register_rest_route('wp/v1', 'foodsearch-usermedia-load-more', array(
            'methods' => 'POST',
            'callback' => [$this, 'user_media_load_more'],
           'permission_callback' =>  'admin_permissions_check',
        ));
    }
    
    public function user_media_popup_open() {
        
        global $wpdb;

        $user_id = $_POST['nid'];
        $post_id = $_POST['pid'];
        $attach_type = $_POST['apnd_type'];
        $append_id = $_POST['apndid'];
        
        $per_page = 20;
        
        //
        $total_attachments = $wpdb->get_var("SELECT COUNT(*) FROM $wpdb->posts WHERE post_type='attachment' AND post_mime_type LIKE 'image/%' AND post_author=$user_id");
        
        $attachments = $wpdb->get_col("SELECT ID FROM $wpdb->posts WHERE post_type='attachment' AND post_mime_type LIKE 'image/%' AND post_author=$user_id ORDER BY ID DESC LIMIT $per_page");
        
        ob_start();
        ?>
        <div class="fds-usermedia-selection-box" data-nid="<?php echo ($user_id) ?>" data-pid="<?php echo ($post_id) ?>" data-apid="<?php echo ($append_id) ?>" data-aptype="<?php echo ($attach_type) ?>">
            <div class="fds-mediabox-headr">
                <strong class="fds-mediapopup-title"><?php esc_html_e('insert media', 'wp-foodsearch') ?></strong>
                <div class="fds-hdrmedia-insert fds-dohav-media"<?php echo (empty($attachments) ? ' style="display:none;"' : '') ?>>
                    <div class="fds-dashboard-file-upload2">
                        <label for="mhder-insert-btn-<?php echo absint($user_id) ?>" class="fds-upload-btn2 fds-input-label"><?php esc_html_e('upload image', 'wp-foodsearch') ?></label>
                        <input id="mhder-insert-btn-<?php echo absint($user_id) ?>" class="fds-file-upload-input2 fds-update-anything-action" type="file" accept="image/*" name="fds_upload_user_newmedia">
                    </div>
                </div>
            </div>

            <div class="fds-usermedia-uploded fds-dohav-media"<?php echo (empty($attachments) ? ' style="display:none;"' : '') ?>>
                <?php
                if (!empty($attachments)) {
                    ?>
                    <div class="mediauploded-items">
                        <?php
                        foreach ($attachments as $attachment_id) {
                            $img_thumb = wp_get_attachment_image_src($attachment_id, 'thumbnail');
                            $img_src = isset($img_thumb[0]) ? $img_thumb[0] : '';

                            $img_name = $img_src != '' ? basename($img_src) : '';
                            ?>
                            <div class="fds-usermedia-uploditm">
                                <a href="#" class="fds-remove-media fds-link" data-id="<?php echo ($attachment_id) ?>"><i class="fds-icon fds-time-simple"></i></a>
                                <div class="fds-media-selectchk">
                                    <input type="radio" name="insert_media" value="<?php echo ($attach_type == 'url' ? $img_src : $attachment_id) ?>">
                                    <span></span>
                                </div>
                                <div class="fds-media-thumbcon" data-src="<?php echo ($img_src) ?>">
                                    <span class="fds-img-thumb" style="background-image: url(<?php echo ($img_src) ?>)" title="<?php echo ($img_name) ?>"></span>
                                </div>
                            </div>
                            <?php
                        }
                        ?>
                    </div>
                    <?php
                    if ($total_attachments > $per_page) {
                        $total_pages = ceil($total_attachments / $per_page);
                        ?>
                        <div id="fds-usermedia-morebtn" class="fds-lodmore-btnsec">
                            <div class="fds-btn fds-medium-btn">
                                <a href="#" class="fds-lodmore-btn fds-has-bg fds-link" data-nid="<?php echo ($user_id) ?>" data-tpages="<?php echo($total_pages) ?>" data-gtopage="2"><?php esc_html_e('load more', 'wp-foodsearch') ?></a>
                            </div>
                        </div>
                        <?php
                    }
                }
                ?>
            </div>
            <div class="insert-mediaacts-con fds-btn fds-medium-btn fds-dohav-media"<?php echo (empty($attachments) ? ' style="display:none;"' : '') ?>>
                <a href="#" class="fds-has-bg fds-link fds-insert-media-btn disable"><?php esc_html_e('insert media', 'wp-foodsearch') ?></a>
            </div>

            <div class="fds-newmedia-insert-box fds-nohav-media"<?php echo (empty($attachments) ? '' : ' style="display:none;"') ?>>
                <div class="fds-dashboard-file-upload2">
                    <label for="media-insert-btn-<?php echo absint($user_id) ?>" class="fds-upload-btn2 fds-input-label"><?php esc_html_e('upload image', 'wp-foodsearch') ?></label>
                    <input id="media-insert-btn-<?php echo absint($user_id) ?>" class="fds-file-upload-input2 fds-update-anything-action" type="file" accept="image/*" name="fds_upload_user_newmedia">
                </div>
            </div>
        </div>
        <?php
        $html = ob_get_clean();
        
        wp_send_json(array('html' => $html));
    }
    
    public function user_media_delete() {
        
        global $wpdb;

        $attach_id = $_POST['aid'];
        
        wp_delete_attachment($attach_id, true);
        
        wp_send_json(array('msg' => esc_html__('media item deleted successfully.', 'wp-foodsearch')));
    }
    
    public function user_media_upolad() {
        $user_id = $_POST['nid'];
        $post_id = $_POST['pid'];
        $attach_type = $_POST['apnd_type'];
        
        $wp_upload_dir = wp_upload_dir();

        $upload_file = $_FILES['user_media_file'];

        require_once ABSPATH . 'wp-admin/includes/image.php';
        require_once ABSPATH . 'wp-admin/includes/file.php';
        require_once ABSPATH . 'wp-admin/includes/media.php';

        $allowed_image_types = array(
            'jpg|jpeg' => 'image/jpeg',
            'png' => 'image/png',
            'gif' => 'image/gif',
        );

        $status_upload = wp_handle_upload($upload_file, array('test_form' => false, 'mimes' => $allowed_image_types));

        if (empty($status_upload['error'])) {
            $image = wp_get_image_editor($status_upload['file']);

            if (is_wp_error($image)) {
                wp_send_json(array('msg' => esc_html__('this media type is not allowed.', 'wp-foodsearch'), 'error' => '2'));
            }

            $file_url = isset($status_upload['url']) ? $status_upload['url'] : '';

            $upload_file_path = $wp_upload_dir['path'] . '/' . basename($file_url);

            // Check the type of file. We'll use this as the 'post_mime_type'.
            $filetype = wp_check_filetype(basename($file_url), null);

            // Prepare an array of post data for the attachment.
            $attachment = array(
                'guid' => $wp_upload_dir['url'] . '/' . basename($upload_file_path),
                'post_mime_type' => $filetype['type'],
                'post_title' => preg_replace('/\.[^.]+$/', '', ($upload_file['name'])),
                'post_author' => $user_id,
                'post_status' => 'inherit'
            );

            // Insert the attachment.
            $attach_id = wp_insert_attachment($attachment, $upload_file_path, $post_id);

            // Generate the metadata for the attachment, and update the database record.
            $attach_data = wp_generate_attachment_metadata($attach_id, $upload_file_path);
            wp_update_attachment_metadata($attach_id, $attach_data);
        }
        
        if (isset($attach_id)) {
            $user_thumb_image = wp_get_attachment_image_src($attach_id, 'thumbnail');
            $img_src = isset($user_thumb_image[0]) && esc_url($user_thumb_image[0]) != '' ? $user_thumb_image[0] : '';
            
            $img_name = $img_src != '' ? basename($img_src) : '';
            ob_start();
            ?>
            <div id="attachd-<?php echo ($attach_id) ?>" class="fds-usermedia-uploditm">
                <a href="#" class="fds-remove-media fds-link" data-id="<?php echo ($attach_id) ?>"><i class="fds-icon fds-time-simple"></i></a>
                <div class="fds-media-selectchk">
                    <input type="radio" name="insert_media" value="<?php echo ($attach_type == 'url' ? $img_src : $attach_id) ?>">
                    <span></span>
                </div>
                <div class="fds-media-thumbcon" data-src="<?php echo ($img_src) ?>">
                    <span class="fds-img-thumb" style="background-image: url(<?php echo ($img_src) ?>)" title="<?php echo ($img_name) ?>"></span>
                </div>
            </div>
            <?php
            $html = ob_get_clean();

            wp_send_json(array('error' => '0', 'msg' => esc_html__('media uploaded successfully.', 'wp-foodsearch'), 'id' => $attach_id, 'html' => $html));
        }
        
        wp_send_json(array('msg' => esc_html__('there is some issue in uploading media.', 'wp-foodsearch'), 'error' => '1'));
    }
    
    public function user_media_load_more() {
        global $wpdb;
        
        $user_id = $_POST['nid'];
        $page_num = $_POST['page_num'];
        
        $offset = 0;
        $per_page = 20;
        if ($page_num > 1) {
            $offset = ($page_num - 1) * $per_page;
        }
        
        $attachments = $wpdb->get_col("SELECT ID FROM $wpdb->posts WHERE post_type='attachment' AND post_mime_type LIKE 'image/%' AND post_author=$user_id ORDER BY ID DESC LIMIT $per_page OFFSET $offset");
        
        ob_start();
        if (!empty($attachments)) {
            foreach ($attachments as $attachment_id) {
                $img_thumb = wp_get_attachment_image_src($attachment_id, 'thumbnail');
                $img_src = isset($img_thumb[0]) ? $img_thumb[0] : '';

                $img_name = $img_src != '' ? basename($img_src) : '';
                ?>
                <div class="fds-usermedia-uploditm">
                    <a href="#" class="fds-remove-media fds-link" data-id="<?php echo ($attachment_id) ?>"><i class="fds-icon fds-time-simple"></i></a>
                    <div class="fds-media-selectchk">
                        <input type="radio" name="insert_media" value="<?php echo ($attach_type == 'url' ? $img_src : $attachment_id) ?>">
                        <span></span>
                    </div>
                    <div class="fds-media-thumbcon" data-src="<?php echo ($img_src) ?>">
                        <span class="fds-img-thumb" style="background-image: url(<?php echo ($img_src) ?>)" title="<?php echo ($img_name) ?>"></span>
                    </div>
                </div>
                <?php
            }
        }
        $html = ob_get_clean();
        
        wp_send_json(array('html' => $html));
    }

}

new User_Media;
