<?php
/**
 * Created by Eyecix Team. * 
 *Author: Eyecix
 *Version: 1.0
 *Detail: Woocommerce Integration
 */

 use FoodSearch\Distance_Check;
 class foodsearch_woocommerce_cart extends foodsearch_cart
{
    public function __construct()
    {
        add_action('wp_ajax_nopriv_wc_add_to_cart', array($this, 'foodsearch_wc_product_create'));
        add_action('wp_ajax_wc_add_to_cart', array($this, 'foodsearch_wc_product_create'));  
		add_filter( 'woocommerce_get_cart_item_from_session', array( $this, 'foodsearch_get_cart_item_from_session' ), 20, 2 );
        add_filter( 'woocommerce_add_cart_item_data', array( $this, 'foodsearch_add_cart_item_data' ), 10, 2 );          
		add_filter( 'woocommerce_add_cart_item', array( $this, 'foodsearch_add_cart_item' ), 20 ); 
        add_action( 'woocommerce_after_cart_item_quantity_update', array( $this, 'foodsearch_update_price_on_quantity_update' ), 20, 4 );
		add_filter( 'woocommerce_get_item_data', array( $this, 'foodsearch_get_item_data' ), 10, 2 );
		add_action( 'woocommerce_checkout_create_order_line_item', array( $this, 'foodsearch_order_line_item' ), 10, 3 );
        add_filter( 'woocommerce_cart_calculate_fees', [$this,'foodsearch_delivery_charges'], 10, 2);   
        add_action('woocommerce_order_status_changed', [$this,'foodsearch_remove_product']);		
		add_action('foodsearch_cart_reset_cron', [$this,'foodsearch_cart_reset']);
		add_action( 'woocommerce_checkout_order_processed', [$this,'foodsearch_empty_cart'],  1, 1  );
		add_action('woocommerce_checkout_update_order_meta',  [$this,'foodsearch_upadte_order_type'], 20, 2);
		add_action('woocommerce_checkout_get_value',  [$this,'prepopulate_wc_fields'], 10, 2);

    }
	function foodsearch_delivery_charges(){
		global $woocommerce,$foodsearch_plugin_settings;  
		$restaurant = isset($_SESSION['restaurant'])?$_SESSION['restaurant']:'';
		$customer_location = isset($_SESSION['customer_location'])?$_SESSION['customer_location']:'';
		if (is_admin() && !defined('DOING_AJAX')) {
		return;
		}
		if (isset($customer_location['order_type']) && $customer_location['order_type'] == 'deliver') {
			$DC = get_post_meta($restaurant, 'foodsearch_delivery_fee');
			if ($DC) {
				$dcm = isset($foodsearch_plugin_settings['location_settings']['delivery_cost_multiplier']) ? $foodsearch_plugin_settings['location_settings']['delivery_cost_multiplier'] : 1;
				$distance = $this->restaurant_distance_from_user_loc($customer_location,$restaurant );
				$_SESSION['distance'] = $distance;
				$_SESSION['dcm '] = $dcm ;
				$dcm = ceil($dcm * $distance[0]['distance']);
				$woocommerce->cart->add_fee(__('Delivery Fee', 'wp_foodsearch'), ($DC[0]+$dcm));
			}
		}
		}
	public function prepopulate_wc_fields($input, $key ) {			
			$customer_location = isset($_SESSION['customer_location'])?$_SESSION['customer_location']:'';
		if (isset($customer_location['order_type']) && $customer_location['order_type'] == 'deliver') {
			$address = explode(',',$customer_location['address']);
			$country = $address[count($address) - 1];
			$state = $address[count($address) - 2];
			$city = $address[count($address) - 3];
			switch ($key) {
				case 'billing_address_1':
					return $customer_location['address'];
					break;
				case 'billing_city':
					return $city;
					break;
			}
		}
	}
	public function foodsearch_update_price_on_quantity_update( $cart_item_key, $quantity, $old_quantity, $cart ) {
		$cart_item_data = $cart->get_cart_item( $cart_item_key );

		if ( ! empty( $cart_item_data['addons'] ) ) {
			$prices = array(
				'price'         => $cart_item_data['addons_price_before_calc'],
				'regular_price' => $cart_item_data['addons_regular_price_before_calc'],
				'sale_price'    => $cart_item_data['addons_sale_price_before_calc'],
			);

			return $this->foodsearch_update_product_price( $cart_item_data, $quantity, $prices );
		}
	}    
	function foodsearch_empty_cart( $order_id ){

		unset($_SESSION['foodsearch_order_type']);
		unset($_SESSION['restaurant']);
		unset($_SESSION['cartitems']);
	 
	 }   
	 function foodsearch_upadte_order_type( $order_id, $data ) {
		$restaurant = $_SESSION['restaurant'];
		$arg = array(
			'ID' => $order_id,
			'post_author' => $restaurant,
		);
		wp_update_post( $arg );
		$order = wc_get_order( $order_id );
		$order->update_meta_data( '_foodsearch_order_type', $_SESSION['foodsearch_order_type']  );
		$order->save();
	}
    public function foodsearch_wc_product_create(){
        global $woocommerce;   
		 $items = isset($_SESSION['cartitems'])?$_SESSION['cartitems']:[];		
		if (isset($_POST['order_type'])) {
            $order_type = $_POST['order_type'];
            if ($order_type == '2') {
                $order_type = 'take_away';
            } else {
                $order_type = 'delivery';
            }
           
        }  
		else{
			$order_type = 'delivery';
		}   
		$_SESSION['foodsearch_order_type'] = $order_type;  
       
	   $this->check_product_in_cart();
	   //exit();
	   $itemkey = [];
	   if ( $woocommerce->cart->get_cart_contents_count() > 0 ) {
		$Cartitems = $woocommerce->cart->get_cart();  
			foreach($Cartitems as $ikey => $values) { 
				
				$itemDetails = get_post_meta($values['product_id'], '_foodsearch_item_detail');
				if($itemDetails){
					$itemDetails = json_decode($itemDetails[0],true);
					$itkey= $this->fds_check_product_in_wc_cart($itemDetails,$ikey);
					if($itkey){
						$itemkey[$itemDetails['id'].$itkey['itemkey']] = $itkey['pid'];
					}
				}
				
			}
		}
       foreach($items as $key=>$item){	
			$quantity = $item['qty'];
			$ikey = $item['id'].$key;
			if(!array_key_exists($ikey,$itemkey))
			{
				$pid = $this->create_product($item,$order_type);				
				$woocommerce->cart->add_to_cart($pid, $quantity);
			}			
			else{	
				global $woocommerce;
				$woocommerce->cart->set_quantity($itemkey[$ikey],$quantity);
			 }
	   }
       wp_send_json(array('error' => '0', 'url' =>  wc_get_checkout_url()));
       wp_die();     
   		
	}
	public function fds_check_product_in_wc_cart($itemRequest,$pid){
		
		$cartitems = isset($_SESSION['cartitems'])?$_SESSION['cartitems']:'';
		$cartitem = [];
       	if(is_array($cartitems) ){
            foreach($cartitems as $key=> $item) { 	                
                $cartitem[$key] = $item['id'];
            } 	
            foreach($cartitem as $key=> $item) { 
                if($itemRequest['id']==$item){
                    $veriCheck ='true';          
					$extraCheck = 'true';
					
                    if(isset($itemRequest['variation'])){  
						$searchItem = $cartitems[$key]['variation'];
						if(is_array($itemRequest['variation'])){
							$name = 	$itemRequest['variation']['name'];
						} 
						else{
							$variation = explode(':',$itemRequest['variation']); 
							$name = $variation[0];							
						}  
						if($name !== $searchItem['name']){
							$veriCheck ='false';
							
							}         
                        

                    }                
                    if(isset($itemRequest['extras'])){               
                       
                        $searchItem = $cartitems[$key]['extras'];
                        if(count($itemRequest['extras'])>=count($searchItem)){
                            foreach($itemRequest['extras'] as $k=>$extras){
                                if(is_array($extras) ){
                                    //  echo $k;
                                    foreach($extras as $extra){
										if(is_array($extra)){
											$name = $extra['name'];
										} 
										else{
											$variation = explode(':',$extra); 
											$name = $variation[0];							
										}                               
                                        if(!in_array_r($name,$searchItem)){                            
                                            $extraCheck = 'false';
                                            break;
                                        }
                                    }
                                }
                                else{                                
                                    $extraKey = explode(':',$extras); 
                                    if(!in_array_r($extraKey[0],$searchItem)){ 
                                        $extraCheck = 'false';
                                        break;
                                    } 
                                }
                            }
                        }
                        else{
                            $extraCheck = 'false';
                        }
                        
                    }
					if($veriCheck =='true' && $extraCheck =='true' ){
						return ['pid'=>$pid,'itemkey'=>$key];
					}
                }               
            }	
        }		
     }
	private function create_product($item,$order_type){
		$product = new WC_Product_Simple;            
		if(isset($item['variation'])){
			$price = $item['variation']['price'];
			$name = $item['name'].'('.$item['variation']['name'].')';
		}
		else{
			$price = $item['basicprice'];
			$name = $item['name'];
		}
		$product->set_virtual( true );
		$product->set_name( $name );
		$product->set_regular_price($price);
		$product->set_catalog_visibility('hidden');
		$pid = $product->save();
		add_post_meta( $pid, '_foodsearch_menu_item', 'true', true );
		$foodsearch_addons = [];
		if(isset($item['extras'])){
			foreach($item['extras'] as $key=> $extras){
				foreach($extras as $extra){
					$foodsearch_addons[] = array('key'=>$key,'name'=>$extra['name'],'price'=>$extra['price']);
				}
			}
			add_post_meta( $pid, '_foodsearch_addons', json_encode($foodsearch_addons,true), true );
			
		}
		$item['product_id'] = $pid;
		add_post_meta( $pid, '_foodsearch_item_detail', json_encode($item,true), true );
		add_post_meta( $pid, '_foodsearch_order_type', $order_type, true );
		return $pid;
	}	
	public function check_product_in_cart(){
		global $woocommerce;
    	$wcitems = $woocommerce->cart->get_cart();
		$cartitems = isset($_SESSION['cartitems'])?$_SESSION['cartitems']:[];
		$wcitem = $cartitem = [];
		foreach($wcitems as $ikey => $values) { 
			$itemDetails = get_post_meta($values['product_id'], '_foodsearch_item_detail');
			if($itemDetails){
				$itemDetails = json_decode($itemDetails[0],true);
				$itkey= $this->fds_check_product_in_wc_cart($itemDetails,$ikey);
				if(!$itkey){
					$wcitem[$itemDetails['id']] =['itemid'=>$itemDetails['id'],'productid'=>$values['product_id']];
				}
			}
			
		}
		foreach($wcitem as $item){
			$this->foodsearch_delete_product($item['productid'], TRUE);
		}


	}
	public function wc_cart_check($checkID,$key = ''){	
		global $woocommerce;
    	$items = $woocommerce->cart->get_cart();  
		if(is_array($items) && count($items)>0){
			foreach($items as $item => $values) { 
				$itemDetails = get_post_meta($values['product_id'], '_foodsearch_item_detail');
				$itemDetails = json_decode($itemDetails[0],true);						
				if($checkID==$itemDetails['id']){				    
					if($values['product_id']==$itemDetails['product_id']){	
						return array('id'=>$checkID,'key'=>$item,'qty'=>$values['quantity']);
					}			
				}
			} 
		}
    }
    public function foodsearch_add_cart_item_data( $cart_item_data, $product_id ) {
		if ( isset( $_POST ) && ! empty( $product_id ) ) {
			$post_data = $_POST;
		} else {
			return;
		}
        $adons =get_post_meta( $product_id, '_foodsearch_addons');
       
        if ( empty( $cart_item_data['foodsearch_addons'] ) ) {
			$cart_item_data['foodsearch_addons'] = array();
		}
        if(!empty($adons)){
            $product_addons = json_decode($adons[0],true);
          //  echo '<pre>'.print_r($product_addons,true).'</pre>';
            foreach($product_addons as $addon){
                $data[] = array(
                    'name'       => $addon['name'],
                    'value'      => floatval( sanitize_text_field( $addon['price'] ) ),
                    'price'      => floatval( sanitize_text_field( $addon['price'] ) ),
                    'price_type' =>'flat_fee'
                );
        
            }
            if ( is_wp_error( $data ) ) {
                // Throw exception for add_to_cart to pickup.
                throw new Exception( $data->get_error_message() );
            } elseif ( $data ) {
                $cart_item_data['foodsearch_addons'] = array_merge( $cart_item_data['foodsearch_addons'], apply_filters( 'woocommerce_product_addon_cart_item_data', $data, $addon, $product_id, $post_data ) );
            }
        }	

		return $cart_item_data;
	}
    public function foodsearch_add_cart_item( $cart_item_data ) {
		$prices = array(
			'price'         => (float) $cart_item_data['data']->get_price( 'edit' ),
			'regular_price' => (float) $cart_item_data['data']->get_regular_price( 'edit' ),
			'sale_price'    => (float) $cart_item_data['data']->get_sale_price( 'edit' ),
		);
	
		return $this->foodsearch_update_product_price( $cart_item_data, $cart_item_data['quantity'], $prices );
	}
    public function foodsearch_update_product_price( $cart_item_data, $quantity, $prices ) {
		
		if ( ! empty( $cart_item_data['foodsearch_addons'] ) && apply_filters( 'woocommerce_product_addons_adjust_price', true, $cart_item_data ) ) {
			$price         = $prices['price'];
			$regular_price = $prices['regular_price'];
			$sale_price    = $prices['sale_price'];

			// Compatibility with Smart Coupons self declared gift amount purchase.
			if ( empty( $price ) && ! empty( $_POST['credit_called'] ) ) {
				// $_POST['credit_called'] is an array.
				if ( isset( $_POST['credit_called'][ $cart_item_data['data']->get_id() ] ) ) {
					$price         = (float) $_POST['credit_called'][ $cart_item_data['data']->get_id() ];
					$regular_price = $price;
					$sale_price    = $price;
				}
			}

			if ( empty( $price ) && ! empty( $cart_item_data['credit_amount'] ) ) {
				$price         = (float) $cart_item_data['credit_amount'];
				$regular_price = $price;
				$sale_price    = $price;
			}

			// Save the price before price type calculations to be used later.
			$cart_item_data['addons_price_before_calc']         = (float) $price;
			$cart_item_data['addons_regular_price_before_calc'] = (float) $regular_price;
			$cart_item_data['addons_sale_price_before_calc']    = (float) $sale_price;
           // echo '$cart_item_data: <pre>'.print_r($cart_item_data,true).'</pre>';
            foreach ( $cart_item_data['foodsearch_addons'] as $addon ) {
                $addon_price = $addon['price']*$quantity;
                $price         += (float) ( $addon_price / $quantity );
                $regular_price += (float) ( $addon_price / $quantity );
                $sale_price    += (float) ( $addon_price / $quantity );
			}

			$updated_product_prices = [
				'price'         => $price,
				'regular_price' => $regular_price,
				'sale_price'    => $sale_price,
			];
			$updated_product_prices = apply_filters( 'woocommerce_product_addons_update_product_price', $updated_product_prices, $cart_item_data, $prices );

			$cart_item_data['data']->set_price( $updated_product_prices['price'] );

			// Only update regular price if it was defined.
			$has_regular_price = is_numeric( $cart_item_data['data']->get_regular_price( 'edit' ) );
			if ( $has_regular_price ) {
				$cart_item_data['data']->set_regular_price( $updated_product_prices['regular_price'] );
			}

			// Only update sale price if it was defined.
			$has_sale_price = is_numeric( $cart_item_data['data']->get_sale_price( 'edit' ) );
			if ( $has_sale_price ) {
				$cart_item_data['data']->set_sale_price( $updated_product_prices['sale_price'] );
			}
		}
		// echo 'updated_product_prices: <pre>'.print_r($updated_product_prices,true).'</pre>';
		// echo 'quantity: <pre>'.print_r($quantity,true).'</pre>';
		// echo 'cart_item_data: <pre>'.print_r($cart_item_data,true).'</pre>';
		// exit();
		return $cart_item_data;
	}
    public function foodsearch_get_item_data( $other_data, $cart_item ) {
		if ( ! empty( $cart_item['foodsearch_addons'] ) ) {
			foreach ( $cart_item['foodsearch_addons'] as $addon ) {
				$price = isset( $cart_item['addons_price_before_calc'] ) ? $cart_item['addons_price_before_calc'] : $addon['price'];
				$name  = $addon['name'];

				if ( 0 == $addon['price'] ) {
					$name .= '';
				} elseif ( 'percentage_based' === $addon['price_type'] && 0 == $price ) {
					$name .= '';
				} elseif ( 'percentage_based' !== $addon['price_type'] && $addon['price'] && apply_filters( 'woocommerce_addons_add_price_to_name', true ) ) {
					//$name .= ' (' . wc_price( SELF::get_product_addon_price_for_display( $addon['price'], $cart_item['data'], true ) ) . ')';
				} else if ( apply_filters( 'woocommerce_addons_add_price_to_name', true ) ) {
					$_product = wc_get_product( $cart_item['product_id'] );
					$_product->set_price( $price * ( $addon['price'] / 100 ) );
					//$name .= ' (' . WC()->cart->get_product_price( $_product ) . ')';
				}

				$addon_data = array(
					'name'    => $name,
					'value'   => $addon['price'],
					'display' => isset( $addon['display'] ) ? $addon['display'] : '',
				);
				$other_data[] = apply_filters( 'woocommerce_product_addons_get_item_data', $addon_data, $addon, $cart_item );
			}
		}

		return $other_data;
	}
    public static function get_product_addon_price_for_display( $price, $cart_item = null ) {
		$product = ! empty( $GLOBALS['product'] ) && is_object( $GLOBALS['product'] ) ? clone $GLOBALS['product'] : null;

		if ( '' === $price || '0' == $price ) {
			return;
		}

		$neg = false;

		if ( $price < 0 ) {
			$neg    = true;
			$price *= -1;
		}

		if ( ( is_cart() || is_checkout() ) && null !== $cart_item ) {
			$product = wc_get_product( $cart_item->get_id() );
		}

		if ( is_object( $product ) ) {
			// Support new wc_get_price_excluding_tax() and wc_get_price_excluding_tax() functions.
			if ( function_exists( 'wc_get_price_excluding_tax' ) ) {
				$display_price = self::foodsearch_get_product_addon_tax_display_mode() === 'incl' ? wc_get_price_including_tax(
					$product,
					array(
						'qty'   => 1,
						'price' => $price,
					)
				) : wc_get_price_excluding_tax(
					$product,
					array(
						'qty'   => 1,
						'price' => $price,
					)
				);

				/**
				 * When a user is tax exempt and product prices are exclusive of taxes, WooCommerce displays prices as follows:
				 * - Catalog and product pages: including taxes
				 * - Cart and Checkout pages: excluding taxes
				 */
				if ( ( is_cart() || is_checkout() ) && ! empty( WC()->customer ) && WC()->customer->get_is_vat_exempt() && ! wc_prices_include_tax() ) {
					$display_price = wc_get_price_excluding_tax(
						$product,
						array(
							'qty'   => 1,
							'price' => $price,
						)
					);
				}
			} else {
				$display_price = self::foodsearch_get_product_addon_tax_display_mode() === 'incl' ? $product->get_price_including_tax( 1, $price ) : $product->get_price_excluding_tax( 1, $price );
			}
		} else {
			$display_price = $price;
		}

		if ( $neg ) {
			$display_price = '-' . $display_price;
		}

		return $display_price;
	}   
    public function update_price_on_quantity_update( $cart_item_key, $quantity, $old_quantity, $cart ) {
		$cart_item_data = $cart->get_cart_item( $cart_item_key );

		if ( ! empty( $cart_item_data['foodsearch_addons'] ) ) {
			$prices = array(
				'price'         => $cart_item_data['addons_price_before_calc'],
				'regular_price' => $cart_item_data['addons_regular_price_before_calc'],
				'sale_price'    => $cart_item_data['addons_sale_price_before_calc'],
			);

			return $this->foodsearch_update_product_price( $cart_item_data, $quantity, $prices );
		}
	}
    public static function foodsearch_get_product_addon_tax_display_mode() {
		if ( is_cart() || is_checkout() ) {
			return get_option( 'woocommerce_tax_display_cart' );
		}

		return get_option( 'woocommerce_tax_display_shop' );
	}
    public function foodsearch_get_cart_item_from_session( $cart_item, $values ) {
		if ( ! empty( $values['foodsearch_addons'] ) ) {
			$prices              = array(
				'price'         => (float) $cart_item['data']->get_price( 'edit' ),
				'regular_price' => (float) $cart_item['data']->get_regular_price( 'edit' ),
				'sale_price'    => (float) $cart_item['data']->get_sale_price( 'edit' ),
			);
			$cart_item['foodsearch_addons'] = $values['foodsearch_addons'];
			$cart_item           = $this->foodsearch_update_product_price( $cart_item, $cart_item['quantity'], $prices );
		}

		return $cart_item;
	}
    public function foodsearch_order_line_item( $item, $cart_item_key, $values ) {
		if ( ! empty( $values['foodsearch_addons'] ) ) {
			foreach ( $values['foodsearch_addons'] as $addon ) {
				$key           = $addon['name'];
				$price_type    = $addon['price_type'];
				$product       = $item->get_product();
				$product_price = $product->get_price();

				/*
				 * For percentage based price type we want
				 * to show the calculated price instead of
				 * the price of the add-on itself and in this
				 * case its not a price but a percentage.
				 * Also if the product price is zero, then there
				 * is nothing to calculate for percentage so
				 * don't show any price.
				 */
				if ( $addon['price'] && 'percentage_based' === $price_type && 0 != $product_price ) {
					$addon_price = $product_price * ( $addon['price'] / 100 );
				} else {
					$addon_price = $addon['price'];
				}
				$price = html_entity_decode(
					strip_tags( wc_price( self::get_product_addon_price_for_display( $addon_price, $values['data'] ) ) ),
					ENT_QUOTES,
					get_bloginfo( 'charset' )
				);

				/*
				 * If there is an add-on price, add the price of the add-on
				 * to the label name.
				 */
				if ( $addon['price'] && apply_filters( 'woocommerce_addons_add_price_to_name', true ) ) {
					$key .= ' (' . $price . ')';
				}

				$meta_data = [
					'key'   => $addon['name'],
					'value' => get_woocommerce_currency_symbol().' '.$addon['value'],
				];
				$meta_data = apply_filters( 'woocommerce_product_addons_order_line_item_meta', $meta_data, $addon, $item, $values );

				$item->add_meta_data( $meta_data['key'], $meta_data['value'] );
			}
		}
	}
    
        function foodsearch_remove_product($order_id) {
            $order = wc_get_order( $order_id );
            $items = $order->get_items();
            foreach ( $items as $item ) {
                $product_id = $item->get_product_id();
                $this->foodsearch_delete_product($product_id, TRUE);
            }
          
        }
        function foodsearch_delete_product($id, $force = FALSE)
		{
			$product = wc_get_product($id);

			if(empty($product))
				return new WP_Error(999, sprintf(__('No %s is associated with #%d', 'woocommerce'), 'product', $id));

			// If we're forcing, then delete permanently.
			if ($force)
			{
				if ($product->is_type('variable'))
				{
					foreach ($product->get_children() as $child_id)
					{
						$child = wc_get_product($child_id);
						$child->delete(true);
					}
				}
				elseif ($product->is_type('grouped'))
				{
					foreach ($product->get_children() as $child_id)
					{
						$child = wc_get_product($child_id);
						$child->set_parent_id(0);
						$child->save();
					}
				}

				$product->delete(true);
				
				delete_post_meta( $id,'_foodsearch_menu_item' );
				delete_post_meta( $id,'_foodsearch_item_detail' );
				delete_post_meta( $id,'_foodsearch_addons' );
				$result = $product->get_id() > 0 ? false : true;
			}
			else
			{
				$product->delete();
				$result = 'trash' === $product->get_status();
			}

			if (!$result)
			{
				return new WP_Error(999, sprintf(__('This %s cannot be deleted', 'woocommerce'), 'product'));
			}

			// Delete parent product transients.
			if ($parent_id = wp_get_post_parent_id($id))
			{
				wc_delete_product_transients($parent_id);
			}
			return true;
			}
	public function foodsearch_cart_reset() {
		$args = array(
			'numberposts' => -1,
			'post_type' => 'product',
			'date_query' => [
				[
					'before'     => '1 hour ago',  
					'inclusive' => true,
				],
			],
			'meta_query' => array(
				array(
					'key'       => '_foodsearch_menu_item',
					'value'     => 'true',
				)
			)
		);
		$posts = get_posts($args);
		foreach($posts as $post){			
			$this->foodsearch_delete_product($post->ID, TRUE);
		}		
	}
	public static function restaurant_distance_from_user_loc($visitor_location = '', $restaurant_id = '') {
        
        //$restaurant_locs = get_post_meta($restaurant_id, 'foodsearch_locations_list', true);
        $restaurant_locs = get_saved_location_on_id($restaurant_id);
        if (!empty($restaurant_locs) && isset($visitor_location['lat']) && $visitor_location['lat'] != '' && $visitor_location['lng'] != '') {
            $user_geo_lat = $visitor_location['lat'];
            $user_geo_lng = $visitor_location['lng'];
            $dist_address = array();
            foreach ($restaurant_locs as $addr_loc_id => $addr_loc_itm) {
                $addr_lat = $addr_loc_itm['lat'];
                $addr_lng = $addr_loc_itm['lng'];
                
                $distance_km = Distance_Check::calculate($user_geo_lat, $user_geo_lng, $addr_lat, $addr_lng, 'K', $restaurant_id);
                //echo $restaurant_id . ' [] ' . $addr_lat . ' ; ' . $addr_lng . ' - ' . ($distance_km) . ' || ' . "\n";
                if ($distance_km > 0) {
                    $dist_address[] = array(                        
                        'distance' => $distance_km,
                    );
                }
            }
            //if (!empty($dist_address) && count($dist_address) > 1) {
                usort($dist_address, function ($a, $b) {
                    if ($a['distance'] == $b['distance']) {
                        $ret_val = 0;
                    }
                    $ret_val = ($a['distance'] < $b['distance']) ? -1 : 1;
                    return $ret_val;
                });
            //}
            return $dist_address;
        }
    }
	
   
}
new foodsearch_woocommerce_cart;