const { Button, ButtonGroup, PanelRow, SelectControl, RangeControl, ColorPicker } = wp.components;
const { PanelColorSettings } = wp.blockEditor;
const { __ } = wp.i18n;
import { useState } from '@wordpress/element';
import { __experimentalNumberControl as NumberControl } from '@wordpress/components';
import OutsideClickHandler from 'react-outside-click-handler';

export const Border = (props) => {
    const { setAttributes } = props;
    const [isRadiusRes, setRadiusRes] = useState("lg");
    const [isRadiusLock, setRadiusLock] = useState("false");
        const [isWidthRes, setWidthRes] = useState("lg");
        const [isWidthLock, setWidthLock] = useState("false");
        const [isShadow, setShadow] = useState(false);
        const [isColor, setColor] = useState(false);
        const [isShadowColor, setShadowColor] = useState(false);
    var name = props.name;

    var radiusArr = {
        "type":"",
        "width":{
            "lg":{"unit":'', "top":'', "right":'', "bottom":'', "left":''},
            "md":{"unit":'', "top":'', "right":'', "bottom":'', "left":''},
            "sm":{"unit":'', "top":'', "right":'', "bottom":'', "left":''},
            "xs":{"unit":'', "top":'', "right":'', "bottom":'', "left":''},
        },
        "color":{"r":'', "g":'', "b":'', "a":''},
        "radius":{
            "lg":{"unit":'', "top":'', "right":'', "bottom":'', "left":''},
            "md":{"unit":'', "top":'', "right":'', "bottom":'', "left":''},
            "sm":{"unit":'', "top":'', "right":'', "bottom":'', "left":''},
            "xs":{"unit":'', "top":'', "right":'', "bottom":'', "left":''},
        },
        "shadow":{"color":'', "hor":'', "ver":'', "blur":'', "spread":'', "pos":''},
    };

    const prepare_val = (index1, index2, index3, val) => {
        radiusArr.type = props.attr.type;
            radiusArr.width.lg.unit = props.attr.width.lg.unit;
            radiusArr.width.lg.top = props.attr.width.lg.top;
            radiusArr.width.lg.right = props.attr.width.lg.right;
            radiusArr.width.lg.bottom = props.attr.width.lg.bottom;
            radiusArr.width.lg.left = props.attr.width.lg.left;
        radiusArr.width.md.unit = props.attr.width.md.unit;
        radiusArr.width.md.top = props.attr.width.md.top;
        radiusArr.width.md.right = props.attr.width.md.right;
        radiusArr.width.md.bottom = props.attr.width.md.bottom;
        radiusArr.width.md.left = props.attr.width.md.left;
            radiusArr.width.sm.unit = props.attr.width.sm.unit;
            radiusArr.width.sm.top = props.attr.width.sm.top;
            radiusArr.width.sm.right = props.attr.width.sm.right;
            radiusArr.width.sm.bottom = props.attr.width.sm.bottom;
            radiusArr.width.sm.left = props.attr.width.sm.left;
        radiusArr.width.xs.unit = props.attr.width.xs.unit;
        radiusArr.width.xs.top = props.attr.width.xs.top;
        radiusArr.width.xs.right = props.attr.width.xs.right;
        radiusArr.width.xs.bottom = props.attr.width.xs.bottom;
        radiusArr.width.xs.left = props.attr.width.xs.left;

        radiusArr.color = props.attr.color;
            radiusArr.radius.lg.unit = props.attr.radius.lg.unit;
            radiusArr.radius.lg.top = props.attr.radius.lg.top;
            radiusArr.radius.lg.right = props.attr.radius.lg.right;
            radiusArr.radius.lg.bottom = props.attr.radius.lg.bottom;
            radiusArr.radius.lg.left = props.attr.radius.lg.left;
        radiusArr.radius.md.unit = props.attr.radius.md.unit;
        radiusArr.radius.md.top = props.attr.radius.md.top;
        radiusArr.radius.md.right = props.attr.radius.md.right;
        radiusArr.radius.md.bottom = props.attr.radius.md.bottom;
        radiusArr.radius.md.left = props.attr.radius.md.left;
            radiusArr.radius.sm.unit = props.attr.radius.sm.unit;
            radiusArr.radius.sm.top = props.attr.radius.sm.top;
            radiusArr.radius.sm.right = props.attr.radius.sm.right;
            radiusArr.radius.sm.bottom = props.attr.radius.sm.bottom;
            radiusArr.radius.sm.left = props.attr.radius.sm.left;
        radiusArr.radius.xs.unit = props.attr.radius.xs.unit;
        radiusArr.radius.xs.top = props.attr.radius.xs.top;
        radiusArr.radius.xs.right = props.attr.radius.xs.right;
        radiusArr.radius.xs.bottom = props.attr.radius.xs.bottom;
        radiusArr.radius.xs.left = props.attr.radius.xs.left;
            radiusArr.shadow.color = props.attr.shadow.color;
            radiusArr.shadow.hor = props.attr.shadow.hor;
            radiusArr.shadow.ver = props.attr.shadow.ver;
            radiusArr.shadow.blur = props.attr.shadow.blur;
            radiusArr.shadow.spread = props.attr.shadow.spread;
            radiusArr.shadow.pos = props.attr.shadow.pos;
    
        if (index2 == "" && index3 == "") radiusArr[index1] = val;
        else if (index3 == "") radiusArr[index1][index2] = val;
        else radiusArr[index1][index2][index3] = val;

        if ( isWidthLock && index1 === "width" ){
            if ( index2 === "lg" && index3 !== "unit" ){
                radiusArr.width.lg.top = val;
                radiusArr.width.lg.right = val;
                radiusArr.width.lg.bottom = val;
                radiusArr.width.lg.left = val;
            }
            else if ( index2 === "md" && index3 !== "unit" ){
                radiusArr.width.md.top = val;
                radiusArr.width.md.right = val;
                radiusArr.width.md.bottom = val;
                radiusArr.width.md.left = val;
            }
            else if ( index2 === "sm" && index3 !== "unit" ){
                radiusArr.width.sm.top = val;
                radiusArr.width.sm.right = val;
                radiusArr.width.sm.bottom = val;
                radiusArr.width.sm.left = val;
            }
            else if ( index2 === "xs" && index3 !== "unit" ){
                radiusArr.width.xs.top = val;
                radiusArr.width.xs.right = val;
                radiusArr.width.xs.bottom = val;
                radiusArr.width.xs.left = val;
            }
        }
        
        if ( isRadiusLock && index1 === "radius" ){
            if ( index2 === "lg" && index3 !== "unit" ){
                radiusArr.radius.lg.top = val;
                radiusArr.radius.lg.right = val;
                radiusArr.radius.lg.bottom = val;
                radiusArr.radius.lg.left = val;
            }
            else if ( index2 === "md" && index3 !== "unit" ){
                radiusArr.radius.md.top = val;
                radiusArr.radius.md.right = val;
                radiusArr.radius.md.bottom = val;
                radiusArr.radius.md.left = val;
            }
            else if ( index2 === "sm" && index3 !== "unit" ){
                radiusArr.radius.sm.top = val;
                radiusArr.radius.sm.right = val;
                radiusArr.radius.sm.bottom = val;
                radiusArr.radius.sm.left = val;
            }
            else if ( index2 === "xs" && index3 !== "unit" ){
                radiusArr.radius.xs.top = val;
                radiusArr.radius.xs.right = val;
                radiusArr.radius.xs.bottom = val;
                radiusArr.radius.xs.left = val;
            }
        }

        setAttributes( {[name]:radiusArr} );
    }

    function foodsearch_cssMount() {
        var css = `
            #fds-block-` + props.block_id + ` .` + props.class + ` {
                border-top: ` + props.attr.width.lg.top + props.attr.width.lg.unit + ` ` + props.attr.type + ` rgba(` + props.attr.color.r + `, ` + props.attr.color.g + `, ` + props.attr.color.b + `, ` + props.attr.color.a + `) ;
                border-right: ` + props.attr.width.lg.right + props.attr.width.lg.unit + ` ` + props.attr.type + ` rgba(` + props.attr.color.r + `, ` + props.attr.color.g + `, ` + props.attr.color.b + `, ` + props.attr.color.a + `) ;
                border-bottom: ` + props.attr.width.lg.bottom + props.attr.width.lg.unit + ` ` + props.attr.type + ` rgba(` + props.attr.color.r + `, ` + props.attr.color.g + `, ` + props.attr.color.b + `, ` + props.attr.color.a + `) ;
                border-left: ` + props.attr.width.lg.left + props.attr.width.lg.unit + ` ` + props.attr.type + ` rgba(` + props.attr.color.r + `, ` + props.attr.color.g + `, ` + props.attr.color.b + `, ` + props.attr.color.a + `) ;
                border-top-left-radius: ` + props.attr.radius.lg.top + props.attr.radius.lg.unit + ` ;
                border-top-right-radius: ` + props.attr.radius.lg.right + props.attr.radius.lg.unit + ` ;
                border-bottom-right-radius: ` + props.attr.radius.lg.bottom + props.attr.radius.lg.unit + ` ;
                border-bottom-left-radius: ` + props.attr.radius.lg.left + props.attr.radius.lg.unit + ` ;
                box-shadow: ` + props.attr.shadow.hor + `px ` + props.attr.shadow.ver + `px ` + props.attr.shadow.blur + `px ` + props.attr.shadow.spread + `px rgba(` + props.attr.shadow.color.r + `, ` + props.attr.shadow.color.g + `, ` + props.attr.shadow.color.b + `, ` + props.attr.shadow.color.a + `) ` + props.attr.shadow.pos + ` ;
            }
            .` + props.name + ` {
              ` + `background: rgba(` + props.attr.color.r + `, ` + props.attr.color.g + `, ` + props.attr.color.b + `, ` + props.attr.color.a + `) ;
            }
            `;
        var elem = document.getElementById('res-listing-' + props.block_id );
        elem.innerHTML = elem.innerHTML + css;
    }
    function foodsearch_html_width(val){
      return (
        <>
          <div className="fds-res-control">
              <ButtonGroup className="fds-res-unit">
                  <Button variant="tertiary" label="Pixel" className={props.attr.width[val].unit == "px" ? "active" : ""} onClick={() => ( prepare_val("width", val, "unit", "px") )} >PX</Button>
                  <Button variant="tertiary" label="EM" className={props.attr.width[val].unit == "em" ? "active" : ""} onClick={() => ( prepare_val("width", val, "unit", "em") )} >EM</Button>
                  <Button variant="tertiary" label="Percent" className={props.attr.width[val].unit == "%" ? "active" : ""} onClick={() => ( prepare_val("width", val, "unit", "%") )} >%</Button>
              </ButtonGroup>
          </div>
          <div className="fds-res-control-input">
              <NumberControl label={__( 'top', 'wp-foodsearch' )} onChange={ ( newval ) => { prepare_val("width", val, "top", newval) }} value={props.attr.width[val].top} />
              <NumberControl label={__( 'right', 'wp-foodsearch' )} onChange={ ( newval ) => { prepare_val("width", val, "right", newval) }} value={props.attr.width[val].right} />
              <NumberControl label={__( 'bottom', 'wp-foodsearch' )} onChange={ ( newval ) => { prepare_val("width", val, "bottom", newval) }} value={props.attr.width[val].bottom} />
              <NumberControl label={__( 'left', 'wp-foodsearch' )} onChange={ ( newval ) => { prepare_val("width", val, "left", newval) }} value={props.attr.width[val].left} />
              <ButtonGroup>
                  <Button variant="primary" className={isWidthLock ? "active" : ""} icon={isWidthLock ? "dashicons dashicons-admin-links" : "dashicons dashicons-admin-links"} onClick={() => ( setWidthLock(!isWidthLock) )} ></Button>
              </ButtonGroup>
          </div>
        </>
      )
    }
    function foodsearch_html_radius(val){
      return (
        <>
          <div className="fds-res-control">
              <ButtonGroup className="fds-res-unit">
                  <Button variant="tertiary" label="Pixel" className={props.attr.radius[val].unit == "px" ? "active" : ""} onClick={() => ( prepare_val("radius", val, "unit", "px") )} >PX</Button>
                  <Button variant="tertiary" label="EM" className={props.attr.radius[val].unit == "em" ? "active" : ""} onClick={() => ( prepare_val("radius", val, "unit", "em") )} >EM</Button>
                  <Button variant="tertiary" label="Percent" className={props.attr.radius[val].unit == "%" ? "active" : ""} onClick={() => ( prepare_val("radius", val, "unit", "%") )} >%</Button>
              </ButtonGroup>
          </div>
          <div className="fds-res-control-input">
              <NumberControl label={__( 'top left', 'wp-foodsearch' )} onChange={ ( newval ) => { prepare_val("radius", val, "top", newval) }} value={props.attr.radius[val].top} />
              <NumberControl label={__( 'top right', 'wp-foodsearch' )} onChange={ ( newval ) => { prepare_val("radius", val, "right", newval) }} value={props.attr.radius[val].right} />
              <NumberControl label={__( 'bottom right', 'wp-foodsearch' )} onChange={ ( newval ) => { prepare_val("radius", val, "bottom", newval) }} value={props.attr.radius[val].bottom} />
              <NumberControl label={__( 'bottom left', 'wp-foodsearch' )} onChange={ ( newval ) => { prepare_val("radius", val, "left", newval) }} value={props.attr.radius[val].left} />
              <ButtonGroup>
                  <Button variant="primary" className={isRadiusLock ? "active" : ""} icon={isRadiusLock ? "dashicons dashicons-admin-links" : "dashicons dashicons-admin-links"} onClick={() => ( setRadiusLock(!isRadiusLock) )} ></Button>
              </ButtonGroup>
          </div>
        </>
      )
    }

    return (
        <div>
            <div className='fds-option-component'>
                <SelectControl label={__( 'border type', 'wp-foodsearch' )} onChange={ ( newval ) => { prepare_val("type", "", "", newval) }} value={props.attr.type}
                    options={ [
                        { label: 'None', value: 'None' },
                        { label: 'Solid', value: 'Solid' },
                        { label: 'Double', value: 'Double' },
                        { label: 'Dotted', value: 'Dotted' },
                        { label: 'Dashed', value: 'Dashed' },
                        { label: 'Groove', value: 'Groove' },
                    ] }
                />
            </div>
            {props.attr.type !== "None" && 
                <>
                <div className="responsive-row">
                    <div className="fds-res-control">
                    {__( 'width', 'wp-foodsearch' )}
                        {props.isRes == 1 &&
                            <ButtonGroup>
                                <Button variant="primary" label="Desktop" icon="dashicons dashicons-desktop" className={isWidthRes === "lg" ? "active" : ""} onClick={() => ( setWidthRes("lg") )} ></Button>
                                <Button variant="primary" label="Laptop" icon="dashicons dashicons-laptop" className={isWidthRes === "md" ? "active" : ""} onClick={() => ( setWidthRes("md") )} ></Button>
                                <Button variant="primary" label="Tablet" icon="dashicons dashicons-tablet" className={isWidthRes === "sm" ? "active" : ""} onClick={() => ( setWidthRes("sm") )} ></Button>
                                <Button variant="primary" label="Smartphone" icon="dashicons dashicons-smartphone" className={isWidthRes === "xs" ? "active" : ""} onClick={() => ( setWidthRes("xs") )} ></Button>
                            </ButtonGroup>
                        }
                    </div>
                    {isWidthRes === "lg" && foodsearch_html_width("lg") }
                    {isWidthRes === "md" && foodsearch_html_width("md") }
                    {isWidthRes === "sm" && foodsearch_html_width("sm") }
                    {isWidthRes === "xs" && foodsearch_html_width("xs") }
                </div>
                <div className="fds-main-popup">
                    <span className='fds-color-title'>{__( 'border color', 'wp-foodsearch' )}</span>
                    <div className='fds-reset-color'>
                      { props.attr.color.r !== "" && 
                        <div className=''><Button label="Reset" icon="dashicons dashicons-image-rotate" onClick={() => ( prepare_val("color", "", "", radiusArr.color) )} ></Button></div>
                      }
                      <OutsideClickHandler onOutsideClick={() => { setColor(false) }} >
                          <div className='fds-color-btn'><Button className={props.name} label="Color" onClick={() => ( setColor(!isColor) )} ></Button></div>
                          { isColor === true && 
                              <ColorPicker 
                                color={`rgba(` + props.attr.color.r + `, ` + props.attr.color.g + `, ` + props.attr.color.b + `, ` + props.attr.color.a + `)`}
                                onChangeComplete={(newval) => prepare_val("color", "", "", newval.rgb)} 
                              />
                          }
                      </OutsideClickHandler>
                      </div>
                </div>
                </>
            }
            <div className="responsive-row">
                <div className="fds-res-control">
                {__( 'border radius', 'wp-foodsearch' )} 
                    {props.isRes == 1 &&
                        <ButtonGroup>
                            <Button variant="primary" label="Desktop" icon="dashicons dashicons-desktop" className={isRadiusRes === "lg" ? "active" : ""} onClick={() => ( setRadiusRes("lg") )} ></Button>
                            <Button variant="primary" label="Laptop" icon="dashicons dashicons-laptop" className={isRadiusRes === "md" ? "active" : ""} onClick={() => ( setRadiusRes("md") )} ></Button>
                            <Button variant="primary" label="Tablet" icon="dashicons dashicons-tablet" className={isRadiusRes === "sm" ? "active" : ""} onClick={() => ( setRadiusRes("sm") )} ></Button>
                            <Button variant="primary" label="Smartphone" icon="dashicons dashicons-smartphone" className={isRadiusRes === "xs" ? "active" : ""} onClick={() => ( setRadiusRes("xs") )} ></Button>
                        </ButtonGroup>
                    }
                </div>
                    {isRadiusRes === "lg" && foodsearch_html_radius("lg") }
                    {isRadiusRes === "md" && foodsearch_html_radius("md") }
                    {isRadiusRes === "sm" && foodsearch_html_radius("sm") }
                    {isRadiusRes === "xs" && foodsearch_html_radius("xs") }
            </div>
            <div className="fds-main-popup">
                <span className='fds-color-title'>{__( 'box shadow', 'wp-foodsearch' )} </span>
                <div className='fds-reset-color'>
                  { props.attr.shadow.color !== "" && 
                    <Button label="Reset" icon="dashicons dashicons-image-rotate" onClick={() => ( prepare_val("shadow", "color", "", radiusArr.shadow.color) )} ></Button>
                  }
                  <OutsideClickHandler onOutsideClick={() => { setShadow(false) }} >
                      <div className='fds-typo-btn'><Button label="Box Shadow" icon="dashicons dashicons-edit" onClick={() => ( setShadow(!isShadow) )} ></Button></div>
                      { isShadow === true && 
                          <div className='fds-typo-popup'>
                              <div className="fds-main-popup">
                                  <span className='fds-color-title'>{__( 'shadow color', 'wp-foodsearch' )}</span>
                                  <OutsideClickHandler onOutsideClick={() => { setShadowColor(false) }} >
                                      <div className='fds-color-btn'><Button label="Color" onClick={() => ( setShadowColor(!isShadowColor) )} style={{ background: `rgba(` + props.attr.shadow.color.r + `, ` + props.attr.shadow.color.g + `, ` + props.attr.shadow.color.b + `, ` + props.attr.shadow.color.a + `)` }} ></Button></div>
                                      { isShadowColor === true && 
                                          <ColorPicker 
                                            color={`rgba(` + props.attr.shadow.color.r + `, ` + props.attr.shadow.color.g + `, ` + props.attr.shadow.color.b + `, ` + props.attr.shadow.color.a + `)`}
                                            onChangeComplete={(newval) => prepare_val("shadow", "color", "", newval.rgb)} 
                                          />
                                      }
                                  </OutsideClickHandler>
                              </div>
                              <div className="responsive-row">
                                  <div className="fds-res-control">{__( 'horizontal', 'wp-foodsearch' )}</div>
                                  <RangeControl className="range-control" min={ -100 } max={ 100 } onChange={ ( newval ) => { prepare_val("shadow", "hor", "", newval) }} value={props.attr.shadow.hor} />
                                  <div className="fds-res-control">{__( 'vertical', 'wp-foodsearch' )}</div>
                                  <RangeControl className="range-control" min={ -100 } max={ 100 } onChange={ ( newval ) => { prepare_val("shadow", "ver", "", newval) }} value={props.attr.shadow.ver} />
                                  <div className="fds-res-control">{__( 'blur', 'wp-foodsearch' )}</div>
                                  <RangeControl className="range-control" min={ 0 } max={ 100 } onChange={ ( newval ) => { prepare_val("shadow", "blur", "", newval) }} value={props.attr.shadow.blur} />
                                  <div className="fds-res-control">{__( 'spread', 'wp-foodsearch' )}</div>
                                  <RangeControl className="range-control" min={ -100 } max={ 100 } onChange={ ( newval ) => { prepare_val("shadow", "spread", "", newval) }} value={props.attr.shadow.spread} />
                              </div>
                              <div className='fds-option-component'>
                                  <SelectControl label={__( 'position', 'wp-foodsearch' )} onChange={ ( newval ) => { prepare_val("shadow", "pos", "", newval) }} value={props.attr.shadow.pos}
                                      options={ [
                                          { label: 'Outline', value: '' },
                                          { label: 'Inset', value: 'Inset' },
                                      ] }
                                  />
                              </div>
                          </div>
                      }
                  </OutsideClickHandler>
                </div>
            </div>
            { foodsearch_cssMount() }
        </div>
)
}

export default Border;