const { Button, ColorPicker } = wp.components;
const { __ } = wp.i18n;
import { useState } from '@wordpress/element';
import { isEmpty } from 'lodash';
import OutsideClickHandler from 'react-outside-click-handler';

export const Color = (props) => {
    const { setAttributes } = props;
    const [isColor, setColor] = useState(false);
    var name = props.name;

    var colorArr = {
        "r":"",
        "g":"",
        "b":"",
        "a":"",
    };

    const prepare_val = (val) => {
        colorArr.r = val.r;
        colorArr.g = val.g;
        colorArr.b = val.b;
        colorArr.a = val.a;
    
        setAttributes( {[name]:colorArr} );
    }
    
    function foodsearch_cssMount() {
      var css = ``;
      if ( props.attr.r !== "" ){
        css = `
            #fds-block-` + props.block_id + ` .` + props.class + ` {
                ` + ((props.isbg) ? "background-" : "") + `color: rgba(` + props.attr.r + `, ` + props.attr.g + `, ` + props.attr.b + `, ` + props.attr.a + `) ;
            }
            .` + props.name + ` {
              ` + `background: rgba(` + props.attr.r + `, ` + props.attr.g + `, ` + props.attr.b + `, ` + props.attr.a + `) ;
            }
        `;
      }
        var elem = document.getElementById('res-listing-' + props.block_id );

        var ih = elem.innerHTML;

        elem.innerHTML = ih + css;
    }

    return (
        <div className="fds-main-popup">
            <span className='fds-color-title'>{props.title}</span>
            <div className='fds-reset-color'>
              { props.attr.r !== "" && 
                <Button label="Reset" icon="dashicons dashicons-image-rotate" onClick={() => ( setAttributes( {[name]:colorArr} ) )} ></Button>
              }
              <OutsideClickHandler
                  onOutsideClick={() => {
                      setColor(false)
                  }}
                >
                  <div className='fds-color-btn' ><Button className={props.name} label={__('color', 'wp-foodsearch')} onClick={() => ( setColor(!isColor) )} ></Button></div>
                  { isColor === true && 
                      <ColorPicker
                          color={`rgba(` + props.attr.r + `, ` + props.attr.g + `, ` + props.attr.b + `, ` + props.attr.a + `)`}
                          onChangeComplete={(newval) => prepare_val(newval.rgb)}
                          enableAlpha = "true"
                      />
                  }
              </OutsideClickHandler>
            </div>
            { foodsearch_cssMount() }
        </div>
    )
}

export default Color;