const { Button, ButtonGroup, div, SelectControl, RangeControl } = wp.components;
const { __ } = wp.i18n;
import { useState } from '@wordpress/element';
import React from 'react';
import Select from 'react-select';
import WebFont from 'webfontloader';
import {Font} from "../assets/font.js";
import OutsideClickHandler from 'react-outside-click-handler';

var googleFonts = [];
Font.items.map((item, index) => {
    googleFonts.push({value: item.family, label: item.family});
   
});
const Fonts = [
    { value: 'None', label: 'None' },
    { 
        label: "Standard Fonts",
        options: [
            { value: 'arial', label: 'Arial' },
            { value: 'tahoma', label: 'Tahoma' },
            { value: 'verdana', label: 'Verdana' },
            { value: 'helvitica', label: 'Helvitica' },
            { value: 'times-new-roman', label: 'Times New Roman' },
            { value: 'trebuchet-ms', label: 'Trebuchet MS' },
            { value: 'georgia', label: 'Georgia' },
        ]
    },
    { 
        label: "Google Webfonts",
        options: googleFonts
    },

]

function foodsearch_add_options(variants, name) {
    var x = document.getElementById(name);
    if ( x ){
        document.getElementById(name).options.length = 0;
        // adding blank option
        var option = document.createElement("option");
        option.text = "";
        option.value = "";
        x.add(option);
          var option = document.createElement("option");
          option.text = "regular";
          option.value = "normal";
          x.add(option);
        // adding blank option
        variants.map((item) => {
            if ( item > 0 ){
                var option = document.createElement("option");
                option.text = item;
                option.value = item;
                x.add(option);
            }
        });

    }
}

const getFontWeight = (e, name) => {
    if ( e == "arial" || e == "tahoma" || e == "verdana" || e == "helvitica" || e == "times-new-roman" || e == "trebuchet-ms" || e == "georgia" ) {
      const variants = ["100", "200", "300", "500", "600", "700", "800", "900"];
      foodsearch_add_options(variants, name);
    }
    else {
      Font.items.map((item, index) => {
          if(item.family.indexOf( e ) >= 0){
              foodsearch_add_options(Font.items[index].variants, name);
          }
      });
    }
}

const loadFontWeight = (family, weight) => {
    if ( family == "arial" || family == "tahoma" || family == "verdana" || family == "helvitica" || family == "times-new-roman" || family == "trebuchet-ms" || family == "georgia" ) {
    }
    else {
      if ( weight === "normal" || weight === "" ) weight = "";
      else weight = ":wght@" + weight;
      WebFont.load({
          google: {
              families: [family + weight + '&display=swap']
          }
      });
    }
}

export const Typography = (props) => {
    const { setAttributes } = props;
    const [isFontSizeRes, setFontSizeRes] = useState("lg");
    const [isLineHeightRes, setLineHeightRes] = useState("lg");
    const [isLetterSpacingRes, setLetterSpacingRes] = useState("lg");
    const [isTypo, setTypo] = useState(false);
    var name = props.name;

    var typoArr = {
      "family":"",
      "weight":"",
      "style":"",
      "transform":"",
      "decoration":"",
      "font":{
          "lg":{"val":'', "unit":''},
          "md":{"val":'', "unit":''},
          "sm":{"val":'', "unit":''},
          "xs":{"val":'', "unit":''},
      },
      "lineHeight":{
          "lg":{"val":'', "unit":''},
          "md":{"val":'', "unit":''},
          "sm":{"val":'', "unit":''},
          "xs":{"val":'', "unit":''},
      },
      "letterSpacing":{
          "lg":{"val":'', "unit":''},
          "md":{"val":'', "unit":''},
          "sm":{"val":'', "unit":''},
          "xs":{"val":'', "unit":''},
      },
    };
    const prepare_val = (index1, index2, index3, val) => {
        typoArr["family"] = props.attr.family;
        typoArr["weight"] = props.attr.weight;
        typoArr["style"] = props.attr.style;
        typoArr["transform"] = props.attr.transform;
        typoArr["decoration"] = props.attr.decoration;

        typoArr.font.lg.val = props.attr.font.lg.val;
        typoArr.font.lg.unit = props.attr.font.lg.unit;
        typoArr.font.md.val = props.attr.font.md.val;
        typoArr.font.md.unit = props.attr.font.md.unit;
        typoArr.font.sm.val = props.attr.font.sm.val;
        typoArr.font.sm.unit = props.attr.font.sm.unit;
        typoArr.font.xs.val = props.attr.font.xs.val;
        typoArr.font.xs.unit = props.attr.font.xs.unit;
        
        typoArr.lineHeight.lg.val = props.attr.lineHeight.lg.val;
        typoArr.lineHeight.lg.unit = props.attr.lineHeight.lg.unit;
        typoArr.lineHeight.md.val = props.attr.lineHeight.md.val;
        typoArr.lineHeight.md.unit = props.attr.lineHeight.md.unit;
        typoArr.lineHeight.sm.val = props.attr.lineHeight.sm.val;
        typoArr.lineHeight.sm.unit = props.attr.lineHeight.sm.unit;
        typoArr.lineHeight.xs.val = props.attr.lineHeight.xs.val;
        typoArr.lineHeight.xs.unit = props.attr.lineHeight.xs.unit;
    
        typoArr.letterSpacing.lg.val = props.attr.letterSpacing.lg.val;
        typoArr.letterSpacing.lg.unit = props.attr.letterSpacing.lg.unit;
        typoArr.letterSpacing.md.val = props.attr.letterSpacing.md.val;
        typoArr.letterSpacing.md.unit = props.attr.letterSpacing.md.unit;
        typoArr.letterSpacing.sm.val = props.attr.letterSpacing.sm.val;
        typoArr.letterSpacing.sm.unit = props.attr.letterSpacing.sm.unit;
        typoArr.letterSpacing.xs.val = props.attr.letterSpacing.xs.val;
        typoArr.letterSpacing.xs.unit = props.attr.letterSpacing.xs.unit;

        if (index2 == "" && index3 == "") typoArr[index1] = val;
        else if (index3 == "") typoArr[index1][index2] = val;
        else typoArr[index1][index2][index3] = val;

        setAttributes( {[name]:typoArr} );

    }

    function foodsearch_cssMount() {
        var css = `
            #fds-block-` + props.block_id + ` .` + props.class + ` {
                font-family: "` + (props.attr.family ? props.attr.family.value : "") + `" ;
                font-weight: ` + props.attr.weight + ` ;
                font-style: ` + props.attr.style + ` ;
                text-transform: ` + props.attr.transform + ` ;
                text-decoration: ` + props.attr.decoration + ` ;
                font-size: ` + props.attr.font.lg.val + props.attr.font.lg.unit + ` ;
                line-height: ` + props.attr.lineHeight.lg.val + props.attr.lineHeight.lg.unit + ` ;
                letter-spacing: ` + props.attr.letterSpacing.lg.val + props.attr.letterSpacing.lg.unit + ` ;
        }
        `;
        var elem = document.getElementById('res-listing-' + props.block_id );
        elem.innerHTML = elem.innerHTML + css;
    }

    return (
        <div className="fds-main-popup">
            <span className='fds-color-title'>{props.title ? props.title : __( 'typography', 'wp-foodsearch' )}:</span>
            <OutsideClickHandler onOutsideClick={() => { setTypo(false) }} >
                <div className='fds-typo-btn'><Button label="Typography" icon="dashicons dashicons-edit" onClick={() => ( setTypo(!isTypo), getFontWeight(props.attr.family.value, name) )} ></Button></div>
                    <div className='fds-typo-popup' style={{ display: (isTypo === true) ? "inline" : "none" }}>
                        <div className='fds-typo-family'>
                            <span className='fds-family-title'>{__( 'font family', 'wp-foodsearch' )}</span>
                            <Select
                                name='family'
                                className="select2-multi"
                                value={ props.attr["family"] }
                                options={ Fonts }
                                onChange={ ( family ) => { 
                                    prepare_val("family", "", "", family),
                                    getFontWeight(family.value, name),
                                    loadFontWeight(family.value, "normal")
                                }}
                            />
                        </div>
                        <div className='fds-option-component'>
                            <SelectControl
                                label={__( 'font weight', 'wp-foodsearch' )}
                                id={[name]}
                                value={ props.attr["weight"] }
                                options={ [
                                    { label: '', value: '' },
                                ] }
                                onChange={ ( newval ) => { 
                                    loadFontWeight(props.attr.family.value, newval),
                                    prepare_val("weight", "", "", newval)
                                }}
                            />
                        </div>
                        <div className='fds-option-component'>
                            <SelectControl
                                label={__( 'font style', 'wp-foodsearch' )}
                                value={props.attr["style"]}
                                options={ [
                                    { label: 'Normal', value: 'normal' },
                                    { label: 'Italic', value: 'italic' },
                                    { label: 'Oblique', value: 'oblique' },
                                ] }
                                onChange={ ( newval ) => { 
                                    prepare_val("style", "", "", newval)
                                }}
                            />
                        </div>
                        <div className='fds-option-component'>
                            <SelectControl
                                label={__( 'transform', 'wp-foodsearch' )}
                                value={props.attr["transform"]}
                                options={ [
                                    { label: 'Inherit', value: 'inherit' },
                                    { label: 'Capitalize', value: 'capitalize' },
                                    { label: 'Lowercase', value: 'lowercase' },
                                    { label: 'Uppercase', value: 'uppercase' },
                                ] }
                                onChange={ ( newval ) => { 
                                    prepare_val("transform", "", "", newval)
                                }}
                            />
                        </div>
                        <div className='fds-option-component'>
                            <SelectControl
                                label={__( 'decoration', 'wp-foodsearch' )}
                                value= {props.attr["decoration"]}
                                options={ [
                                    { label: 'None', value: 'none' },
                                    { label: 'Inherit', value: 'inherit' },
                                    { label: 'Underline', value: 'underline' },
                                    { label: 'Overline', value: 'overline' },
                                    { label: 'Line Through', value: 'line-through' },
                                ] }
                                onChange={ ( newval ) => { 
                                    prepare_val("decoration", "", "", newval)
                                }}
                            />
                        </div>
                        <div className="responsive-row">
                            <div className="fds-res-control">
                            {__( 'font size', 'wp-foodsearch' )} 
                                {props.isRes == 1 &&
                                    <ButtonGroup>
                                        <Button variant="primary" label="Desktop" icon="dashicons dashicons-desktop" className={isFontSizeRes === "lg" ? "active" : ""} onClick={() => ( setFontSizeRes("lg") )} ></Button>
                                        <Button variant="primary" label="Laptop" icon="dashicons dashicons-laptop" className={isFontSizeRes === "md" ? "active" : ""} onClick={() => ( setFontSizeRes("md") )} ></Button>
                                        <Button variant="primary" label="Tablet" icon="dashicons dashicons-tablet" className={isFontSizeRes === "sm" ? "active" : ""} onClick={() => ( setFontSizeRes("sm") )} ></Button>
                                        <Button variant="primary" label="Smartphone" icon="dashicons dashicons-smartphone" className={isFontSizeRes === "xs" ? "active" : ""} onClick={() => ( setFontSizeRes("xs") )} ></Button>
                                    </ButtonGroup>
                                }
                            </div>
                            {isFontSizeRes === "lg" &&
                                <>
                                <div className="fds-res-control">
                                    <ButtonGroup className="fds-res-unit">
                                        <Button variant="tertiary" label="Pixel" className={props.attr.font.lg.unit == "px" ? "active" : ""} onClick={() => ( prepare_val("font", "lg", "unit", "px") )} >PX</Button>
                                        <Button variant="tertiary" label="EM" className={props.attr.font.lg.unit == "em" ? "active" : ""} onClick={() => ( prepare_val("font", "lg", "unit", "em") )} >EM</Button>
                                        <Button variant="tertiary" label="Percent" className={props.attr.font.lg.unit == "%" ? "active" : ""} onClick={() => ( prepare_val("font", "lg", "unit", "%") )} >%</Button>
                                    </ButtonGroup>
                                </div>
                                <RangeControl
                                    value={props.attr.font.lg.val} className="range-control" min={ 1 } max={ 300 } step={ 0.01 } initialPosition={``}
                                    onChange={ ( newval ) => { 
                                        prepare_val("font", "lg", "val", newval)
                                    }}
                                />
                                </>
                            }
                            {isFontSizeRes === "md" &&
                                <>
                                <div className="fds-res-control">
                                    <ButtonGroup className="fds-res-unit">
                                        <Button variant="tertiary" label="Pixel" className={props.attr.font.md.unit == "px" ? "active" : ""} onClick={() => ( prepare_val("font", "md", "unit", "px") )} >PX</Button>
                                        <Button variant="tertiary" label="EM" className={props.attr.font.md.unit == "em" ? "active" : ""} onClick={() => ( prepare_val("font", "md", "unit", "em") )} >EM</Button>
                                        <Button variant="tertiary" label="Percent" className={props.attr.font.md.unit == "%" ? "active" : ""} onClick={() => ( prepare_val("font", "md", "unit", "%") )} >%</Button>
                                    </ButtonGroup>
                                </div>
                                <RangeControl
                                    value={props.attr.font.md.val} className="range-control" min={ 1 } max={ 300 } step={ 0.01 } 
                                    onChange={ ( newval ) => { 
                                        prepare_val("font", "md", "val", newval)
                                    }}
                                />
                                </>
                            }
                            {isFontSizeRes === "sm" &&
                                <>
                                <div className="fds-res-control">
                                    <ButtonGroup className="fds-res-unit">
                                        <Button variant="tertiary" label="Pixel" className={props.attr.font.sm.unit == "px" ? "active" : ""} onClick={() => ( prepare_val("font", "sm", "unit", "px") )} >PX</Button>
                                        <Button variant="tertiary" label="EM" className={props.attr.font.sm.unit == "em" ? "active" : ""} onClick={() => ( prepare_val("font", "sm", "unit", "em") )} >EM</Button>
                                        <Button variant="tertiary" label="Percent" className={props.attr.font.sm.unit == "%" ? "active" : ""} onClick={() => ( prepare_val("font", "sm", "unit", "%") )} >%</Button>
                                    </ButtonGroup>
                                </div>
                                <RangeControl
                                    value={props.attr.font.sm.val} className="range-control" min={ 1 } max={ 300 } step={ 0.01 } 
                                    onChange={ ( newval ) => { 
                                        prepare_val("font", "sm", "val", newval)
                                    }}
                                />
                                </>
                            }
                            {isFontSizeRes === "xs" &&
                                <>
                                <div className="fds-res-control">
                                    <ButtonGroup className="fds-res-unit">
                                        <Button variant="tertiary" label="Pixel" className={props.attr.font.xs.unit == "px" ? "active" : ""} onClick={() => ( prepare_val("font", "xs", "unit", "px") )} >PX</Button>
                                        <Button variant="tertiary" label="EM" className={props.attr.font.xs.unit == "em" ? "active" : ""} onClick={() => ( prepare_val("font", "xs", "unit", "em") )} >EM</Button>
                                        <Button variant="tertiary" label="Percent" className={props.attr.font.xs.unit == "%" ? "active" : ""} onClick={() => ( prepare_val("font", "xs", "unit", "%") )} >%</Button>
                                    </ButtonGroup>
                                </div>
                                <RangeControl
                                    value={props.attr.font.xs.val} className="range-control" min={ 1 } max={ 300 } step={ 0.01 } 
                                    onChange={ ( newval ) => { 
                                        prepare_val("font", "xs", "val", newval)
                                    }}
                                />
                                </>
                            }
                        </div>

                        <div className="responsive-row">
                            <div className="fds-res-control">
                            {__( 'line height', 'wp-foodsearch' )} 
                                {props.isRes == 1 &&
                                    <ButtonGroup className="responsive-btn">
                                        <Button variant="primary" label="Desktop" icon="dashicons dashicons-desktop" className={isLineHeightRes === "lg" ? "active" : ""} onClick={() => ( setLineHeightRes("lg") )} ></Button>
                                        <Button variant="primary" label="Laptop" icon="dashicons dashicons-laptop" className={isLineHeightRes === "md" ? "active" : ""} onClick={() => ( setLineHeightRes("md") )} ></Button>
                                        <Button variant="primary" label="Tablet" icon="dashicons dashicons-tablet" className={isLineHeightRes === "sm" ? "active" : ""} onClick={() => ( setLineHeightRes("sm") )} ></Button>
                                        <Button variant="primary" label="Smartphone" icon="dashicons dashicons-smartphone" className={isLineHeightRes === "xs" ? "active" : ""} onClick={() => ( setLineHeightRes("xs") )} ></Button>
                                    </ButtonGroup>
                                }
                            </div>
                            {isLineHeightRes === "lg" &&
                                <>
                                <div className="fds-res-control">
                                    <ButtonGroup className="fds-res-unit">
                                        <Button variant="tertiary" label="Pixel" className={props.attr.lineHeight.lg.unit == "px" ? "active" : ""} onClick={() => ( prepare_val("lineHeight", "lg", "unit", "px") )} >PX</Button>
                                        <Button variant="tertiary" label="EM" className={props.attr.lineHeight.lg.unit == "em" ? "active" : ""} onClick={() => ( prepare_val("lineHeight", "lg", "unit", "em") )} >EM</Button>
                                        <Button variant="tertiary" label="Percent" className={props.attr.lineHeight.lg.unit == "%" ? "active" : ""} onClick={() => ( prepare_val("lineHeight", "lg", "unit", "%") )} >%</Button>
                                    </ButtonGroup>
                                </div>
                                <RangeControl
                                    value={props.attr.lineHeight.lg.val} className="range-control" min={ 1 } max={ 300 } step={ 0.01 } initialPosition={``}
                                    onChange={ ( newval ) => { 
                                        prepare_val("lineHeight", "lg", "val", newval)
                                    }}
                                />
                                </>
                            }
                            {isLineHeightRes === "md" &&
                                <>
                                <div className="fds-res-control">
                                    <ButtonGroup className="fds-res-unit">
                                        <Button variant="tertiary" label="Pixel" className={props.attr.lineHeight.md.unit == "px" ? "active" : ""} onClick={() => ( prepare_val("lineHeight", "md", "unit", "px") )} >PX</Button>
                                        <Button variant="tertiary" label="EM" className={props.attr.lineHeight.md.unit == "em" ? "active" : ""} onClick={() => ( prepare_val("lineHeight", "md", "unit", "em") )} >EM</Button>
                                        <Button variant="tertiary" label="Percent" className={props.attr.lineHeight.md.unit == "%" ? "active" : ""} onClick={() => ( prepare_val("lineHeight", "md", "unit", "%") )} >%</Button>
                                    </ButtonGroup>
                                </div>
                                <RangeControl
                                    value={props.attr.lineHeight.md.val} className="range-control" min={ 1 } max={ 300 } step={ 0.01 } initialPosition={``}
                                    onChange={ ( newval ) => { 
                                        prepare_val("lineHeight", "md", "val", newval)
                                    }}
                                />
                                </>
                            }
                            {isLineHeightRes === "sm" &&
                                <>
                                <div className="fds-res-control">
                                    <ButtonGroup className="fds-res-unit">
                                        <Button variant="tertiary" label="Pixel" className={props.attr.lineHeight.sm.unit == "px" ? "active" : ""} onClick={() => ( prepare_val("lineHeight", "sm", "unit", "px") )} >PX</Button>
                                        <Button variant="tertiary" label="EM" className={props.attr.lineHeight.sm.unit == "em" ? "active" : ""} onClick={() => ( prepare_val("lineHeight", "sm", "unit", "em") )} >EM</Button>
                                        <Button variant="tertiary" label="Percent" className={props.attr.lineHeight.sm.unit == "%" ? "active" : ""} onClick={() => ( prepare_val("lineHeight", "sm", "unit", "%") )} >%</Button>
                                    </ButtonGroup>
                                </div>
                                <RangeControl
                                    value={props.attr.lineHeight.sm.val} className="range-control" min={ 1 } max={ 300 } step={ 0.01 } initialPosition={``}
                                    onChange={ ( newval ) => { 
                                        prepare_val("lineHeight", "sm", "val", newval)
                                    }}
                                />
                                </>
                            }
                            {isLineHeightRes === "xs" &&
                                <>
                                <div className="fds-res-control">
                                    <ButtonGroup className="fds-res-unit">
                                        <Button variant="tertiary" label="Pixel" className={props.attr.lineHeight.xs.unit == "px" ? "active" : ""} onClick={() => ( prepare_val("lineHeight", "xs", "unit", "px") )} >PX</Button>
                                        <Button variant="tertiary" label="EM" className={props.attr.lineHeight.xs.unit == "em" ? "active" : ""} onClick={() => ( prepare_val("lineHeight", "xs", "unit", "em") )} >EM</Button>
                                        <Button variant="tertiary" label="Percent" className={props.attr.lineHeight.xs.unit == "%" ? "active" : ""} onClick={() => ( prepare_val("lineHeight", "xs", "unit", "%") )} >%</Button>
                                    </ButtonGroup>
                                </div>
                                <RangeControl
                                    value={props.attr.lineHeight.xs.val} className="range-control" min={ 1 } max={ 300 } step={ 0.01 } initialPosition={``}
                                    onChange={ ( newval ) => { 
                                        prepare_val("lineHeight", "xs", "val", newval)
                                    }}
                                />
                                </>
                            }
                        </div>

                        <div className="responsive-row">
                            <div className="fds-res-control">
                            {__( 'letter spacing', 'wp-foodsearch' )} 
                                {props.isRes == 1 &&
                                    <ButtonGroup className="responsive-btn">
                                        <Button variant="primary" label="Desktop" icon="dashicons dashicons-desktop" className={isLetterSpacingRes === "lg" ? "active" : ""} onClick={() => ( setLetterSpacingRes("lg") )} ></Button>
                                        <Button variant="primary" label="Laptop" icon="dashicons dashicons-laptop" className={isLetterSpacingRes === "md" ? "active" : ""} onClick={() => ( setLetterSpacingRes("md") )} ></Button>
                                        <Button variant="primary" label="Tablet" icon="dashicons dashicons-tablet" className={isLetterSpacingRes === "sm" ? "active" : ""} onClick={() => ( setLetterSpacingRes("sm") )} ></Button>
                                        <Button variant="primary" label="Smartphone" icon="dashicons dashicons-smartphone" className={isLetterSpacingRes === "xs" ? "active" : ""} onClick={() => ( setLetterSpacingRes("xs") )} ></Button>
                                    </ButtonGroup>
                                }
                            </div>
                            {isLetterSpacingRes === "lg" &&
                                <>
                                <div className="fds-res-control">
                                    <ButtonGroup className="fds-res-unit">
                                        <Button variant="tertiary" label="Pixel" className={props.attr.letterSpacing.lg.unit == "px" ? "active" : ""} onClick={() => ( prepare_val("letterSpacing", "lg", "unit", "px") )} >PX</Button>
                                        <Button variant="tertiary" label="EM" className={props.attr.letterSpacing.lg.unit == "em" ? "active" : ""} onClick={() => ( prepare_val("letterSpacing", "lg", "unit", "em") )} >EM</Button>
                                        <Button variant="tertiary" label="Percent" className={props.attr.letterSpacing.lg.unit == "%" ? "active" : ""} onClick={() => ( prepare_val("letterSpacing", "lg", "unit", "%") )} >%</Button>
                                    </ButtonGroup>
                                </div>
                                <RangeControl
                                    value={props.attr.letterSpacing.lg.val} className="range-control" min={ 1 } max={ 300 } step={ 0.01 } initialPosition={``}
                                    onChange={ ( newval ) => { 
                                        prepare_val("letterSpacing", "lg", "val", newval)
                                    }}
                                />
                                </>
                            }
                            {isLetterSpacingRes === "md" &&
                                <>
                                <div className="fds-res-control">
                                    <ButtonGroup className="fds-res-unit">
                                        <Button variant="tertiary" label="Pixel" className={props.attr.letterSpacing.md.unit == "px" ? "active" : ""} onClick={() => ( prepare_val("letterSpacing", "md", "unit", "px") )} >PX</Button>
                                        <Button variant="tertiary" label="EM" className={props.attr.letterSpacing.md.unit == "em" ? "active" : ""} onClick={() => ( prepare_val("letterSpacing", "md", "unit", "em") )} >EM</Button>
                                        <Button variant="tertiary" label="Percent" className={props.attr.letterSpacing.md.unit == "%" ? "active" : ""} onClick={() => ( prepare_val("letterSpacing", "md", "unit", "%") )} >%</Button>
                                    </ButtonGroup>
                                </div>
                                <RangeControl
                                    value={props.attr.letterSpacing.md.val} className="range-control" min={ 1 } max={ 300 } step={ 0.01 } initialPosition={``}
                                    onChange={ ( newval ) => { 
                                        prepare_val("letterSpacing", "md", "val", newval)
                                    }}
                                />
                                </>
                            }
                            {isLetterSpacingRes === "sm" &&
                                <>
                                <div className="fds-res-control">
                                    <ButtonGroup className="fds-res-unit">
                                        <Button variant="tertiary" label="Pixel" className={props.attr.letterSpacing.sm.unit == "px" ? "active" : ""} onClick={() => ( prepare_val("letterSpacing", "sm", "unit", "px") )} >PX</Button>
                                        <Button variant="tertiary" label="EM" className={props.attr.letterSpacing.sm.unit == "em" ? "active" : ""} onClick={() => ( prepare_val("letterSpacing", "sm", "unit", "em") )} >EM</Button>
                                        <Button variant="tertiary" label="Percent" className={props.attr.letterSpacing.sm.unit == "%" ? "active" : ""} onClick={() => ( prepare_val("letterSpacing", "sm", "unit", "%") )} >%</Button>
                                    </ButtonGroup>
                                </div>
                                <RangeControl
                                    value={props.attr.letterSpacing.sm.val} className="range-control" min={ 1 } max={ 300 } step={ 0.01 } initialPosition={``}
                                    onChange={ ( newval ) => { 
                                        prepare_val("letterSpacing", "sm", "val", newval)
                                    }}
                                />
                                </>
                            }
                            {isLetterSpacingRes === "xs" &&
                                <>
                                <div className="fds-res-control">
                                    <ButtonGroup className="fds-res-unit">
                                        <Button variant="tertiary" label="Pixel" className={props.attr.letterSpacing.xs.unit == "px" ? "active" : ""} onClick={() => ( prepare_val("letterSpacing", "xs", "unit", "px") )} >PX</Button>
                                        <Button variant="tertiary" label="EM" className={props.attr.letterSpacing.xs.unit == "em" ? "active" : ""} onClick={() => ( prepare_val("letterSpacing", "xs", "unit", "em") )} >EM</Button>
                                        <Button variant="tertiary" label="Percent" className={props.attr.letterSpacing.xs.unit == "%" ? "active" : ""} onClick={() => ( prepare_val("letterSpacing", "xs", "unit", "%") )} >%</Button>
                                    </ButtonGroup>
                                </div>
                                <RangeControl
                                    value={props.attr.letterSpacing.xs.val} className="range-control" min={ 1 } max={ 300 } step={ 0.01 } initialPosition={``}
                                    onChange={ ( newval ) => { 
                                        prepare_val("letterSpacing", "xs", "val", newval)
                                    }}
                                />
                                </>
                            }
                        </div>

                    </div>
            </OutsideClickHandler>
            { foodsearch_cssMount() }
        </div>
)
}

export default Typography;