<?php 
      add_action('wp_footer', function() {
          global $foodsearch_plugin_settings;
         $format_address =  $latitude = $longitude ='';
          $map_type = isset($foodsearch_plugin_settings['location_settings']['map_type']) ? $foodsearch_plugin_settings['location_settings']['map_type'] : '';
          if ($map_type == 'mapbox') {
            $mapbox_api_key = isset($foodsearch_plugin_settings['api_settings']['mapbox_api']) ? $foodsearch_plugin_settings['api_settings']['mapbox_api'] : '';
            $mapbox_map_style = isset($foodsearch_plugin_settings['location_settings']['mapbox_style']) ? $foodsearch_plugin_settings['location_settings']['mapbox_style'] : '';
            if (!isset($_SESSION['customer_location'])) {
              $visitor_location = FoodSearch\User_Locations::user_current_location();
              $lat = $visitor_location['lat'];
              $lng = $visitor_location['lng'];
              $geo_loc_url = 'https://api.mapbox.com/geocoding/v5/mapbox.places/' . $lng . ',' . $lat . '.json?access_token=' . $mapbox_api_key;
              $location_geo = wp_remote_get($geo_loc_url);
              if (!is_wp_error($location_geo)) {
                if (isset($location_geo['body'])) {
                  $cords_info = json_decode($location_geo['body'], true);
                  $format_address = isset($cords_info['features'][0]['place_name']) ? $cords_info['features'][0]['place_name'] : '';
                  $cords = isset($cords_info['features'][0]['geometry']['coordinates']) ? $cords_info['features'][0]['geometry']['coordinates'] : '';
                  $latitude = isset($cords[1]) ? $cords[1] : '';
                  $longitude = isset($cords[0]) ? $cords[0] : '';

                  $response_array['address'] = $format_address;
                }
              }
            }
            else{
              $visitor_location = $_SESSION['customer_location'];
              $latitude = $lat = $visitor_location['lat'];
              $longitude = $lng = $visitor_location['lng'];
              $format_address = $visitor_location['address'];
              $geo_loc_url = 'https://api.mapbox.com/geocoding/v5/mapbox.places/' . $lng . ',' . $lat . '.json?access_token=' . $mapbox_api_key;
            }
            
          }
          $map_zoom = '';
          $map_zoom = $map_zoom > 0 ? $map_zoom : 6;
         
          $rand_num = rand(100000, 999999);        
          $map_height = '200px';
          $map_width = '100%';
         
        ?>
        <div id="fds-location-mpopup" class="fds-modal-popup fds-popup-hide fds-location-modal">
            <div class="fds-modal-container">
                <a href="javascript:void(0);" class="fds-popup-closebtn fds-link"><i class="fds-icon fds-time-simple"></i></a>
                <div class="fds-modal-inner-area">
                    <div class="fds-modal-content-area">
                        <div class="fds-dynm-modal-content fds-addupd-location fds-user-locations">
                         
                          <div class="fds-location-full-map fds-location-map-outer" data-id="<?php echo absint($rand_num); ?>">
                            <input type="hidden" name="fds_location_map_zoom" class="fds-map-zoom-field" value="<?php echo ($map_zoom) ?>">
                            <div id="fds-map-<?php echo absint($rand_num); ?>" style="width: <?php echo ($map_width) ?>; height: <?php echo ($map_height) ?>;"></div>
                           
                            <div class="fds-location-popup-open">
                              <div class="label_wrap"><label class="fds-input-label"><?php esc_html_e('street address *', 'wp-foodsearch') ?></label></div>

                              <div class="fds-location-popup-filed">
                            <a href="#" id="btn" onclick="" class="fds-get-current-location fds-link"><i class="fds-icon fds-marker-thin"></i> </a>
                                  
                            
                                    <?php
                                    if ($map_type == 'mapbox' && $mapbox_api_key != '' && $mapbox_map_style != '') {
                                        ?>
                                        <div class="fds-mapbox-loc-geocoder"></div>
                                        <?php
                                    } else {
                                        ?>
                                        <input type="text" name="fds_loc_address" id="fdsLocAddressField" class="fds-input-style fds-loc-address-field" required >
                                        <?php
                                    }
                                    ?>
                                    <input type="hidden" name="fds_location_lat" class="fds-map-lat-field" value="<?php echo ($latitude) ?>">
                                    <input type="hidden" name="fds_location_lng" class="fds-map-lng-field" value="<?php echo ($longitude) ?>"> 
                                    <input type="hidden" name="fds_location_address" class="fds-map-adr-field" value="<?php echo ($format_address) ?>"> 
                                    <input type="hidden" name="fds_resturant" class="fds-rest-id-field" value="<?php echo (get_the_ID()) ?>"> 
                              </div>
                              <?php
                          if(is_user_logged_in()){
                                echo '<div class="fds-location-popup-wrap fds-filter-radio"><ul class="fds-options-wrap">';
                            $user = wp_get_current_user();
                            $customer = get_customer_id_by_user_id($user->id);
                                $userID = $customer[0]->ID;
                            
                           // echo '<pre>'.print_r($userID[0]->ID,true).'</pre>';

                            $locationsList = get_saved_location_on_id($userID);
                             
                           // echo '<pre>'.print_r($locationsList,true).'</pre>';
                            $user_or_obj_id = $userID;
                              foreach($locationsList as $loc_itm){
                                $id = $loc_itm['id'];
                                $adrs = unserialize($loc_itm['detail']);
                            
                               ?>
                               <li id="loc-adress-itm-<?php echo ($id) ?>" class="fds-list-item fds-edit-user-loc"  data-id="<?php echo ($id) ?>" data-nid="<?php echo ($user_or_obj_id) ?>">
                               <input type="radio" name="address" id="<?php echo ($id) ?>" value="<?php echo ($adrs['label']) ?>">
                               <label class="fds-radio-style"><?php echo ($adrs['address']) ?></label>
                              </li>
                               <?php 
                            
                            }
                                echo '</ul></div>';
                          }

                          ?>
                              <div class="fds-popup-btn-wrap">
                              <?php
                                    if(is_single()){ 
                                        $popupBTnClass = 'update-popup-res-location';
                                     }
                                    else{ 
                                        $popupBTnClass = 'update-popup-location';
                                      }
                                    ?>
                                    <div class="fds-btn fds-medium-btn">
                                      <a href="#" class="<?=$popupBTnClass;?> fds-has-bg" data-value="deliver"><?php esc_html_e('delivery', 'wp-foodsearch') ?></a></div>
                                    <span> <?php esc_html_e('OR', 'wp-foodsearch') ?> </span>
                                    <div class="fds-btn fds-medium-btn"><a href="#"  class="<?=$popupBTnClass;?> fds-has-bg"  data-value="pickup"><?php esc_html_e('take away', 'wp-foodsearch') ?></a></div>   
 
                                    
                                    
                                </div></div>
                            
                          </div>
                          
                        </div>
                    </div>
                </div>
            </div>
        </div>    
        <?php
        if (!isset($_SESSION['customer_location']) && $foodsearch_plugin_settings['location_settings']['disply_res'] =='on') {

          ?>    
        <script>
          jQuery('document').ready(function(){
          //  foodsearch__map_render();
          "use strict";
            foodsearch_modal_popup_open('fds-location-mpopup');
            setTimeout(function () {
             jQuery('.fds-get-current-location').trigger('click');
        }, 1000);
            
          })
          </script>
        <?php
        }
  }, 50);

       ?>