<?php
use FoodSearch\Common_Functions;
use FoodSearch\user_orders as FoodSearch_Orders;
function invoicePrint($id)
{

        global $table_prefix, $wpdb, $foodsearch_user_orders_obj, $foodsearch_plugin_settings;
        
        if (isset($foodsearch_plugin_settings['payment_settings']['wc_cart_active']) && $foodsearch_plugin_settings['payment_settings']['wc_cart_active'] == 'on' && class_exists('WooCommerce')) {
        
            $customerOrder = new customers_Orders;
            global $foodsearch_user_orders_obj, $foodsearch_plugin_settings;
            $order = $customerOrder->get_order($id);
    
            $order = $order['order'];
            $order_id = $order['id'];
            $first_name = $order['billing']['first_name'];
            $last_name = $order['billing']['last_name'];
            $billing_email = $order['billing']['email'];
            $billing_phone = $order['billing']['phone'];
            $billing_address = $order['billing']['address_1'] . ' ' . $order['billing']['city'] . ' ' . $order['billing']['state'] . ' ' . $order['billing']['postcode'] . ' ' . $order['billing']['country'];
            $billing_address_lat = '';
            $billing_address_lng = '';
    
            $customer_name = '';
            if ($first_name != '') {
                $customer_name .= $first_name;
                if ($last_name != '') {
                    $customer_name .= ' ' . $last_name;
                }
            }
    
            $order_status = $order['status'];
    
    
            $create_date = $order['date_created'];
            $create_date_formate = date_i18n(get_option('date_format'), strtotime($create_date));
            $create_time_formate = date_i18n(get_option('time_format'), strtotime($create_date));
    
            ob_start(); ?>
        <div class="pdf-wrapper" style="width:336px;margin: 0 auto;">
            <div class="pdf-receipt-stars">******************************</div>
            <div class="pdf-receipt-header-content">
                <div class="pdf-receipt-head-title"><?php printf(esc_html__('Receipt', 'wp-foodsearch')); ?></div>
                <div class="pdf-receipt-head-number"><?php printf(esc_html__('order id: #%s', 'wp-foodsearch'), $order_id); ?></div>
            </div>
            <div class="pdf-receipt-stars">******************************</div>
    
            <div class="pdf-receipt-dt-section">
                <div class="pdf-receipt-dt-title"><?php echo ($customer_name) ?></div>
                <div class="pdf-receipt-dt-date"><div><?php echo ($create_date_formate) ?></div> 
                <div class="pdf-receipt-dt-time"><?php echo ($create_time_formate) ?></div></div>
            </div>
    <?php
                    $order_items = $order['line_items'];
            if (!empty($order_items)) {

                $order_subtotal = $order['subtotal'];
                $order_net_total = $order['total'];
                $items_counter = 1;
                $total_order_items = count($order_items);
                $menu_itms_open = false;
                foreach ($order_items as $order_item) {
                    $order_item_id = $order_item['id'];
                    $order_item_name = $order_item['name'];

                    $mtotal = 0;
                    if (is_array($order_item['meta_data']) && count($order_item['meta_data']) >= 1) {
                        $mtotal = 0;
                        foreach ($order_item['meta_data'] as $meta) {
                            preg_match_all('/[0-9]+/', $meta->value, $matches);
                            $value = $matches[0][1];
                            $mtotal += $value;
                        }
                    }
                    $item_menu_id = $order_item['id'];
                    $item_qty = $order_item['quantity'];
                    $item_subtotal = $order_item['subtotal'];
                    $menu_itm_label = $order_item_name;

                    $item_alltotal = $item_subtotal;

                    $rand_num = rand(1000000, 9999999);
                    ?>
    
            <div class="pdf-receipt-list">
                <div class="pdf-receipt-list-text"><?php echo ($item_qty) ?> x <?php echo ($menu_itm_label) ?></div>
                <div class="pdf-receipt-list-price"><?php echo (Common_Functions::get_formatted_price($item_alltotal)) ?></div>
            </div>
            <?php
                    if (is_array($order_item['meta_data']) && count($order_item['meta_data']) >= 1) {
                        ?>
     <div class="pdf-receipt-list-sub">
    <?php
                                    foreach ($order_item['meta_data'] as $meta) {
                                        //  echo $mp = preg_replace('/[^0-9]/', '', $meta->value);
                                        preg_match_all('/[0-9]+/', $meta->value, $matches);
                                        ?>
                            <div class="pdf-receipt-list">
                        <div class="pdf-receipt-list-text"><?php echo ($item_qty) ?> x <?php echo ($meta->key) ?></div>
                        <div class="pdf-receipt-list-price"><?php echo Common_Functions::get_formatted_price($matches[0][1] * $item_qty) ?></div>
                    </div>                        
                        <?php
                                    }
                                    ?>
                        </div>
                        <?php
                    }
                }
                ?>
            <div class="pdf-receipt-seprater"><div></div><div></div></div>
    
            <div class="pdf-receipt-list uppercase-text">
                <div class="pdf-receipt-list-text"><?php esc_html_e('Subtotal:', 'wp-foodsearch'); ?></div>
                <div class="pdf-receipt-list-price"><?php echo (Common_Functions::get_formatted_price($order_subtotal)) ?></div>
            </div>
            <?php
              $delivery_fee = isset($order['fee_lines']) ? $order['fee_lines'][0]['total'] : '';
            if ($delivery_fee > 0) {
                ?>
                    <div class="pdf-receipt-list uppercase-text">
                <div class="pdf-receipt-list-text"><?php esc_html_e('Delivery Fee:', 'wp-foodsearch'); ?></div>
                <div class="pdf-receipt-list-price"><?php echo (Common_Functions::get_formatted_price($delivery_fee)) ?></div>
            </div>               
                    <?php
            }

            if (is_array($order['tax_lines']) && count($order['tax_lines']) > 0) {
                $vat_amount = $order['tax_lines'][0]['total'];
                ?>
                <div class="pdf-receipt-list uppercase-text">
                <div class="pdf-receipt-list-text"><?php esc_html_e('vat:', 'wp-foodsearch'); ?></div>
                <div class="pdf-receipt-list-price"><?php echo (Common_Functions::get_formatted_price($vat_amount)) ?></div>
            </div>
            <div class="pdf-receipt-margin"></div>
            <div class="pdf-receipt-seprater"><div></div></div>
            <?php } ?>
           
    
            <div class="pdf-receipt-list uppercase-text">
                <div class="pdf-receipt-list-text"><?php esc_html_e('Total Amount:', 'wp-foodsearch'); ?></div>
                <div class="pdf-receipt-list-price"><?php echo (Common_Functions::get_formatted_price($order_net_total)) ?></div>
            </div>
            <div class="pdf-receipt-margin"></div>
            <div class="pdf-receipt-seprater"><div></div></div>
    
            <div class="pdf-receipt-thanks">
                <div>********</div>
                <div class="pdf-receipt-thanks-text">Thank You</div>
                <div>********</div>
            </div>
    
        </div><div><div class="pdf-receipt-barcode"><barcode code="<?= $order_id; ?>" type="I25" class="barcode" /></div></div>
        <div class="pdf-receipt-last-seprater"></div>
                    <?php
            }
        } 
        else {
        $order_id = $id;

        $table_name = $table_prefix . 'fds_orders';
        $order_result = $wpdb->get_row("SELECT * FROM $table_name WHERE order_id=$order_id", 'ARRAY_A');

        $order_meta = FoodSearch_Orders::get_order_meta($order_id);
        $first_name = FoodSearch_Orders::order_meta_value($order_meta, 'billing_first_name');
        $last_name = FoodSearch_Orders::order_meta_value($order_meta, 'billing_last_name');
        $billing_email = FoodSearch_Orders::order_meta_value($order_meta, 'billing_email');
        $billing_phone = FoodSearch_Orders::order_meta_value($order_meta, 'billing_phone');
        $billing_address = FoodSearch_Orders::order_meta_value($order_meta, 'billing_address');
        $billing_address_lat = FoodSearch_Orders::order_meta_value($order_meta, 'address_lat');
        $billing_address_lng = FoodSearch_Orders::order_meta_value($order_meta, 'address_lng');

        $customer_name = '';
        if ($first_name != '') {
            $customer_name .= $first_name;
            if ($last_name != '') {
                $customer_name .= ' ' . $last_name;
            }
        }

        $order_status = $order_result['status'];

        $status_list = FoodSearch_Orders::get_order_statuses();

        $order_status_label = $foodsearch_user_orders_obj->get_order_status_tclr($order_status);

        $create_date = $order_result['date_created'];
        $create_date_formate = date_i18n(get_option('date_format'), strtotime($create_date));
        $create_time_formate = date_i18n(get_option('time_format'), strtotime($create_date));
        ob_start();
        ?>
         <div class="pdf-wrapper" style="width:336px;margin: 0 auto;">
    <div class="pdf-receipt-stars">******************************</div>
    <div class="pdf-receipt-header-content">
        <div class="pdf-receipt-head-title"><?php printf(esc_html__('Receipt', 'wp-foodsearch')); ?></div>
        <div class="pdf-receipt-head-number"><?php printf(esc_html__('order id: #%s', 'wp-foodsearch'), $order_id); ?></div>
    </div>
    <div class="pdf-receipt-stars">******************************</div>

    <div class="pdf-receipt-dt-section">
        <div class="pdf-receipt-dt-title"><?php echo ($customer_name) ?></div>
        <div class="pdf-receipt-dt-date"><div><?php echo ($create_date_formate) ?></div> 
        <div class="pdf-receipt-dt-time"><?php echo ($create_time_formate) ?></div></div>
    </div> <!---->
        <?php
        $order_items = $foodsearch_user_orders_obj->get_order_items($order_id, 'menu_items');
        if (!empty($order_items)) {

            $order_subtotal = $order_result['total_sales'];
            $order_net_total = $order_result['net_total'];
            $items_counter = 1;
            $total_order_items = count($order_items);
            $menu_itms_open = false;
            foreach ($order_items as $order_item) {
                $order_item_id = $order_item['order_item_id'];
                $order_item_name = $order_item['order_item_name'];
                $order_item_type = $order_item['order_item_type'];
                if ($order_item_type == 'menu_item' || $order_item_type == 'menu_item_extra') {
                    $order_item_meta = $foodsearch_user_orders_obj->get_order_item_meta($order_item_id);
                    $item_menu_id = $foodsearch_user_orders_obj->order_item_meta_value($order_item_meta, 'menu_id');
                    $item_qty = $foodsearch_user_orders_obj->order_item_meta_value($order_item_meta, 'qty');
                    $item_subtotal = $foodsearch_user_orders_obj->order_item_meta_value($order_item_meta, 'subtotal');

                    $table_name = $table_prefix . 'menu_items';
                    $menu_itmsql = "SELECT * FROM $table_name WHERE id=$item_menu_id";
                    $menu_itm_obj = $wpdb->get_row($menu_itmsql);
                    $menu_itm_label = $menu_itm_obj->name;
                    $item_alltotal = $item_subtotal * $item_qty;

                    ?>
                      <?php
                      if ($order_item_type == 'menu_item_extra') {
                          ?>
  <div class="pdf-receipt-list-sub"> 
    <?php } ?>
                         <div class="pdf-receipt-list">
           <div class="pdf-receipt-list-text"><?php echo ($item_qty) ?> x <?php echo ($menu_itm_label) ?></div>
            <div class="pdf-receipt-list-price"><?php echo (Common_Functions::get_formatted_price($item_alltotal)) ?></div>
        </div>
                     
                </div>
                <?php
                }
            }
        }
        ?>
        <div class="pdf-receipt-seprater"><div></div><div></div></div>
    
    <div class="pdf-receipt-list uppercase-text">
        <div class="pdf-receipt-list-text"><?php esc_html_e('Subtotal:', 'wp-foodsearch'); ?></div>
        <div class="pdf-receipt-list-price"><?php echo (Common_Functions::get_formatted_price($order_subtotal)) ?></div>
    </div>
    <?php
             $delivery_fee = isset($order_result['shipping_total']) ? $order_result['shipping_total'] : '';
             if ($delivery_fee > 0) {
                ?>
            <div class="pdf-receipt-list uppercase-text">
        <div class="pdf-receipt-list-text"><?php esc_html_e('Delivery Fee:', 'wp-foodsearch'); ?></div>
        <div class="pdf-receipt-list-price"><?php echo (Common_Functions::get_formatted_price($delivery_fee)) ?></div>
    </div>               
            <?php
            }

            $order_vat_switch = isset($foodsearch_plugin_settings['payment_settings']['order_vat_tax']) ? $foodsearch_plugin_settings['payment_settings']['order_vat_tax'] : '';
                            
            $order_tax_amount = isset($order_result['tax_total']) ? $order_result['tax_total'] : '';
            
            $vat_amount = 0;
            if ($order_tax_amount > 0) {
                $vat_amount = $order_tax_amount;
            }
            if ($vat_amount > 0 || $order_vat_switch == 'on') {
                ?>
        <div class="pdf-receipt-list uppercase-text">
        <div class="pdf-receipt-list-text"><?php esc_html_e('vat:', 'wp-foodsearch'); ?></div>
        <div class="pdf-receipt-list-price"><?php echo (Common_Functions::get_formatted_price($vat_amount)) ?></div>
    </div>
    <div class="pdf-receipt-margin"></div>
    <div class="pdf-receipt-seprater"><div></div></div>
    <?php } ?>
   

    <div class="pdf-receipt-list uppercase-text">
        <div class="pdf-receipt-list-text"><?php esc_html_e('Total Amount:', 'wp-foodsearch'); ?></div>
        <div class="pdf-receipt-list-price"><?php echo (Common_Functions::get_formatted_price($order_net_total)) ?></div>
    </div>
    <div class="pdf-receipt-margin"></div>
    <div class="pdf-receipt-seprater"><div></div></div>

    <div class="pdf-receipt-thanks">
        <div>********</div>
        <div class="pdf-receipt-thanks-text">Thank You</div>
        <div>********</div>
    </div>

</div><div><div class="pdf-receipt-barcode"><barcode code="<?= $order_id; ?>" type="I25" class="barcode" /></div></div>
<div class="pdf-receipt-last-seprater"></div>
        <?php
    }



    //echo plugin_dir_path(dirname(dirname(dirname(__FILE__)))) . 'assets/scss/build/css/foodsearch-invoice-mpdf-style.css';
$stylesheet = file_get_contents(plugin_dir_path(dirname(dirname(dirname(__FILE__)))) . 'assets/scss/build/css/foodsearch-invoice-mpdf-style.css');
$defaultConfig = (new \Mpdf\Config\ConfigVariables())->getDefaults();
$fontDirs = $defaultConfig['fontDir'];
$defaultFontConfig = (new \Mpdf\Config\FontVariables())->getDefaults();
$fontData = $defaultFontConfig['fontdata'];
$mpdf = new \Mpdf\Mpdf([
    'mode' => '+aCJK',
    // 'mode' => 'utf-8',
    "autoScriptToLang" => true,
    "autoLangToFont" => true,
    "autoBreakPage" => false,
    'format' => [83, 160],
    'margin_left' => 0,
    'margin_right' => 0,
    'margin_top' => 0,
    'margin_bottom' => 0,
    'border' => '2px solid #000',
    'mirrorMargins' => true,
    'tempDir' => __DIR__ . '/upload',
    'fontDir' => array_merge($fontDirs, [
        __DIR__ . '/fonts'
    ]),
    'fontdata' => $fontData + [
        "roboto" => [
            'R' => "Roboto.ttf",
            'B' => "Roboto-Bold.ttf",
        ],
        "jobsearch" => [
            'R' => "icomoon.ttf",
        ],
    ],
    'default_font' => 'poppins'
]);
$mpdf->allow_charset_conversion = true;
$pdf_html = ob_get_clean();
    
$mpdf->WriteHTML($stylesheet, \Mpdf\HTMLParserMode::HEADER_CSS);

$mpdf->WriteHTML($pdf_html, \Mpdf\HTMLParserMode::HTML_BODY);

echo $mpdf->Output('orders.pdf', 'I');
exit();
}