<?php
/*
Plugin Name: WP FoodSearch
Plugin URI: https://codecanyon.net/user/eyecix/portfolio
Description: WP FoodSearch is an Online Food Ordering system for Single/Multiple Restaurants. It is a standalone WordPress plugin which allows you to easily add Food Ordering System to your WordPress Website. Using WP FoodSearch you can easily receive both PickUp/Takeaway and Delivery orders. WP FoodSearch has a user friendly frontend and backend interface which will allow you to easily manage the orders and also comes with pre-built user dashboard to manage their profile and orders. The plugin automatically adds the required pages to your site when you activate the plugin. The plugin outputs the food items on your page using shortcodes and Gutenberg Blocks.
Tags: Food Delivery, food ordering, online ordering, restaurant menu, Restaurant ordering
Author: 20script
Version: 1.1.3
Author URI: https://www.20script.ir
Text Domain: wp-foodsearch
Requires at least: 5.0
Requires PHP: 7.2
*/
if (!defined('WPINC')) {
    die;
}

/**
 * The code that runs during plugin activation.
 * This action is documented in helper/classes/class-activator.php
 */
function foodsearch_activate_plugin()
{
    require_once plugin_dir_path(__FILE__) . 'helper/classes/class-activator.php';
    $acticate = new FoodSearch_Plugin_Activator();
}

/**
 * The code that runs during plugin deactivation.
 * This action is documented in helper/classes/class-deactivator.php
 */
function foodsearch_deactivate_plugin()
{
    require_once plugin_dir_path(__FILE__) . 'helper/classes/class-deactivator.php';
    FoodSearch_Plugin_Deactivator::deactivate();
}

register_activation_hook(__FILE__, 'foodsearch_activate_plugin');
register_deactivation_hook(__FILE__, 'foodsearch_deactivate_plugin');

/**
 * The core plugin class that is used to define internationalization,
 * admin-specific hooks, and public-facing site hooks.
 */
require plugin_dir_path(__FILE__) . 'helper/classes/class-fds-plugin.php';
require plugin_dir_path(__FILE__) . 'includes/wp-foodsearch-blocks/class-fds-blocks.php';
/**
 * Retrieve the root url of the plugin.
 *
 */
function foodsearch_plugin_get_url($path = '')
{
    return plugin_dir_url(__FILE__) . $path;
}

/**
 * Retrieve the root path of the plugin.
 *
 */
function foodsearch_plugin_get_path($path = '')
{
    return plugin_dir_path(__FILE__) . $path;
}


/**
 * Begins execution of the plugin.
 *
 * Since everything within the plugin is registered via hooks,
 * then kicking off the plugin from this point in the file does
 * not affect the page life cycle.
 *
 * @since    1.0.0
 */
function foodsearch_run_plugin() {
  
    new FoodSearch_Plugin();
}

foodsearch_run_plugin();

function foodsearch_plugin_shortcode($atts) {
    require( plugin_dir_path(__FILE__) . "dashboard/menu_builder.php" );
}
add_shortcode('fds-plugin-shortcode', 'foodsearch_plugin_shortcode');